更新日志
********


Python 3.11.15 final
====================

*Release date: 2026-03-03*


安全性
------

* gh-144125: "BytesGenerator" 现在将拒绝序列化（写入）不安全折叠或分隔
  的标头；参见 "verify_generated_headers"。（由 Bas Bloemsaat 和 Petr
  Viktorin 在 gh-121650 中贡献。）

* gh-143935: 修复了使用现代邮件策略扁平化电子邮件消息时注释折叠中的程
  序缺陷。由很长的不可折叠字符序列组成的注释可能会触发强制换行，而该换
  行会省略续行所需的前导空格，导致注释的剩余部分被解释为新的标头字段。
  这使得通过精心构造的输入实现标头注入成为可能。

* gh-143925: 拒绝 "data:" URL 媒体类型中的控制字符。

* gh-143919: 拒绝 "http.cookies.Morsel" 字段和值中的控制字符。

* gh-143916: 拒绝 wsgiref.headers.Headers 字段、值和参数之内的 C0 控制
  字符。

* gh-142145: Remove quadratic behavior in "xml.minidom" node ID cache
  clearing.  In order to do this without breaking existing users, we
  also add the *ownerDocument* attribute to "xml.dom.minidom" elements
  and attributes created by directly instantiating the "Element" or
  "Attr" class. Note that this way of creating nodes is not supported;
  creator functions like "xml.dom.Document.documentElement()" should
  be used instead.

* gh-137836: 在 "html.parser.HTMLParser" 中增加对“纯文本”元素, RAWTEXT
  元素 "xmp", "iframe", "noembed" 和 "noframes"，以及可选的 RAWTEXT 元
  素 "noscript" 的支持。

* gh-136063: "email.message": 确保旧式 HTTP 形参解析为线性复杂度。 由
  Bénédikt Tran 编写补丁。

* gh-136065: 修复 "os.path.expandvars()" 中的二次幂复杂度问题。

* gh-119451: 修正 "http.client" 模块中一个潜在的内存拒绝服务问题。 当
  连接到一个恶意服务器时，它可能导致分配任意大小的内存。 这会造成多种
  问题包括 "MemoryError"、消耗交换空间、内存不足（OOM）杀死进程或容器
  ，甚至系统崩溃。

* gh-119452: 修正 "http.server" 模块中一个潜在的内存拒绝服务问题。 当
  一个恶意用户连接到 Windows 上的 CGI 服务器时，它可能导致分配任意大小
  的内存。 这会造成多种问题包括 "MemoryError"、消耗交换空间、内存不足
  （OOM）杀死进程或容器，甚至系统崩溃。

* gh-119342: 修正a potential memory denial of service in the
  "plistlib" 模块中一个潜在的内存拒绝服务问题。 当读取从不受信任的源接
  收的 Plist 文件时，它可能导致分配任意大小的内存。 这会造成多种问题包
  括 "MemoryError"、消耗交换空间、内存不足（OOM）杀死进程或容器，甚至
  系统崩溃。


库
--

* gh-144833: 修复在 "ssl" 中当 "newPySSLSocket()" 的 "SSL_new()" 返回
  NULL 时的一个释放后再使用的问题。 此错误是在对象已被释放后通过一个悬
  空指针来报告的。

* gh-144363: 将捆绑的 libexpat 更新至 2.7.4

* gh-90949: 为 xmlparser 对象添加
  "SetAllocTrackerActivationThreshold()" 和
  "SetAllocTrackerMaximumAmplification()" 以防止在一个 Expat 解析器内
  部使用不适当大小的动态内存。 由 Bénédikt Tran 编写补丁。


核心与内置函数
--------------

* gh-120384: Fix an array out of bounds crash in "list_ass_subscript",
  which could be invoked via some specificly tailored input: including
  concurrent modification of a list object, where one thread assigns a
  slice and another clears it.

* gh-120298: Fix use-after free in "list_richcompare_impl" which can
  be invoked via some specificly tailored evil input.


Python 3.11.14 final
====================

*Release date: 2025-10-09*


安全性
------

* gh-139700: 检测 zip64 中央目录记录末尾的一致性。 在没有字节数据被附
  加到 ZIP 文件时支持使用 "zip64 可扩展数据" 的记录。

* gh-139400: "xml.parsers.expat": 确保父级 Expat 解析器当其不再被
  "ExternalEntityParserCreate()" 所创建的子解析器所引用时只会被作为垃
  圾回收一次。 由 Sebastian Pipping 编写补丁。

* gh-135661: 根据HTML5标准修复 "html.parser.HTMLParser" 中开始和结束标
  签的解析。

  * 不再接受在 "</" 和标签名之间的空格。例如，"</ script>" 不会结束脚
    本部分。

  * 垂直制表符("\v")和非ASCII空格不再被识别为空白符。空白符只有
    "\t\n\r\f" 和空格。

  * 空字符(U+0000)不再结束标签名。

  * 现在会忽略结束标签中标签名后的属性和斜杠，而不再在带引号的属性值中
    的第一个 ">" 处终止解析。例如："</script/foo=">"/>"。

  * 现在在开始和结束标签中忽略最后一个属性和闭合 ">" 之间的多个斜杠和
    空白符。例如，"<a foo=bar/ //>"。

  * 属性名与属性值之间多个连续的 "=" 符号将不再被合并处理。例如："<a
    foo==bar>" 会生成属性名为 "foo"、属性值为 "=bar" 的标签。

* gh-135661：根据 HTML5 标准修复了 "html.parser.HTMLParser" 中的 CDATA
  段解析问题："] ]>" 和 "]] >" 不再终止 CDATA 段。新增私有方法
  "_set_support_cdata()"，可用于指定如何解析 "<[CDATA[" —— 在外部内容
  （SVG 或 MathML）中作为 CDATA 段解析，或在 HTML 命名空间中作为伪注释
  解析。

* gh-102555: 根据HTML5标准修复 "html.parser.HTMLParser" 中的注释解析。
  "--!>" 现在结束注释。"-- >" 不再结束注释。支持异常结束的空注释
  "<-->" 和 "<--->"。

* gh-135462: 修复 "html.parser.HTMLParser" 在处理特制输入时的二次方复
  杂度问题。现根据HTML5规范处理文件结束错误——自动闭合注释和声明，忽略
  标签。

* gh-118350：修复 "html.parser.HTMLParser" 对可转义原始文本模式（
  "textarea" 和 "title" 元素）的支持问题。

* gh-86155: "html.parser.HTMLParser.close()" 现在在 "<script>" 标签未
  关闭时不再丢失数据。由 Waylan Limberg 提供补丁。


库
--

* gh-139312: 将捆绑的 libexpat 升级至 2.7.3

* gh-138998: 将捆绑的 libexpat 更新至 2.7.2

* gh-130577: "tarfile" 现在可验证归档以确保成员偏移量为非负值。 （由
  Alexander Enrique Urieles Nieto 在 gh-130577 中贡献。）

* gh-135374: Update the bundled copy of setuptools to 79.0.1.


Python 3.11.13 final
====================

*发布日期: 2025-06-03*


安全性
------

* gh-135034: 修复了多个问题，这些问题允许使用精心构造的符号链接和硬链
  接绕过 "tarfile" 提取过滤器（"filter="data"" 和 "filter="tar""）。

  Addresses CVE 2024-12718, CVE 2025-4138, CVE 2025-4330, and CVE
  2025-4517.

* gh-133767: 修复在非"严格"错误处理程序中使用"unicode-escape"解码器时
  的释放后使用问题。

* gh-128840: 在 "ipaddress" 中早期短路处理长IPv6地址，以防止过多的内存
  消耗和轻微的拒绝服务。


库
--

* gh-128840: 修复了解析包含嵌入式IPv4地址的长IPv6地址的问题。

* gh-134062: "ipaddress": 修复 "__hash__()" 中 "IPv4Network" 和
  "IPv6Network" 对象的冲突。

* gh-123409: 根据 **RFC 3596, §2.5** 修复
  "ipaddress.IPv6Address.reverse_pointer" 的输出。由 Bénédikt Tran 提
  供补丁。

* bpo-43633: 改进 "ipaddress" 中 IPv4 映射的 IPv6 地址 (**RFC 4291**
  第 2.2, 2.5.5.2 节) 的文本表示。由 Oleksandr Pavliuk 提交补丁。


Python 3.11.12 final
====================

*发布日期: 2025-04-08*


安全性
------

* gh-131809: 将捆绑的 libexpat 更新至 2.7.1

* gh-131261: 更新至 libexpat 2.7.0

* gh-105704: 当使用 "urllib.parse.urlsplit()" 和
  "urllib.parse.urlparse()" 时主机解析将不会拒绝包含方括号 ("[" 和
  "]") 的主机名。 根据 >>`<<RFC 3986 第 3.2.2 节 <https://www.rfc-
  editor.org/rfc/rfc3986#section-3.2.2>`__方括号仅适用于 IPv6 和
  IPvFuture 主机。

* gh-121284: 修复了在使用现代电子邮件策略扁平化电子邮件消息时，rfc2047
  编码词的折叠错误。以前，当一个编码词对于一行来说太长时，它会被解码、
  跨行分割并重新编码。但是原始文本中的逗号和其他特殊字符可能会被保留未
  编码和未引用。如果生成的渲染电子邮件被传输或重新解析，理论上可以利用
  精心构造的编码词来欺骗标题行。

* gh-80222: 修复在使用现代电子邮件策略扁平化电子邮件消息时引用字符串折
  叠的错误。之前，当一个引用字符串被折叠以至于跨越多行时，周围的引号和
  内部转义将被省略。理论上，如果生成的渲染电子邮件被传输或重新解析，这
  可能会被用来使用精心构造的引用字符串欺骗标题行。

* gh-119511: 修复 "imaplib" 模块中潜在的拒绝服务问题。当连接到恶意服务
  器时，可能导致分配任意数量的内存。在许多系统上，这是无害的，因为未使
  用的虚拟内存只是一个映射，但如果这达到了虚拟地址大小限制，可能会导致
  "MemoryError" 或其他进程崩溃。在不寻常的系统或构建中，所有分配的内存
  都被触及并由实际 RAM 或存储支持，这可能会消耗资源，直到类似崩溃。


库
--

* gh-127257: 在 "ssl" 中，OpenSSL 报告使用 "ERR_LIB_SYS" 的系统调用失
  败现在将作为 "OSError" 被引发。


文档
----

* gh-121277: CPython文档的作者现在可以使用 "next" 作为
  "versionchanged"、"versionadded"、>>``<<deprecated``指令的版本。


C API
-----

* gh-106883: Disable GC during the _PyThread_CurrentFrames() and
  _PyThread_CurrentExceptions() calls to avoid the interpreter to
  deadlock.


Python 3.11.11 final
====================

*发布日期: 2024-12-03*


工具/示例
---------

* gh-123418: 更新 GitHub CI 工作流以使用 OpenSSL 3.0.15 和
  multissltests 以使用 3.0.15、3.1.7 和 3.2.3。


测试
----

* gh-125041: 在s390x架构上重新启用对 "zlib" 的跳过测试：仅跳过压缩字节
  的检查，这些在zlib的软件实现和硬件加速实现之间可能不同。


安全性
------

* gh-126623: 将 libexpat 升级到 2.6.4 版本

* gh-122792: 修改了IPv4映射的 "ipaddress.IPv6Address"，使其一致使用映
  射的IPv4地址值来决定属性。行为被修复的属性包括 "is_multicast"、
  "is_reserved"、"is_link_local"、"is_global" 和 "is_unspecified"。


库
--

* gh-124651: 在 "venv" 激活脚本中正确引用模板字符串。


Python 3.11.10 final
====================

*Release date: 2024-09-07*


Windows
-------

* gh-123418: 更新 Windows 构建以使用 OpenSSL 3.0.15。

* gh-119690: Fixes data type confusion in audit event raised by
  "_winapi.CreateNamedPipe".


安全性
------

* gh-123678: 将libexpat升级到2.6.3版本

* gh-121957: Fixed missing audit events around interactive use of
  Python, now also properly firing for "python -i", as well as for
  "python -m asyncio". The event in question is "cpython.run_stdin".

* gh-122133: 在 "AF_UNIX" 不可用的平台（如Windows）上，为
  "socket.socketpair()" 后备方案验证套接字连接。

  由Gregory P. Smith <greg@krypto.org> 和 Seth Larson
  <seth@python.org>提供补丁。由Ellie <el@horse64.org>报告。

* gh-121285: 在 tarfile 头解析中移除对 "hdrcharset"、PAX 和 GNU 稀疏头
  的回溯。

* gh-118486: "os.mkdir()" on Windows now accepts *mode* of "0o700" to
  restrict the new directory to the current user. This fixes
  CVE-2024-4030 affecting "tempfile.mkdtemp()" in scenarios where the
  base temporary directory is more permissive than the default.

* gh-116741: 更新捆绑的 libexpat 到 2.6.2


库
--

* gh-123270: 对 "zipfile.Path" 中导致无限循环的畸形负载应用了更为精确
  的修复（gh-122905），而不会破坏使用合法字符的内容。

* gh-123067: 通过 "http.cookies" 修复解析带有反斜杠的 """ 引号包围的
  cookie 值时的二次复杂度问题。

* gh-122905: "zipfile.Path" 对象现在会对来自 zipfile 的名称进行清理。

* gh-121650: 现在，带有嵌入换行符的 "email" 标题在输出时会被引用。
  "generator" 现在会拒绝序列化（写入）不安全折叠或分隔的标题；参见
  "verify_generated_headers"。（由Bas Bloemsaat和Petr Viktorin在
  gh-121650 中贡献。）

* gh-119506: 修复了在刷新内部缓冲区期间再次调用
  "io.TextIOWrapper.write()" 方法时会破坏内部缓冲区的问题。

* gh-118643: 修复 "email" 模块在重新折叠长地址列表时的 AttributeError
  。同时修复地址列表中地址分隔符编码不正确的问题。

* gh-113171: 修复了以下属性判断中的各类误报（false positives）和漏报（
  false negatives）问题

  * "ipaddress.IPv4Address.is_private" (详见相关文档说明)

  * "ipaddress.IPv4Address.is_global"

  * "ipaddress.IPv6Address.is_private"

  * "ipaddress.IPv6Address.is_global"

  同样适用于相应的 "ipaddress.IPv4Network" 和 "ipaddress.IPv6Network"
  属性。

* gh-102988: "email.utils.getaddresses()" and
  "email.utils.parseaddr()" now return "('', '')" 2-tuples in more
  situations where invalid email addresses are encountered instead of
  potentially inaccurate values. Add optional *strict* parameter to
  these two functions: use "strict=False" to get the old behavior,
  accept malformed inputs. "getattr(email.utils,
  'supports_strict_parsing', False)" can be use to check if the
  *strict* paramater is available. Patch by Thomas Dwyer and Victor
  Stinner to improve the CVE-2023-27043 fix.

* gh-67693: 修复了 "urllib.parse.urlunparse()" 和
  "urllib.parse.urlunsplit()" 对于路径以多个斜杠开始且没有权限的 URI
  的处理。基于 Ashwin Ramaswami 的补丁。


核心与内置函数
--------------

* gh-112275: A deadlock involving "pystate.c"'s "HEAD_LOCK" in
  "posixmodule.c" at fork is now fixed. Patch by ChuBoning based on
  previous Python 3.12 fix by Victor Stinner.

* gh-109120: 添加了对不正确星号表达式的处理，例如 "f(3, *)"。补丁由
  Grigoryev Semyon提供。


Python 3.11.9 final
===================

*Release date: 2024-04-02*


安全性
------

* gh-115398: Allow controlling Expat >=2.6.0 reparse deferral
  (CVE-2023-52425) by adding five new methods:

  * "xml.etree.ElementTree.XMLParser.flush()"

  * "xml.etree.ElementTree.XMLPullParser.flush()"

  * "xml.parsers.expat.xmlparser.GetReparseDeferralEnabled()"

  * "xml.parsers.expat.xmlparser.SetReparseDeferralEnabled()"

  * "xml.sax.expatreader.ExpatParser.flush()"

* gh-115399: 将捆绑的 libexpat 更新到 2.6.0

* gh-115243: 修复在并发修改时 "collections.deque.index()" 可能崩溃的问
  题。

* gh-114572: "ssl.SSLContext.cert_store_stats()" 和
  "ssl.SSLContext.get_ca_certs()" 现在在 "ssl.SSLContext" 被多个线程共
  享时正确锁定对证书存储的访问。


核心与内置函数
--------------

* gh-116296: 修复 "object.__reduce__()" 内部错误处理中可能的内存泄漏。

* gh-116034: Fix location of the error on a failed assertion.

* gh-115823: 在由于无效字节序列引发 "SyntaxError" 异常时，正确计算解析
  器中的错误范围。由 Pablo Galindo 提供补丁。

* gh-112087: For an empty reverse iterator for list will be reduced to
  "reversed()". Patch by Donghee Na.

* gh-115011: 现在，对于具有 "__index__()" 方法的对象，无符号整数类型成
  员的设置器支持与 "int" 相同的有效值范围。

* gh-96497: 修复在理解中使用的赋值表达式中混淆的类变量的错误解析。


库
--

* gh-117310: 修复了在创建新的 "_ssl._SSLContext" 时，如果 CPython 被不
  合理地构建导致默认密码列表为空，或链接的 SSL 库报告其 C
  "SSL_CTX_set_cipher_list()" API 失败时，可能触发的早期及额外的
  "Py_DECREF" 崩溃问题。

* gh-117178: 修复了在 gh-114781 中引入的自引用模块的懒加载回归问题。

* gh-117084: 修复了 Windows 上 "zipfile" 提取包含反斜杠名称的目录条目
  时的问题。

* gh-117110: 修复了一个阻止 "typing.Any" 的子类用参数实例化的错误。由
  Chris Fu 提供补丁。

* gh-90872: 在Windows上，"subprocess.Popen.wait()" 不再用负超时调用
  "WaitForSingleObject()"：如果超时为负，则传递 "0" 毫秒。由Victor
  Stinner提供补丁。

* gh-116957: configparser: 在早期读取引发 DuplicateSectionError 或
  DuplicateOptionError 后，不再将 ConfigParser 值保留在无效状态（存储
  为列表而不是字符串）。

* gh-90095: 忽略 ".pdbrc" 中的空行和注释。

* gh-116764: 恢复在 "urllib.parse" 函数 "parse_qs()" 和 "parse_qsl()"
  中对 "None" 和其他假值的支持。此外，现在它们会对非零整数和非空序列抛
  出 TypeError。

* gh-116811: 在 "PathFinder.invalidate_caches" 中，委托给
  "MetadataPathFinder.invalidate_caches"。

* gh-116600: 修复全局 "Flag" 成员的 "repr()"。

* gh-116484: 修改自动生成的 "tkinter.Checkbutton" 控件名称，以避免在同
  一父容器内与自动生成的 "tkinter.ttk.Checkbutton" 控件名称发生冲突。

* gh-116401: 修复了 "os.fwalk()" 和 "shutil.rmtree()" 在打开命名管道时
  的阻塞问题。

* gh-116143: 修复 pydoc "_start_server" 中的竞争条件，消除
  "_start_server" 返回一个 "serving" 但没有设置 "docserver" 的线程的窗
  口。

* gh-116325: "typing": 对前向引用为空字符串的情况，抛出 "SyntaxError"
  而非 "AttributeError"。

* gh-90535: 修复了在 "logging.TimedRotatingFileHandler" 中对于
  "when='MIDNIGHT'" 和 "when='Wx'" 时 *interval* 值 > 1 的支持。

* gh-115978: 在 WASI 上禁用 preadv()、readv()、pwritev() 和 writev()。

  在 WASI 0.2 的 wasmtime 下，这些函数未能通过 test_posix 测试
  (https://github.com/bytecodealliance/wasmtime/issues/7830)。

* gh-88352: 修复 "logging.TimedRotatingFileHandler" 处理程序中下一次滚
  动时间的计算。"computeRollover()" 现在总是返回一个大于指定时间的时间
  戳，并且在 DST 变更时也能正确工作。"doRollover()" 不再覆盖已经滚动过
  的文件，从而避免了在午夜或 DST 变更时重复运行导致的数据丢失。

* gh-87115: 在使用 "pdb" 运行脚本时，将 "__main__.__spec__" 设置为
  "None"。

* gh-76511: 修复 "email.Message.as_string()" 中的 UnicodeEncodeError，
  该错误发生在消息声称使用 ascii 字符集但实际上包含非 ascii 字符时。现
  在，非 ascii 字符会被替换为 U+FFFD 替换字符，类似于 "replace" 错误处
  理器的行为。

* gh-75988: 修复 "unittest.mock.create_autospec()" 以通过调用传递给包
  装对象来返回真实结果。

* gh-115881: 修复了当传递 "feature_version=(3, 8)" 时，"ast.parse()"
  会错误地将条件上下文管理器（如 "with (x() if y else z()): ..."）标记
  为无效语法的问题。这撤销了作为 gh-94949 一部分对语法所做的更改。

* gh-115886: 修复了 "multiprocessing.shared_memory.SharedMemory" 中嵌
  入空字符的名称被静默截断的问题。

* gh-115809: 改进了 "logging.TimedRotatingFileHandler" 中计算要删除哪
  些滚动日志文件的算法。现在对于没有 "namer" 和具有任意确定性 "namer"
  (不修改文件名中的日期时间部分) 的处理程序来说是可靠的。

* gh-74668: "urllib.parse" 函数 "parse_qs()" 和 "parse_qsl()" 现在支持
  包含原始和百分比编码非 ASCII 数据的字节参数。

* gh-67044: "csv.writer()" 现在总是引用或转义 "'\r'" 和 "'\n'"，不管
  *lineterminator* 的值如何。

* gh-115712: "csv.writer()" now quotes empty fields if delimiter is a
  space and skipinitialspace is true and raises exception if quoting
  is not possible.

* gh-115618: 修复 "property" 方法 "getter()"、"setter()" 和
  "deleter()" 中对 "None" 参数引用计数不当减少的问题。

* gh-115570: A "DeprecationWarning" is no longer omitted on access to
  the "__doc__" attributes of the deprecated "typing.io" and
  "typing.re" pseudo-modules.

* gh-112006: Fix "inspect.unwrap()" for types with the "__wrapper__"
  data descriptor.

* gh-101293: 在 "inspect.Signature.from_callable()" 中支持带有
  "__call__()" 方法的可调用对象，以及将 "__new__()" 和 "__init__()" 方
  法设置为类方法、静态方法、绑定方法、部分函数以及其他类型的方法和描述
  符的类型。

* gh-115392: 修复 "doctest" 中的一个错误，该错误会导致装饰函数的行号报
  告不正确。

* gh-114563: Fix several "format()" bugs when using the C
  implementation of "Decimal": * memory leak in some rare cases when
  using the "z" format option (coerce negative 0) * incorrect output
  when applying the "z" format option to type "F" (fixed-point with
  capital "NAN" / "INF") * incorrect output when applying the "#"
  format option (alternate form)

* gh-115197: "urllib.request" 在 macOS 和 Windows 上不再在检查系统代理
  绕过列表之前解析主机名。

* gh-115198: Fix support of Docutils >= 0.19 in "distutils".

* gh-115165: 现在在尝试为调用 "typing" 泛型别名（包括使用
  "typing.Annotated" 创建的泛型别名）返回的对象设置`__orig_class__` 属
  性时，大多数异常会被忽略。之前只有 "AttributeError" 被忽略。由Dave
  Shawley提供补丁。

* gh-115133: 修复与Expat 2.6.0兼容的 "XMLPullParser" 测试。

* gh-115059: "io.BufferedRandom.read1()" 现在会刷新底层写入缓冲区。

* gh-79382: 在递归 "glob()" 中，尾随的 "**" 不再允许匹配文件和不存在的
  路径。

* gh-114763: 保护使用 "importlib.util.LazyLoader" 加载的模块，防止在加
  载完成前多个线程尝试访问属性时出现竞争条件。

* gh-97959: 修复 "pydoc" 中类方法、绑定方法、方法及函数别名的渲染问题
  。类方法不再显示“builtins.type实例的方法”注释。现在为类和未绑定方法
  添加了相应的注释。方法和函数别名现在如果原始定义与当前不同，会引用到
  定义原始内容的模块或类。绑定方法现在列在静态方法部分。内置类的方法现
  在和Python类的方法一样得到支持。

* gh-112281: 允许为 "typing.Annotated" 创建 类型的联合，即使元数据不可
  哈希。

* gh-111775: 修复了 "importlib.resources.simple.ResourceHandle.open()"
  在文本模式下的问题，添加了遗漏的 "stream" 参数。

* gh-90095: 使 .pdbrc 和 -c 可以与任何有效的 pdb 命令一起工作。

* gh-107155: 修复了 "help(x)" 的错误输出，其中 "x" 是一个 "lambda" 函
  数，该函数有一个带有 ""return"" 键的 "__annotations__" 字典属性。

* gh-105866: 修复了 "_get_slots" 的 bug，该 bug 在定义带有 slots 和
  weakref_slot 的数据类时会导致错误。

* gh-60346: 修复 ArgumentParser 与 parse_known_args 不一致的问题。

* gh-100985: 更新 HTTPSConnection 以在使用代理时一致地包装 IPv6 地址。

* gh-100884: email: 修复在多行地址列表中结合 Unicode 编码时逗号的错误
  折叠问题。

* gh-95782: Fix "io.BufferedReader.tell()",
  "io.BufferedReader.seek()", "_pyio.BufferedReader.tell()",
  "io.BufferedRandom.tell()", "io.BufferedRandom.seek()" and
  "_pyio.BufferedRandom.tell()" being able to return negative offsets.

* gh-96310: 修复 "argparse" 中当互斥组中的所有选项被抑制时出现的回溯问
  题。

* gh-93205: 修复 "logging.handlers.TimedRotatingFileHandler" 中的一个
  错误，其中指向具有相同名称但不同扩展名的文件的多个旋转处理程序实例会
  冲突并且不会删除正确的文件。

* bpo-44865: 在 "argparse" 中添加对本地化函数的缺失调用。

* bpo-43952: Fix "multiprocessing.connection.Listener.accept()" to
  accept empty bytes as authkey. Not accepting empty bytes as key
  causes it to hang indefinitely.

* bpo-42125: linecache: 如果可用，从 "__spec__" 获取模块名称。这允许在
  使用自定义加载器时获取 "__main__" 模块的源代码。

* gh-66543: 使 "mimetypes.guess_type()" 能够正确解析仅包含主机名的URL
  、包含片段或查询的URL以及Windows上仅包含UNC共享点的文件名。基于
  Dong-hee Na 的补丁。

* bpo-33775: 在 argparse 中为本地化添加了 'default' 和 'version' 帮助
  文本。


文档
----

* gh-115399: Document CVE-2023-52425 of Expat <2.6.0 under "XML
  vulnerabilities".

* gh-115233: 修复 Logging Cookbook 中 "LoggerAdapter" 的一个例子。


测试
----

* gh-83434: 在regrtest中搜索引用泄漏（"-R``选项）时禁用JUnit XML输出（
  "--junit-xml=FILE``命令行选项）。由 Victor Stinner 提供补丁。

* gh-117187: 修复对 vanilla Expat <2.6.0 的XML测试。

* gh-115979: 更新 test_importlib，使其在 WASI SDK 21 下通过。

* gh-116307: Added import helper "isolated_modules" as "CleanImport"
  does not remove modules imported during the context.

* gh-115720: 泄漏测试（"-R", "--huntrleaks"）现在显示每次迭代中发现泄
  漏数量的摘要。

* gh-115122: 为 regrtest 测试运行器添加 "--bisect" 选项：使用
  "test.bisect_cmd" 运行失败的测试以识别失败的测试。由 Victor Stinner
  提供补丁。

* gh-115596: 修复 "test_os" 中的 "ProgramPriorityTests" 永久改变进程优
  先级的问题。

* gh-115198: Fix test_check_metadata_deprecate in distutils tests with
  a newer Docutils.


构建
----

* gh-116313: 使 WASI 构建在 wasmtime 18 下使用 WASI 0.2/preview2 原语
  工作。

* gh-115167: 使用 Visual Studio 2022 版本 17.8 构建时避免提供
  "vcruntime140_threads.dll"。


Windows
-------

* gh-116773: 修复``<_overlapped.Overlapped object at 0xXXX> still has
  pending operation at deallocation, the process may crash``的实例。

* gh-91227: 修复asyncio ProactorEventLoop实现，以便向未监听的地址发送
  数据报不会阻止接收更多数据报。

* gh-115554: 安装程序现在对于更新 适用于Windows的Python启动器 有更严格
  的规则。一般来说，大多数用户只安装了一个启动器，不会看到任何区别。当
  安装了多个启动器时，安装启动器的选项将被禁用，直到只剩下一个。降级启
  动器（从未允许）现在被更明显地阻止。

* gh-115543: 适用于Windows的Python启动器 现在可以检测从 Microsoft
  Store 安装的 Python 3.13，并且在设置 "PYLAUNCHER_ALLOW_INSTALL" 时默
  认安装 Python 3.12。

* gh-115009: 更新 Windows 安装程序以使用 SQLite 3.45.1。


IDLE
----

* gh-88516: 在 macOS 上，在编辑器窗口的标题栏中显示代理图标以匹配平台
  行为。


工具/示例
---------

* gh-113516: 在构建WASI时不要设置 "LDSHARED"。


C API
-----

* gh-117021: 修复非 Windows 64 位平台上 "PyLong_AsPid()" 中的整数溢出
  问题。


Python 3.11.8 final
===================

*Release date: 2024-02-06*


安全性
------

* gh-113659: 跳过名称以点开头或具有隐藏文件属性的 ".pth" 文件。


核心与内置函数
--------------

* gh-114887: 更改 "create_datagram_endpoint()" 中的套接字类型验证，以
  接受所有非流套接字。这修复了与原始套接字兼容性的回归问题。

* gh-114388: Fix a "RuntimeWarning" emitted when assign an integer-
  like value that is not an instance of "int" to an attribute that
  corresponds to a C struct member of type T_UINT and T_ULONG. Fix a
  double "RuntimeWarning" emitted when assign a negative integer value
  to an attribute that corresponds to a C struct member of type
  T_UINT.

* gh-89811: 在执行依赖于此值可用的字节码特殊化之前，检查有效的
  "tp_version_tag"。

* gh-113602: 修复了一个导致解析器尝试覆盖现有错误并在过程中崩溃的错误
  。由 Pablo Galindo 提供补丁

* gh-113566: Fix a 3.11-specific crash when the "repr" of a "Future"
  is requested after the module has already been garbage-collected.

* gh-106905: 使用每个 AST 解析器状态而非全局状态来跟踪 AST 解析器内的
  递归深度，以防止由于同时解析而导致的潜在竞争条件。

  该问题主要在3.11版本中由 "ast.parse()" 的多线程用户发现。在3.12版本
  中，对垃圾回收触发时机的更改防止了竞态条件的发生。

* gh-112716: 修复当 "__builtins__" 不是字典时，"import" 语句和内置类型
  的 >>``<<__reduce__()``方法中的SystemError。

* gh-105967: 解决Apple的macOS平台zlib库中的一个bug，其中
  "zlib.crc32()" 和 "binascii.crc32()" 在多GB输入上可能产生不正确的结
  果。包括在使用 "zipfile" 处理包含大数据的zip文件时。

* gh-94606: 修复当 "email.message.get_payload()" 读取含有 Unicode 代理
  字符且消息内容不适合 surrogateescape 编码的消息时的
  UnicodeEncodeError。由 Sidney Markowitz 提供补丁。


库
--

* gh-114965: 更新捆绑的pip到24.0版本。

* gh-114959: "tarfile" 在尝试在文件上提取目录时不再忽略错误。

* gh-109475: 修复 "argparse" 中对明确选项值"--"的支持（例如 "--
  option=--"）。

* gh-110190: 通过在 stgdict 中将 "MAX_STRUCT_SIZE" 设置为 32，修复
  Windows ARM64 平台上带数组的 ctypes 结构体。由 Diego Russo 提供补丁
  。

* gh-113280: 修复在 "ssl.SSLSocket" 创建过程中发生错误时，在罕见情况下
  出现的开放套接字泄漏问题。

* gh-77749: "email.policy.EmailPolicy.fold()" 现在如果 "utf8" 为 false
  ，总是编码头部的非 ASCII 字符。

* gh-114492: 使 "termios.tcgetattr()" 在Alpine Linux上的结果可重现。之
  前它可能会在某些字段留下随机垃圾。

* gh-75128: 在 "asyncio.BaseEventLoop.create_server()" 中忽略
  "OSError"，当IPv6可用但接口实际上不支持它时。

* gh-114257: 在 "ctypes.util.find_library()" 中忽略 "FileNotFound" 错
  误，在Linux上直接返回 "None"。

* gh-101438: 避免在ElementTree.iterparse中出现引用循环。由
  "ElementTree.iterparse" 返回的迭代器可能会持有一个文件描述符。如果返
  回的迭代器未被耗尽，引用循环会阻止文件描述符的及时清理。

* gh-104522: 运行子进程时引发的 "OSError" 现在仅在错误是由于尝试更改当
  前目录失败时，才会将 *filename* 属性设置为*cwd*。

* gh-109534: 修复了 "asyncio.selector_events.BaseSelectorEventLoop" 中
  SSL握手失败时的引用泄漏问题。由Jamie Phan提供补丁。

* gh-114077: 修复在 32 位平台上传递大于 2 GiB 的 *count* 时
  "socket.socket.sendfile()" 中可能出现的 "OverflowError"。

* gh-114014: 修复了 "fractions.Fraction" 中的一个 bug，该 bug 在使用
  "d" 作为小数部分的无效字符串时，会生成与其他无效字母/字符不同的错误
  。由 Jeremiah Gabriel Pascual 提供补丁。

* gh-113951: 修复了 "tkinter.Text" 和 "tkinter.Canvas" 类的
  "tag_unbind()" 方法在三参数情况下的行为。以前，
  "widget.tag_unbind(tag, sequence, funcid)" 会销毁 *sequence* 的当前
  绑定，使 *sequence* 变为未绑定状态，并删除 *funcid* 命令。现在它仅从
  *sequence* 的绑定中移除 *funcid*，保留其他命令，并删除 *funcid* 命令
  。只有当 *funcid* 是最后一个绑定的命令时，才会使 *sequence* 变为未绑
  定状态。

* gh-113877: 修复 64 位 Windows 上的 "tkinter" 方法 "winfo_pathname()"
  。

* gh-113781: 在 Python 结束期间发出警告时，静默不可引发的
  AttributeError。

* gh-113594: 修复 "email" 中当重新折叠包含 unknown-8bit 编码部分后跟非
  unknown-8bit 编码部分的行时引发的 "UnicodeEncodeError"。

* gh-113538: 在 "asyncio.StreamReaderProtocol.connection_made()" 中，
  有一个回调函数，如果包装“连接回调”的任务失败，则会记录错误。如果任务
  被取消，这个回调本身会失败。通过首先检查任务是否被取消来防止这种情况
  。如果是，关闭传输但不记录错误。

* gh-85567: 修复 "pickle" 和 "pickletools" 命令行界面中未关闭文件的资
  源警告。

* gh-101225: 增加由 "multiprocessing.manager" 和
  "multiprocessing.resource_sharer" 创建的
  "multiprocessing.connection.Listener" 对象的积压，以显著降低在创建到
  它们的 "multiprocessing.connection.Connection" 时遇到连接拒绝错误的
  风险。

* gh-113543: 确保 "webbrowser.MacOSXOSAScript" 发送 "webbrowser.open"
  审计事件。

* gh-113028: 当字符串的第二个引用出现在 "pickle" 的输入中，并且使用
  Python 实现时，我们保证只有一个副本被 pickle，并且在重新加载时共享一
  个对象。以前，在协议 0 中，当字符串包含某些字符（如换行符）时，会导
  致对象重复。

* gh-113421: 修复多进程日志记录器对于 "%(filename)s" 的问题。

* gh-113358: Fix rendering tracebacks for exceptions with a broken
  "__getattr__".

* gh-113214: 修复了在 SSL-over-SSL 场景中 asyncio SSL 协议中止时出现的
  "AttributeError"。

* gh-113246: 更新捆绑的 pip 到 23.3.2 版本。

* gh-113199: 使得 "http.client.HTTPResponse.read1" 和
  "http.client.HTTPResponse.readline" 在知道内容长度时读取所有数据后关
  闭 IO。由 Illia Volochii 提供补丁。

* gh-113188: Fix "shutil.copymode()" and "shutil.copystat()" on
  Windows. Previously they worked differenly if *dst* is a symbolic
  link: they modified the permission bits of *dst* itself rather than
  the file it points to if *follow_symlinks* is true or *src* is not a
  symbolic link, and did not modify the permission bits if
  *follow_symlinks* is false and *src* is a symbolic link.

* gh-61648: 检测 doctests 中属性的行号。

* gh-112559: "signal.signal()" 和 "signal.getsignal()" 不再对可调用的
  处理器调用 "repr"。"asyncio.run()" 和 "asyncio.Runner.run()" 不再对
  任务结果调用 "repr"。由 Yilei Yang 提供补丁。

* gh-110190: 通过在 stgdict 中将 "MAX_STRUCT_SIZE" 设置为 64，修复了
  PPC64LE 平台上带有数组的 ctypes 结构体。由 Diego Russo 提供补丁。

* gh-79429: Ignore FileNotFoundError when remove a temporary directory
  in the multiprocessing finalizer.

* gh-79325: 修复了 Windows 上 "tempfile.TemporaryDirectory()" 清理过程
  中的无限递归错误。

* gh-110190: 通过在stgdict中将 "MAX_STRUCT_SIZE" 设置为32，修复了Arm平
  台上带有数组的ctypes结构体问题。由Diego Russo提供补丁。

* gh-81194: 修复了 "socket.if_indextoname()" 在特定值（UINT_MAX）下的
  崩溃问题。修复了64位非Windows平台上 "socket.if_indextoname()" 的整数
  溢出问题。

* gh-75666: 修复了 "tkinter" 小部件的 "unbind()" 方法在两个参数下的行
  为。之前，"widget.unbind(sequence, funcid)" 会销毁 *sequence* 的当前
  绑定，使 *sequence* 无绑定，并删除 *funcid* 命令。现在它只从
  *sequence* 的绑定中移除 *funcid*，保留其他命令，并删除 *funcid* 命令
  。只有当 *funcid* 是最后一个绑定命令时，才会使 *sequence* 无绑定。

* gh-110345: 在 "tkinter._test()" 中显示 Tcl/Tk 补丁级别（而非版本）。

* gh-109858: 保护 "zipfile" 免受“引用覆盖”zip炸弹攻击。现在在尝试读取
  与其他条目或中央目录重叠的条目时会引发 BadZipFile。

* gh-38807: 修复了 "trace" 中的竞态条件。不再检查目录是否存在并创建它
  ，而是直接调用 "os.makedirs()" 并传递 "exist_ok=True" 关键字参数。

* gh-75705: 在 "mailbox.mbox" 和 "mailbox.MMDF" 中设置 unixfrom 信封。

* gh-105102: 允许 "ctypes.Union" 嵌套在 "ctypes.Structure" 中，当系统
  字节序与类的字节序相反时。

* gh-104282: 修复了由于对具有零长度属性的 BCJ 过滤器处理不当导致的
  "lzma._decode_filter_properties()" 中的空指针解引用。补丁由 Radislav
  Chugunov 提供。

* gh-102512: 当从外部线程（即 "_DummyThread"）调用 "os.fork()" 时，子
  进程中的线程类型更改为 "_MainThread"。还更改了其名称和守护状态，现在
  可以加入了。

* gh-91133: 修复了 "tempfile.TemporaryDirectory" 清理中的一个错误，现
  在在解决文件系统权限错误时不再解引用符号链接。

* bpo-43153: 在 Windows 上，"tempfile.TemporaryDirectory" 之前在目录清
  理过程中将 "PermissionError" 掩盖为 "NotADirectoryError"。现在如果错
  误未被忽略，它会正确地引发 "PermissionError"。由 Andrei Kulakov 和
  Ken Jin 提供补丁。

* bpo-35332: "shutil.rmtree()" 函数现在在 *ignore_errors* 为 "True" 时
  忽略调用 "os.close()" 时的错误，并且 "os.close()" 在出错后不再重试。

* bpo-35928: "io.TextIOWrapper" 现在正确处理 "read()" 和 "write()" 后
  的解码缓冲区。

* bpo-26791: "shutil.move()" 现在当一个目录是符号链接的目标时，将符号
  链接移动到该目录中。这提供了与 mv shell 命令相同的行为。之前的行为会
  引发异常。由 Jeffrey Kintscher 提供补丁。

* bpo-36959: 修复了 "strptime()" 中一些无效 ISO 格式字符串组合的错误消
  息，这些消息引用了格式字符串中不包含的指令。由 Gordon P. Hemsley 提
  供补丁。

* bpo-18060: 修复了一个类继承问题，当从 Structure 或 Union 的基类派生
  两个或更多级别的子类时，可能导致段错误。


文档
----

* gh-110746: 改进了 ttk.treeview.column 和 ttk.treeview.heading 方法以
  及布局的有效选项/值的标记。

* gh-95649: 文档说明 "asyncio" 模块包含从 uvloop 项目的 v0.16.0 中获取
  的代码，以及所需的 MIT 许可信息。


测试
----

* gh-109980: 在 macOS 上修复 "test_shutil" 中的 "test_tarfile_vs_tar"
  ，其中系统 tar 可以在归档中包含比 "shutil.make_archive" 更多的信息。

* gh-112769: 现在，当 "zlib.ZLIB_RUNTIME_VERSION" 包含非整数后缀时，测
  试正确比较 zlib 版本。例如，zlib-ng 将版本定义为 "1.3.0.zlib-ng"。

* gh-105089: 在 AIX 上修复 "test.test_zipfile.test_core.TestWithDirec
  tory.test_create_directory_with_write" 测试，通过对模式进行 0xFFFF
  的按位与操作，使其与 "zinfo.external_attr" 同步。

* bpo-40648: 测试 Windows 上文件可以通过 chmod() 获取的模式。


构建
----

* gh-101778: Fix build error when there's a dangling symlink in the
  directory containing "ffi.h".

* gh-112305: 修复了在树外构建上执行的 "check-clean-src" 步骤，以检测错
  误的 "$(srcdir)/Python/frozen_modules/*.h" 文件，并建议适当的源树清
  理步骤以重新获得可工作的构建。

* bpo-11102: "os.major()"、"os.makedev()" 和 "os.minor()" 函数现在在
  HP-UX v3 上可用。

* bpo-36351: 交叉编译时不设置 ipv6type。


Windows
-------

* gh-109991: 更新 Windows 构建以使用 OpenSSL 3.0.13。

* gh-111239: 更新 Windows 构建以使用 zlib v1.3.1。

* gh-100107: "py.exe" 启动器在启动包含 "/usr/bin/env" shebang 的脚本时
  ，将不再尝试运行 Microsoft Store 重定向器。

* gh-114096: 为创建目录连接激活的进程权限现在会在之后恢复，避免程序中
  其他部分的行为变化。

* gh-113009: "multiprocessing": 在 Windows 上，修复了
  "Process.terminate()" 中的一个竞态条件：不再将 "returncode" 属性设置
  为总是在 "Process.wait()" 中调用 "WaitForSingleObject()"。之前，有时
  候即使 "GetExitCodeProcess()" 不是 "STILL_ACTIVE"，进程在
  "TerminateProcess()" 后仍在运行。由 Victor Stinner 提供补丁。

* gh-87868: 在 "_winapi.CreateProcess()" 中正确排序并移除重复的环境变
  量。

* bpo-37308: 修复在 Windows 上使用非 ASCII *tagname* 参数时
  "mmap.mmap" 中的乱码问题。


macOS
-----

* gh-115009: 更新macOS安装程序以使用SQLite 3.45.1。

* gh-109991: 更新macOS安装程序以使用OpenSSL 3.0.13。

* gh-74573: 文档说明 "dbm.ndbm" 在更新时超过未记录的平台限制时可能会静
  默损坏 DBM 文件，并且在读取此类损坏文件时可能会崩溃（段错误）。
  (FB8919203)

* gh-65701: **freeze** 工具不适用于 Python 的框架构建。文档说明这一点
  ，并在使用此类构建运行工具时早期退出。

* gh-102362: 确保 "sysconfig.get_plaform()" 的结果至少包括主版本和次版
  本，即使在构建过程中 "MACOSX_DEPLOYMENT_TARGET" 仅设置为一个主版本以
  匹配 pip 预期的格式。

* gh-110017: 由于 macOS 中的一个错误 (FB13453490)，在 macOS 上禁用信号
  处理压力测试。

* gh-109981: 在 macOS 上使用 "/dev/fd" 来确定
  "test.support.os_helper.fd_count" 中打开的文件数量，以避免在探测打开
  的文件时因“受保护”的文件描述符而崩溃。


IDLE
----

* gh-96905: 在idlelib代码中，停止重新定义内置的'dict'和'object'。

* gh-72284: 改进 IDLE 文档中的功能列表、编辑器键绑定和 shell 键绑定。

* gh-113903: 修复 test.test_idle 在 test_configdialog 中的罕见失败。

* gh-113729: 修复 3.11.7 和 3.12.1 中的“帮助 -> IDLE 文档”菜单错误。

* gh-113269: 修复 test_editor 在 macOS Catalina 上的挂起问题。

* gh-112898: 修复在macOS上退出IDLE时处理未保存文件的问题。

* gh-103820: 修改IDLE绑定，使得在非X11窗口系统（即Win32和Aqua）上来自
  鼠标按钮4/5的事件不会被误认为是滚动。

* bpo-13586: 打开“替换”对话框时输入选中的文本。


工具/示例
---------

* gh-109991: 更新GitHub CI工作流以使用OpenSSL 3.0.13，并更新
  multissltests以使用1.1.1w、3.0.13、3.1.5和3.2.1。

* gh-115015: 修复Argument Clinic中的一个bug，该bug会为没有参数但使用
  METH_METHOD | METH_FASTCALL | METH_KEYWORDS 调用约定的方法生成错误的
  代码。之前只检查了位置参数的数量；任何传递的关键字参数都会被静默接受
  。


Python 3.11.7 final
===================

*Release date: 2023-12-04*


核心与内置函数
--------------

* gh-112625: 修复在 "bytearray.join()" 方法中迭代参数时可能会清除
  bytearray对象，导致读取已释放内存的bug。

* gh-112388: 修复导致解析器尝试覆盖 tokenizer 错误的错误。由 Pablo
  Galindo 提供补丁。

* gh-112387: 修复解码字符串中反向 tokenize 错误的错误位置。由 Pablo
  Galindo 提供补丁。

* gh-112266: 更改 "__dict__" 和 "__weakref__" 的文档字符串。

* gh-109181: Speed up "Traceback" object creation by lazily compute
  the line number. Patch by Pablo Galindo

* gh-102388: 修复 "iso2022_jp_3" 和 "iso2022_jp_2004" 编解码器读取越界
  的错误

* gh-111366: 修复了 "codeop" 中的一个问题，该问题导致在存在无效语法时
  引发的 "SyntaxError" 异常不包含精确的错误信息。由Pablo Galindo提供补
  丁。

* gh-111380: 修复了一个错误，该错误导致在解析时如果遇到无效语法，
  "SyntaxWarning" 会显示两次。由Pablo Galindo提供补丁。

* gh-88116: Traceback location ranges involving wide unicode
  characters (like emoji and asian characters) now are properly
  highlighted. Patch by Batuhan Taskaya and Pablo Galindo.

* gh-94438: 修复了一个回归问题，该问题在调试时阻止了跨 "is None" 和
  "is not None" 的跳转。由Savannah Ostrowski提供补丁。

* gh-110696: 修复了无效参数解包的错误消息。由Pablo Galindo提供补丁

* gh-110237: 修复在 "_PyEval_MatchClass" 中对 "PyList_Append" 调用缺少
  错误检查的问题。

* gh-109216: 修复 "BUILD_MAP" 中可能的内存泄漏。


库
--

* gh-112618: 修复了与 "typing.Annotated" 相关的缓存错误。
  "Annotated[str, True]" 不再与 "Annotated[str, 1]" 相同。

* gh-112509: 修复了可能导致键同时出现在 "typing.TypedDict" 的
  "__required_keys__" 和``__optional_keys__``属性中的边缘情况。由Jelle
  Zijlstra提供补丁。

* gh-94722: 修复了一个错误，即当其中一个实例的 lineno 为 "None" 时，
  "DocTest" 实例之间的比较会失败。

* gh-112105: 使 "readline.set_completer_delims()" 与 libedit 一起工作
  。

* gh-111942: 在非调试模式下修复 TextIOWrapper 构造器中使用不可编码的
  “errors”参数时的 SystemError。

* gh-109538: 当事件循环在 "StreamWriter.__del__()" 中已经关闭时，显示
  警告信息而不是显示 "RuntimeError"。

* gh-111942: 修复在 "io.TextIOWrapper.reconfigure()" 中传递无效参数（
  例如非字符串编码）时导致的崩溃。

* gh-111804: 在 WASI 下移除 posix.fallocate()，因为底层的
  posix_fallocate() 在 WASI preview2 中不可用。

* gh-111841: 修复在 Windows 上的 "os.putenv()" 和 "os.unsetenv()" 中在
  嵌入的空字符处截断参数的问题。

* gh-111541: 修复 "doctest" 对于非内置子类的 "SyntaxError" 的处理。

* gh-110894: 为 "asyncio.start_server()" 的 "client_connected_cb" 中的
  异常调用循环异常处理器，以便应用程序可以处理它。由 Kumar Aditya 提供
  补丁。

* gh-111531: 修复 "tkinter" 小部件的 "bind_class()" 和 "bind_all()" 方
  法中的引用泄漏问题。

* gh-111356: Added "io.text_encoding()", "io.DEFAULT_BUFFER_SIZE", and
  "io.IncrementalNewlineDecoder" to "io.__all__".

* gh-68166: 在 "tkinter.ttk.Style.element_create()" 中移除了对不支持的
  "vsapi" 元素类型的提及。为 "element_create()" 和其他 "ttk.Style" 方
  法添加了测试。在文档中为 "element_create()" 添加了示例。

* gh-111251: Fix "_blake2" not checking for errors when initializing.

* gh-111174: 修复在为空 BytesIO 重复调用 "io.BytesIO.getbuffer()" 时的
  崩溃问题。

* gh-111187: 将 locale.getdefaultlocale() 的移除版本推迟到 Python 3.15
  。

* gh-111159: 修复 "doctest" 对带有注释的异常的输出比较。

* gh-110910: 修复 "asyncio.TaskGroup" 和 "asyncio.Timeout" 中的无效状
  态处理。如果使用不当，现在会正确抛出 RuntimeError，并在之后保持状态
  一致。

* gh-111092: 使 turtledemo 在没有启用默认根的情况下运行。

* gh-110590: 修复 "_sre.compile()" 中的一个bug，当 *code* 参数是非整数
  列表时，"TypeError" 会被 "OverflowError" 覆盖。

* gh-65052: 防止 "pdb" 在尝试显示不可显示对象时崩溃。

* gh-110519: Deprecation warning about non-integer number in "gettext"
  now alwais refers to the line in the user code where gettext
  function or method is used. Previously it could refer to a line in
  "gettext" code.

* gh-110378: "contextmanager()" 和 "asynccontextmanager()" 上下文管理
  器现在会关闭一个产生多个值的无效底层生成器对象。

* gh-110365: Fix "termios.tcsetattr()" bug that was overwritting
  existing errors during parsing integers from "term" list.

* gh-110196: 向 "IPv6Address" 添加 "__reduce__" 方法以保留 "scope_id"
  。

* gh-109747: 改进对不支持的后视模式的错误提示。现在对于后视模式宽度过
  大的情况，会抛出 re.error 而不是 OverflowError 或 RuntimeError。

* gh-109786: 修复了重新进入 "itertools.pairwise" 的 "__next__()" 方法
  时可能出现的引用泄漏和崩溃问题。

* gh-108791: 改进了 "pdb" 命令行接口中的错误处理，使其产生更简洁的错误
  消息。

* gh-73561: 当 "http.client" 使用IPv6地址作为Host头时，省略接口范围。

* gh-86826: "zipinfo" 现在支持RFC 8536确定的TZ字符串中的全部值范围，并
  检测所有无效格式。Python和C实现现在在无效数据上抛出相同类型的异常。

* bpo-41422: 修复了 "pickle.Pickler" 和 "pickle.Unpickler" 通过内部备
  忘录映射涉及循环引用的内存泄漏。

* bpo-40262: "ssl.SSLSocket.recv_into()" 方法不再要求 *buffer* 参数实
  现 "__len__"，并且支持具有任意项目大小的缓冲区。

* bpo-35191: Fix unexpected integer truncation in
  "socket.setblocking()" which caused it to interpret multiples of
  "2**32" as "False".


文档
----

* gh-108826: "dis" 模块的命令行界面现在在文档中被提及。


测试
----

* gh-110367: 使regrtest的 "--verbose3" 选项与 "--huntrleaks -jN" 选项
  兼容。>>``<<./python -m test -j1 -R 3:3 --verbose3``命令现在按预期工
  作。由Victor Stinner提供补丁。

* gh-111309: "distutils" tests can now be run via "unittest".

* gh-111165: Remove no longer used functions "run_unittest()" and
  "run_doctest()" and class "BasicTestRunner" from the "test.support"
  module.

* gh-110932: 如果定义了 "SOURCE_DATE_EPOCH" 环境变量，修复regrtest：使
  用变量值作为随机种子。由Victor Stinner提供补丁。

* gh-110995: test_gdb: 修复对未构建Python脚本支持的gdb的检测。由Victor
  Stinner提交的补丁。

* gh-110918: 现在按照指定的顺序测试由选项 "--match"、"--ignore"、"--
  matchfile" 和``--ignorefile``指定的测试用例匹配模式，最后一个匹配决
  定测试用例是否运行或被忽略。

* gh-110647: 修复 test_signal 的 test_stress_modifying_handlers()。由
  Victor Stinner提供补丁。

* gh-103053: 在FreeBSD上修复 test_tools.test_freeze：在复制的源代码目
  录中运行"make distclean"而不是"make clean"以同时删除"python"程序。由
  Victor Stinner提供补丁。

* gh-110167: 修复 test_socket 中的死锁问题，当服务器因超时失败但客户端
  仍在自己的线程中运行时。不要在 doCleanups() 中持有锁调用清理函数。其
  中一个清理函数会等待客户端完成，而如果客户端在这种情况下调用
  addCleanup()，可能会导致死锁。由 Victor Stinner 提供补丁。

* gh-110388: 为 "tty" 添加测试。

* gh-81002: 为 "termios" 添加测试。

* gh-110267: 添加对 PyStructSequence 对象的 pickle 和 copy 操作的测试
  。由 Xuehai Pan 提供补丁。

* gh-109974: 修复 test_threading 锁测试中的竞态条件。等待条件满足，而
  不是使用带有硬编码秒数的 "time.sleep()"。由 Victor Stinner 提供补丁
  。

* gh-109972: 将 test_gdb.py 文件拆分为由多个测试组成的 test_gdb 包，现
  在可以并行运行测试。由 Victor Stinner 提供补丁。

* gh-104736: 修复在 Linux ppc64le 上用 LLVM clang 16 构建的 Python 上
  的 test_gdb（例如 Fedora 38）。在 gdb "bt" 命令输出中搜索模式以检测
  gdb 是否未能检索到回溯。例如，如果找到 "Backtrace stopped: frame did
  not save the PC" 则跳过测试。补丁由 Victor Stinner 提供。

* gh-108927: 修复了在同一进程中运行测试时的顺序依赖问题，当一个具有子
  模块的测试（如 test_importlib）跟随一个导入其子模块的测试（如
  test_importlib.util）并先于一个使用该子模块的测试（如 test_unittest
  或 test_compileall）时。


构建
----

* gh-103053: "make check-clean-src" 现在也会检查源目录中是否找到
  "python" 程序：如果确实存在则失败并报错。由 Victor Stinner 提供补丁
  。

* gh-109191: 修复在使用最新版本 libedit 构建时的编译错误。


Windows
-------

* gh-110913: WindowsConsoleIO现在正确地分块大缓冲区而不拆分UTF-8序列。

* gh-110437: 允许覆盖 VC 可再发行组件的来源，以确保在更新之间永远不会
  降级。

* gh-109286: 更新 Windows 安装程序以使用 SQLite 3.43.1。


macOS
-----

* gh-110950: 更新 macOS 安装程序，包含上游 Tcl/Tk 的修复，解决在 macOS
  14 Sonoma 上 Tkinter 中遇到的 "Secure coding is not enabled for
  restorable state!" 警告问题。

* gh-111015: 确保在 macOS 构建中，IDLE.app 和 Python Launcher.app 以适
  当的权限安装。

* gh-109286: 更新macOS安装程序以使用SQLite 3.43.1。

* gh-71383: 更新 macOS 安装程序，包含上游 Tcl/Tk 的修复，解决在
  Tkinter 中遇到的 "ttk::ThemeChanged" 错误。

* gh-92603: 更新 macOS 安装程序，包含上游 Tcl/Tk 接受的修复，解决在第
  一个 "tkinter.Tk()" 实例被销毁后遇到的崩溃问题。

* gh-99834: 将 macOS 安装程序更新至 Tcl/Tk 8.6.13。


IDLE
----

* bpo-35668: Add docstrings to the IDLE debugger module. Fix two bugs:
  initialize Idb.botframe (should be in Bdb); in Idb.in_rpc_code,
  check whether prev_frame is None before trying to use it. Greatly
  expand test_debugger.


C API
-----

* gh-112438: 修复在 "PyArg_ParseTuple()" 类似函数中嵌套元组中格式单元
  "es"、"et"、"es#"和"et#"的支持。

* gh-109521: "PyImport_GetImporter()" 现在在无法获取 "sys.path_hooks"
  或 "sys.path_importer_cache"，或者它们不是对应的列表和字典时设置
  RuntimeError。以前在模糊的情况下可能返回 NULL 而不设置错误，如果这些
  属性类型错误，可能崩溃或抛出 SystemError。


Python 3.11.6 final
===================

*Release date: 2023-10-02*


核心与内置函数
--------------

* gh-109351: 修复编译涉及命名（海象）表达式的无效AST时崩溃的错误。

* gh-109207: 修复符号表条目对象的 "__repr__" 中的SystemError。

* gh-109179: 修复C回溯显示中从 "SyntaxError" 中删除注释的错误。

* gh-88943: 改进跟随数字文字的非ASCII字符的语法错误。现在它指向无效的
  非ASCII字符，而不是有效的数字文字。

* gh-108959: 修复涉及非语义括号和空格的下标和二元操作的错误位置的光标
  放置。由Pablo Galindo提供补丁。

* gh-108520: Fix "multiprocessing.synchronize.SemLock.__setstate__()"
  to properly initialize
  "multiprocessing.synchronize.SemLock._is_fork_ctx". This fixes a
  regression when passing a SemLock accross nested processes.

  将 "multiprocessing.synchronize.SemLock.is_fork_ctx" 重命名为
  "multiprocessing.synchronize.SemLock._is_fork_ctx"，以避免将其暴露为
  公共API。


库
--

* gh-110036: On Windows, multiprocessing "Popen.terminate()" now
  catchs "PermissionError" and get the process exit code. If the
  process is still running, raise again the "PermissionError".
  Otherwise, the process terminated as expected: store its exit code.
  Patch by Victor Stinner.

* gh-110038: 修复了一个问题，该问题导致 "KqueueSelector.select()" 在某
  些情况下当文件描述符被同时注册为读和写时，不返回所有就绪的事件。

* gh-109631: 现在可以中断执行短重复匹配的 "re" 函数，如
  "re.findall()", "re.split()", "re.search()" 和 "re.sub()"。

* gh-109593: 避免在多进程资源跟踪器的重入调用上死锁。虽然不太可能，但
  如果GC传递调用了如SemLock这样的多进程对象的终结器，就可能发生这种重
  入调用。

* gh-109613: 修复 "os.stat()" 和 "os.DirEntry.stat()"：检查异常。以前
  ，在Python调试模式下构建时，当函数成功但设置了异常时，这些函数可能会
  触发致命的Python错误（并中止进程）。由Victor Stinner提供补丁。

* gh-109375: "pdb" 的 "alias" 命令现在阻止注册没有参数的别名。

* gh-107219: 修复了 "concurrent.futures" 中的竞争条件。当进程池中的进
  程被突然终止时（而 future 正在运行或挂起），关闭连接的写入端。如果调
  用队列在发送字节到工作进程时被阻塞，关闭连接的写入端会中断发送，因此
  队列可以被关闭。由 Victor Stinner 提供补丁。

* gh-50644: 现在尝试 pickle 或创建 "codecs" 流的浅拷贝或深拷贝会引发
  TypeError。之前，复制会因 RecursionError 失败，而 pickle 会产生错误
  的结果，最终导致解 pickle 时因 RecursionError 失败。

* gh-108987: 修复 "_thread.start_new_thread()" 的竞争条件。如果在
  Python 终止过程中创建了一个线程，新生成的线程现在会立即退出，而不是
  尝试访问已释放的内存并导致崩溃。由 Victor Stinner 提供补丁。

* gh-108843: 修复 "ast.unparse()" 在反解析包含多种引号类型的 f-字符串
  时的问题。

* gh-108682: 枚举：如果从自定义 "__new__" 调用 "super().__new__()"，则
  引发 "TypeError"。

* gh-105829: 修复 concurrent.futures.ProcessPoolExecutor 死锁

* gh-64662: 修复 "sqlite3.Connection.iterdump()" 中对虚拟表的支持。由
  Aviv Palivoda 提交的补丁。

* gh-107913: 修复在创建异常对象之前如果清理代码清除或修改了 "errno" 和
  "winerror" 值，"OSError" 异常中可能丢失这些值的问题。

* gh-104372: 在Linux上，"subprocess" 可以使用 "vfork()" 系统调用来更快
  地生成子进程，通过在其等待vfork的子进程 "exec()" 结果时释放GIL，防止
  父进程阻塞其他线程。这可以防止从慢速文件系统生成二进制文件时阻塞应用
  程序的其余部分。

* gh-84867: "unittest.TestLoader" 不再从确切的 "unittest.TestCase" 和
  "unittest.FunctionTestCase" 类加载测试用例。


文档
----

* gh-109209: 文档现在所需的最低 Sphinx 版本为 4.2。

* gh-105052: 更新 "timeit" 文档，说明时间以秒为单位仅是默认设置。

* gh-102823: 记录当 "x" 和 "y" 的类型为 "float" 时 "x // y" 的返回类型
  。


测试
----

* gh-110031: 如果 Python 是用地址消毒剂 (ASAN) 构建的，跳过使用
  thread+fork 的 test_threading 测试。由 Victor Stinner 提供补丁。

* gh-110088: 修复 test_asyncio 超时：不测量最大持续时间，测试不应测量
  CI 性能。仅在有任务有超时或延迟时测量最小持续时间。向
  "test_asyncio.utils" 添加 "CLOCK_RES"。由 Victor Stinner 提供补丁。

* gh-110033: 修复 "test_signal" 的 "test_interprocess_signal()"。确保
  在信号处理程序中引发异常之前删除 "subprocess.Popen" 对象。否则，
  "Popen.__del__()" 可能会获取到被记录为 "Exception ignored in: ..."
  的异常，导致测试失败。由 Victor Stinner 提供补丁。

* gh-109594: Fix test_timeout() of test_concurrent_futures.test_wait.
  Remove the future which may or may not complete depending if it
  takes longer than the timeout ot not. Keep the second future which
  does not complete before wait() timeout. Patch by Victor Stinner.

* gh-109748: 修复 test_venv 的
  "test_zippath_from_non_installed_posix()"：不复制 "__pycache__/" 子
  目录，因为它们可能被并行运行的其他 Python 测试修改。由 Victor
  Stinner 提供补丁。

* gh-103053: 如果 Python 是用 "./configure --enable-optimizations" 构
  建的（意味着启用了 Profile Guided Optimization (PGO)），则跳过
  test_tools.test_freeze 的 test_freeze_simple_script()：这只会使测试
  变得太慢。冻结工具由许多其他 CI 使用其他（更快的）编译器标志进行测试
  。由 Victor Stinner 提供补丁。

* gh-109396: 修复 FIPS 模式下的 "test_socket.test_hmac_sha1()"。使用更
  长的密钥：FIPS 模式要求至少 112 位。之前的密钥只有 32 位。由 Victor
  Stinner 提供补丁。

* gh-104736: 修复在 Linux ppc64le 上用 LLVM clang 16 构建的 Python 上
  的 test_gdb（例如 Fedora 38）。在 gdb "bt" 命令输出中搜索模式以检测
  gdb 是否未能检索到回溯。例如，如果找到 "Backtrace stopped: frame did
  not save the PC" 则跳过测试。补丁由 Victor Stinner 提供。

* gh-109237: 修复当工作目录包含至少一个非ASCII字符时的
  "test_site.test_underpth_basic()"：将 "._pth" 文件编码为UTF-8，并启
  用UTF-8模式以在子进程的标准输出中使用UTF-8。由Victor Stinner提供补丁
  。

* gh-109230: 修复 "test_pyexpat.test_exception()"：现在可以从不同于
  Python源代码目录的目录运行。在此之前，测试在这种情况下会失败。如果
  Modules/pyexpat.c源不可用，则跳过测试。也在非CPython的Python实现上跳
  过测试。由Victor Stinner提供补丁。

* gh-109015: 如果启用了TCP黑洞（"sysctl net.inet.tcp.blackhole"），在
  FreeBSD上修复test_asyncio、test_imaplib和test_socket测试。跳过在这种
  非标准配置下失败的少数测试，这些测试会返回 "ETIMEDOUT"。目前，
  "FreeBSD GCP镜像启用了TCP和UDP黑洞
  <https://reviews.freebsd.org/D41751>`_（``sysctl
  net.inet.tcp.blackhole=2`" 和 "sysctl net.inet.udp.blackhole=1"）。
  由Victor Stinner提供补丁。

* gh-91960: Skip "test_gdb" if gdb is unable to retrieve Python frame
  objects: if a frame is "<optimized out>". When Python is built with
  "clang -Og", gdb can fail to retrive the *frame* parameter of
  "_PyEval_EvalFrameDefault()". In this case, tests like "py_bt()" are
  likely to fail. Without getting access to Python frames, "python-
  gdb.py" is mostly clueless on retrieving the Python traceback.
  Moreover, "test_gdb" is no longer skipped on macOS if Python is
  built with Clang. Patch by Victor Stinner.

* gh-108962: 如果 "chflags()" 失败并提示"OSError: [Errno 45] Operation
  not supported"（例如在FreeBSD 13上），则跳过
  "test_tempfile.test_flags()"。由Victor Stinner提供补丁。

* gh-89392: 移除了测试中对 "test_main()" 函数的支持。现在它们总是使用
  正常的 unittest 测试运行器。

* gh-108851: 修复 WASI 构建机器上 "test_tomllib" 的递归测试：减少递归
  限制并根据当前可用的递归限制计算最大嵌套数组/字典。由 Victor Stinner
  提供补丁。

* gh-108851: 在 "test.support" 模块中添加 "get_recursion_available()"
  和 "get_recursion_depth()" 函数。由 Victor Stinner 提供补丁。

* gh-108822: "regrtest" 现在计算所有测试的统计信息：成功、失败和跳过。
  "test_netrc"、"test_pep646_syntax" 和 "test_xml_etree" 现在在其
  "test_main()" 函数中返回结果。补丁由 Victor Stinner 和 Alex Waygood
  提供。

* gh-108388: 将 test_concurrent_futures 转换为包含 7 个子测试的包。由
  Victor Stinner 提供补丁。

* gh-108388: 将test_multiprocessing_fork、
  test_multiprocessing_forkserver和test_multiprocessing_spawn拆分为测
  试包。每个包由4个子测试组成：processes、threads、manager和misc。这样
  可以并行运行更多测试，从而减少总测试时间。由Victor Stinner提供补丁。

* gh-101634: 当使用 "-jN" 选项运行Python测试套件时，如果工作进程的
  stdout无法从区域编码解码，则报告测试失败，因此退出码为非零。由Victor
  Stinner提供补丁。

* gh-100086: Python 测试运行器 (libregrtest) 现在会记录 Python 构建信
  息，如“debug”与“release”构建，或 LTO 和 PGO 优化。由 Victor Stinner
  提供补丁。

* gh-98903: The Python test suite now fails wit exit code 4 if no
  tests ran. It should help detecting typos in test names and test
  methods.

* gh-95027: 在 Windows 上，当 Python 测试套件使用 "-jN" 选项运行时，现
  在将 ANSI 代码页用作 stdout 临时文件的编码，而不是使用可能导致解码错
  误的 UTF-8。补丁由 Victor Stinner 提供。

* gh-93353: regrtest 现在在运行 -jN 选项时会检查测试是否泄漏临时文件或
  目录。由 Victor Stinner 提供补丁。


构建
----

* gh-63760: 修复 Solaris 构建：不再重新定义 "gethostname()" 函数。
  Solaris 自 2005 年起定义了该函数。由 Victor Stinner 提供，原始补丁由
  Jakub Kulík 提供补丁。

* gh-108740: 修复 "make regen-all" 中的竞态条件。"deepfreeze.c" 源文件
  和由 Argument Clinic 生成的文件现在在生成 "全局对象" 之前生成或更新
  。之前，某些标识符可能会根据这些文件的生成顺序而丢失。由 Victor
  Stinner 提供补丁。


Windows
-------

* gh-109991: 更新 Windows 构建以使用 OpenSSL 3.0.11。

* gh-107565: Update Windows build to use OpenSSL 3.0.10.


macOS
-----

* gh-109991: 更新macOS安装程序以使用OpenSSL 3.0.11。


工具/示例
---------

* gh-109991: 更新GitHub CI工作流以使用OpenSSL 3.0.11，并使
  multissltests使用1.1.1w、3.0.11和3.1.3版本。


Python 3.11.5 final
===================

*Release date: 2023-08-24*


安全性
------

* gh-108310: Fixed an issue where instances of "ssl.SSLSocket" were
  vulnerable to a bypass of the TLS handshake and included protections
  (like certificate verification) and treating sent unencrypted data
  as if it were post-handshake TLS encrypted data.  Security issue
  reported as CVE-2023-40217 by Aapo Oksman. Patch by Gregory P.
  Smith.


核心与内置函数
--------------

* gh-104432: 修复了在 "grp" 和 "socket" 模块中涉及返回 "char *" 指针序
  列的C API中潜在的非对齐内存访问。这些是在ARM macOS上使用
  "-fsaniziter=alignment" 构建时发现的。由Christopher Chavez提供补丁。

* gh-77377: 确保在fork上下文中创建的多进程同步对象不会被发送到在spawn
  上下文中创建的不同进程。这将在父进程中将段错误更改为可操作的
  RuntimeError。

* gh-106092: 修复了在垃圾回收延迟释放 "PyFrameObject" 时，由于 use-
  after-free 错误导致的段错误。

* gh-106719: 不再在类型和模块类型的 "__annotations__" getter 和 setter
  中抑制任意错误。

* gh-106723: 将 "frozen_modules" 传播到多进程生成的进程解释器中。

* gh-105979: 修复了 "_imp.get_frozen_object()" 中由于异常处理不当导致
  的崩溃。

* gh-105840: 修复了在专门化函数调用时 "__defaults__" 过多可能导致崩溃
  的问题。

* gh-105588: 修复了一个在编译格式错误的 "ast" 节点时可能导致崩溃的问题
  。

* gh-105375: 修复了 "builtins" 模块中的错误，其中异常可能被覆盖。

* gh-105375: 修复了编译器中的一个错误，其中异常可能被覆盖。

* gh-105375: 改进了 "PyUnicode_BuildEncodingMap()" 中的错误处理，其中
  异常可能被覆盖。

* gh-105235: 防止在 "mmap.find()" 调用期间发生越界内存访问。

* gh-101006: 改进读取 "marshal" 数据时的错误处理。


库
--

* gh-105736: Harmonized the pure Python version of OrderedDict with
  the C version. Now, both versions set up their internal state in
  "__new__". Formerly, the pure Python version did the set up in
  "__init__".

* gh-107963: 修复 "multiprocessing.set_forkserver_preload()" 以检查给
  定的模块名称列表。修补由Donghee Na提供。

* gh-106242: 修复 "os.path.normpath()" 以处理嵌入的空字符而不截断路径
  。

* gh-107845: "tarfile.data_filter()" 现在在确定符号链接的目标时会考虑
  其位置，因此不再会因 "LinkOutsideDestinationError" 拒绝一些有效的
  tarball。

* gh-107715: 修复在类名包含特殊字符时 "doctest.DocTestFinder.find()"
  的行为。由 Gertjan van Zwieten 提供补丁。

* gh-100814: 现在，将可调用对象作为选项值传递给 Tkinter 图像时会引发预
  期的 TclError，而不是 AttributeError。

* gh-106684: Close "asyncio.StreamWriter" when it is not closed by
  application leading to memory leaks. Patch by Kumar Aditya.

* gh-107077: Seems that in some conditions, OpenSSL will return
  "SSL_ERROR_SYSCALL" instead of "SSL_ERROR_SSL" when a certification
  verification has failed, but the error parameters will still contain
  "ERR_LIB_SSL" and "SSL_R_CERTIFICATE_VERIFY_FAILED". We are now
  detecting this situation and raising the appropiate
  "ssl.SSLCertVerificationError". Patch by Pablo Galindo

* gh-107396: tarfiles; 修复了gzip解压中self.exception的赋值前使用问题
  。

* gh-62519: 使 "gettext.pgettext()" 在找不到翻译时搜索复数定义。

* gh-83006: 文档化 "shutil.disk_usage()" 在Unix上非挂载文件系统的行为
  。

* gh-106186: 当使用 "email.parser.Parser" 类解析 "headersonly=True" 的
  邮件时，不报告 "MultipartInvariantViolationDefect" 缺陷。

* gh-106831: 修复了 "_ssl.c" 中 "d2i_SSL_SESSION" 结果可能缺少 "NULL"
  检查的问题。

* gh-106774: 更新捆绑的 pip 到版本 23.2.1。

* gh-106752: Fixed several bug in zipfile.Path in
  "name"/"suffix"/"suffixes"/"stem" operations when no filename is
  present and the Path is not at the root of the zipfile.

* gh-106602: 在 "enum" 中添加__copy__和__deepcopy__。

* gh-106530: 撤销了对 "colorsys.rgb_to_hls()" 的更改，该更改导致对某些
  几乎白色的输入进行除零操作。由Terry Jan Reedy提供补丁。

* gh-106052: "re" 模块：在子模式包含回溯的情况下修复贪婪量词的匹配问题
  。

* gh-106510: 改进正则表达式中原子组的调试输出。

* gh-105497: 修复存在未命名标志时的标志掩码反转问题。

* gh-90876: 防止 "multiprocessing.spawn" 在 "sys.executable" 为 "None"
  的环境中 *导入* 失败。这个问题在3.11版本中随着对多处理中路径类对象的
  支持而出现倒退。

* gh-106350: 检测 "_tkinter" 模块使用的 libtommath 函数 "mp_init()" 中
  可能的内存分配失败。

* gh-102541: Make pydoc.doc catch bad module ImportError when output
  stream is not None.

* gh-106263: 修复了在调用 "repr" 时手动构造的 SignalDict 对象导致的崩
  溃。由 Charlie Zhao 提供补丁。

* gh-105375: 修复 "_Unpickler_SetInputStream()" 中的一个 bug，该 bug
  在失败时可能导致异常被覆盖。

* gh-105375: 修复 "sys" 模块中由于延迟错误处理可能导致异常被覆盖的错误
  。

* gh-105605: 在模块初始化期间加强 "pyexpat" 的错误处理，以防止异常可能
  被覆盖，以及对象被两次解引用。

* gh-105375: 修复 "decimal" 模块中可能导致异常被覆盖的错误。

* gh-105375: 修复 "_datetime" 模块中在模块初始化失败时异常可能被覆盖的
  错误。

* gh-105375: 修复 "_ssl" 初始化过程中可能导致引用泄漏和异常被覆盖的错
  误。

* gh-105375: 修复 "array.array" 类中可能导致异常被覆盖的错误。

* gh-105375: Fix bugs in "_ctypes" where exceptions could end up being
  overwritten.

* gh-105375: 修复 "posix" 模块中可能导致异常被覆盖的错误。

* gh-105375: 修复 "_elementtree" 模块中可能导致异常被覆盖的错误。

* gh-105375: 修复 "zoneinfo" 模块中可能导致异常被覆盖的错误。

* gh-105375: 修复 "errno" 模块中可能导致异常被覆盖的错误。

* gh-105497: 修复存在别名/掩码成员时的标志反转问题。

* gh-105375: 修复 "pickle" 中异常可能被覆盖的错误。

* gh-103171: Revert undocumented behaviour change with runtime-
  checkable protocols decorated with "typing.final()" in Python 3.11.
  The behaviour change had meant that objects would not be considered
  instances of these protocols at runtime unless they had a
  "__final__" attribute. Patch by Alex Waygood.

* gh-105375: 修复 "sqlite3" 中的一个错误，其中异常可能在 "collation"
  回调中被覆盖。

* gh-105332: 将 pickling 方法从按名称恢复为按值。

* gh-104554: 在 urllib.parse 中添加 RTSPS 方案支持。

* gh-100061: 修复了一个导致带有占有限定符的正则表达式错误匹配的错误。

* gh-102541: 在导入失败时，在 "help()" 提示中隐藏回溯。

* gh-99203: 恢复 CPython <= 3.10.5 的 "shutil.make_archive()" 行为：如
  果 "root_dir" 不是目录，则不创建空存档，并且在这种情况下，无论
  "format" 选择如何，都会引发 "FileNotFoundError" 或
  "NotADirectoryError"。除了恢复的行为外，该函数现在也可能在 "dry_run"
  模式下引发这些异常。

* gh-94777: 修复 "multiprocessing" "ProcessPoolExecutor" 在子进程崩溃
  且数据正被写入调用队列时的挂起问题。

* bpo-18319: 确保 "gettext(msg)" 即使存在复数形式也能检索翻译。换句话
  说："gettext(msg) == ngettext(msg, '', 1)"。


文档
----

* gh-107008: 记录 "curses" 模块变量 "LINES" 和 "COLS"。

* gh-106948: 向 "nitpick_ignore" 添加一系列标准外部名称。

* gh-54738: 添加关于如何本地化 "argparse" 模块的文档。


测试
----

* gh-105776: 修复当C编译器命令带有 "-std=c11" 选项时的test_cppext：从
  编译器命令中移除``-std=``选项。由Victor Stinner提供补丁。

* gh-107237: "test_logging"：通过将超时从100毫秒增加到5分钟（
  LONG_TIMEOUT）来修复``test_udp_reconnection()``。由Victor Stinner提
  供补丁。

* gh-101634: 当使用 "-jN" 选项运行Python测试套件时，如果工作进程的
  stdout无法从区域编码解码，则报告测试失败，因此退出码为非零。由Victor
  Stinner提供补丁。


构建
----

* gh-107814: 当使用 "-q" 参数调用 "find_python.bat" 时，未能正确静默
  nuget 的输出。此问题现已修复。

* gh-106881: 在 "Modules/posixmodule.c" 中包含 "linux/limits.h" 之前先
  检查其是否存在。

* gh-104692: 将 "commoninstall" 作为 "bininstall" 的先决条件包含在内

  这确保了在使用并行构建（"make -j install"）时，"commoninstall" 会在
  "bininstall" 开始之前完成，因此 "python3" 符号链接只会在所有标准库模
  块安装完成后才被安装。

* gh-100340: 允许 wasm-sdk 17 及更高版本使用 -Wno-int-conversion，从而
  能够针对最新 sdk 构建 WASI 构建。


Windows
-------

* gh-106242: 修复了在Windows上传递包含嵌入空字符的路径时 "realpath()"
  的行为，使其表现一致。在严格模式下，现在会抛出 "OSError" 而不是意外
  的 "ValueError"，在非严格模式下会使路径变为绝对路径。

* gh-106844: Fix integer overflow in "_winapi.LCMapStringEx()" which
  affects "ntpath.normcase()".

* gh-99079: Update Windows build to use OpenSSL 3.0.9

* gh-105436: 确保空环境块以两个空字符终止，这是Windows所要求的。


macOS
-----

* gh-107565: Update macOS installer to use OpenSSL 3.0.10.

* gh-99079: 更新macOS安装程序以使用OpenSSL 3.0.9。


工具/示例
---------

* gh-107565: Update multissltests and GitHub CI workflows to use
  OpenSSL 1.1.1v, 3.0.10, and 3.1.2.

* gh-95065: Argument Clinic now supports overriding automatically
  generated signature by using directive "@text_signature". See the
  Argument Clinic docs.

* gh-106970: 修复Argument Clinic中 "destination <name> clear" 命令的
  bug；目的地缓冲区永远不会被清除，且 "destination" 指令解析器在处理命
  令后会直接继续到错误处理器。由Erlend E. Aasland提供补丁。


C API
-----

* gh-107916: C API 函数 "PyErr_SetFromErrnoWithFilename()",
  "PyErr_SetExcFromWindowsErrWithFilename()" 和
  "PyErr_SetFromWindowsErrWithFilename()" 现在在调用
  "PyUnicode_DecodeFSDefault()" 之前保存错误代码。

* gh-107915: 诸如 "PyErr_SetString()", "PyErr_Format()",
  "PyErr_SetFromErrnoWithFilename()" 等 C API 函数，如果格式化错误消息
  或解码文件名失败，将不再崩溃或忽略错误。相反，它们会保留相应的错误。

* gh-107226: "PyModule_AddObjectRef()" 现在仅在有限 API 版本 3.10 或更
  高版本中可用。

* gh-105375: 修复 "PyErr_WarnExplicit()" 中的一个错误，其中如果API内部
  失败，异常可能会被覆盖。

* gh-99612: 修复 "PyUnicode_DecodeUTF8Stateful()" 对于仅ASCII数据的问
  题："*consumed" 未被设置。


Python 3.11.4 final
===================

*Release date: 2023-06-06*


安全性
------

* gh-103142: The version of OpenSSL used in our binary builds has been
  upgraded to 1.1.1u to address several CVEs.

* gh-99889: Fixed a security in flaw in "uu.decode()" that could allow
  for directory traversal based on the input if no "out_file" was
  specified.

* gh-104049: 在 "http.client.SimpleHTTPRequestHandler" 生成的目录索引
  中不暴露本地的磁盘位置。

* gh-102153: "urllib.parse.urlsplit()" now strips leading C0 control
  and space characters following the specification for URLs defined by
  WHATWG in response to CVE-2023-24329. Patch by Illia Volochii.


核心与内置函数
--------------

* gh-105164: 确保如果一个块中唯一的注解位于 "match" 块内，则正确设置注
  解。由Jelle Zijlstra提供补丁。

* gh-104615: 修复了类似 "a, a = x, y" 代码中的赋值顺序错误。由Carl
  Meyer贡献。

* gh-104482: 修复了ast.c中验证模式匹配语句时的三个错误处理bug。

* gh-102818: 不在 "sys.setprofile" 和 "sys.settrace" 的蹦床函数中添加
  帧到回溯中。这确保了如果回调函数中引发异常，帧不会被重复，并且确保如
  果使用C回调且该回调不添加帧时，帧不会被省略。

* gh-104405: 修复了一个问题，其中一些 *bytecode* 指令在“内联”调用时可
  能忽略 **PEP 523**。

* gh-104018: 在字节对象的 %-格式化中禁止使用 "z" 格式说明符。

* gh-103971: Fix an issue where incorrect locations numbers could be
  assigned to code following "case" blocks.

* gh-102310: 更改了无效字节文字的错误范围。

* gh-103590: 不要将 "try-except*" 构造中抛出的单个异常包装在
  "ExceptionGroup" 中。

* gh-101517: 修复了为 "except*" 发出的指令的行号中的错误。

* gh-103242: 迁移 "set_ecdh_curve()" 方法以不使用已弃用的 OpenSSL API
  。Donghee Na 的补丁。

* gh-102700: 允许内置模块成为子模块。这允许子模块静态链接到 CPython 二
  进制文件中。

* gh-101857: 通过将检查范围扩大到linux而不仅仅是glibc来修复Linux系统上
  的xattr支持检测。这修复了对musl的支持。

* gh-99184: 在 "weakref.ref" 的 "repr" 中绕过 "__name__" 的实例属性访
  问。

* gh-96670: The parser now raises "SyntaxError" when parsing source
  code containing null bytes. Backported from "aab01e3". Patch by
  Pablo Galindo

* bpo-31821: 修复 "pause_reading()" 在被 "asyncio" 中的
  "connection_made()" 调用时工作的问题。


库
--

* gh-105080: 修复了 "inspect.signature()" 在派生类上的不一致签名问题

* gh-104874: 记录了 "typing.NewType" 的 "__name__" 和 "__supertype__"
  属性。补丁由 Jelle Zijlstra 提供。

* gh-104340: 当 "asyncio" 管道协议由于错误失去连接，并且调用者没有在相
  应的 "StreamWriter" 上等待 "wait_closed()" 时，不要记录关于未检索到
  的异常的警告。毕竟，根据 "StreamWriter.close()" 文档，
  "wait_closed()" 调用是可选的（“非强制性”）。

* gh-104372: 重构了 "_posixsubprocess" 的内部实现，以避免在标记
  "pass_fds=" 文件描述符为可继承时在 fork 和 exec 之间使用 Python C
  API。

* gh-75367: 修复了 "inspect.getattr_static()" 中的数据描述符检测问题。

* gh-104536: 修复了内部 "multiprocessing.process" 清理逻辑中的一个竞态
  条件，该条件可能在调用 "process.close()" 时表现为意外的
  "AttributeError"。

* gh-104399: 准备 "_tkinter" 模块以通过必要时替换弃用的函数
  "mp_to_unsigned_bin_n()" 和 "mp_unsigned_bin_size()" 来构建与Tcl 9.0
  和未来的libtommath。

* gh-104307: "socket.getnameinfo()" 现在在联系 DNS 服务器时会释放 GIL
  。

* gh-87695: 修复了 "pathlib.Path.glob()" 在遇到指向过长路径的符号链接
  时引发 "OSError" 的问题。

* gh-104265: 通过禁止实例化 "_csv.Reader" 和 "_csv.Writer" 类型来防止
  可能的崩溃。这个回归是在3.10.0a4版本中由PR 23224引入的 (bpo-14935)。
  由Radislav Chugunov提供补丁。

* gh-104035: 不忽略用户定义的 "__getstate__" 和 "__setstate__" 方法对
  于有槽的冻结数据类。

* gh-103987: 在 "mmap" 中修复了几个可能导致在内存映射文件失效后仍访问
  它们的错误。

* gh-103935: 对要执行的文件使用 "io.open_code()" 而不是原始的 "open()"
  。

* gh-100370: 修复了在32位构建中 "sqlite3.Connection.blobopen()" 可能引
  发的 "OverflowError"。由 Erlend E. Aasland 提供补丁。

* gh-103848: 添加检查以确保 "urllib.parse.urlsplit()" 找到的 "[" 括号
  "]" 主机是 IPv6 或 IPvFuture 格式。

* gh-103872: 将捆绑的 pip 更新至版本 23.1.2。

* gh-103861: 修复了 "zipfile.Zipfile" 在使用 "force_zip64" 向其中添加
  文件时创建无效 zip 文件的问题。由 Carey Metcalfe 提供补丁。

* gh-103685: 为 Tk 8.7 准备 "tkinter.Menu.index()"，使其在应该返回
  "None" 时不会引发 "TclError: expected integer but got """。

* gh-81403: "urllib.request.CacheFTPHandler" 不再在重用缓存的 FTP 实例
  时引发 "URLError"。ftplib 的 endtransfer 方法调用 voidresp 来排空连
  接，以正确处理 FTP 实例的重用。

* gh-103578: Fixed a bug where "pdb" crashes when reading source file
  with different encoding by replacing "io.open()" with
  "io.open_code()". The new method would also call into the hook set
  by "PyFile_SetOpenCodeHook()".

* gh-103556: 现在创建 "inspect.Signature" 对象时，带有默认值的位置参数
  后面跟着没有默认值的位置或关键字参数是不可能的。

* gh-103559: 将捆绑的 pip 更新到版本 23.1.1。

* gh-103365: 将默认的 Flag 边界设置为 "STRICT" 并修复位操作。

* gh-103472: 通过显式关闭代理/隧道的 CONNECT 响应，避免
  "http.client.HTTPConnection" 中潜在的 "ResourceWarning"。

* gh-103449: 修复了 "dataclasses.dataclass()" 中文档字符串生成的一个错
  误。

* gh-103256: 修复了一个导致 "hmac" 在请求的哈希算法在OpenSSL中不可用（
  尽管在``hashlib``本身中作为单独部分可用）时引发异常的bug。现在它正确
  地回退到内置算法。这种情况可能发生在，例如，您的OpenSSL不包含SHA3支
  持而您想计算 >>``<<hmac.digest(b'K', b'M', 'sha3_256')``时。

* gh-103225: 修复 "pdb" 在显示模块级源代码行号时的一个bug。

* gh-93910: Remove deprecation of enum "memmber.member" access.

* gh-102978: 修复当以 "autospec=True" 调用时，"unittest.mock.patch()"
  不强制执行用``@classmethod``或 "@staticmethod" 装饰的方法的函数签名
  的问题。

* gh-103204: 修复 "http.server" 接受HTTP版本号前带有'+'或'-'，或带有数
  字分隔'_'字符的HTTP请求的问题。版本号的长度也受到限制。

* gh-102953: "tarfile" 中的提取方法，以及 "shutil.unpack_archive()"，
  新增了一个 *filter* 参数，允许限制可能令人惊讶或危险的tar特性，例如
  在目标目录之外创建文件。详情请见 解压缩过滤器。

* gh-101640: "argparse.ArgumentParser" 现在会在写入消息时捕获错误，例
  如当 "sys.stderr" 为 "None" 时。由 Oleg Iarygin 提供的补丁。

* gh-96522: 修复 pty.spawn() 中潜在的僵局问题。

* gh-87474: 修复 "subprocess.Popen" 中潜在的文件描述符泄露问题。


文档
----

* gh-89455: 为 "traceback.TracebackException" 类的 "max_group_depth"
  和 "max_group_width" 参数以及 "exceptions" 属性添加缺失的文档。

* gh-89412: 为 "traceback.TracebackException" 类的 "end_lineno" 和
  "end_offset" 属性添加缺失的文档。

* gh-104943: 在 "typing.NamedTuple" 中删除对旧Python版本的提及。

* gh-67056: 文档说明从已注册的清理函数内部注册或注销一个 "atexit" 清理
  函数的效果是未定义的。

* gh-48241: Clarifying documentation about the url parameter to
  urllib.request.urlopen and urllib.request.Requst needing to be
  encoded properly.


测试
----

* gh-104494: 更新 "test_pack_configure_in" 和
  "test_place_configure_in" 以适应Tk 8.7中错误消息格式的变化。

* gh-104461: 仅在X11上运行test_configure_screen，因为 "DISPLAY" 环境变
  量和toplevels的``-screen``选项在Win32或Aqua的Tk上没有用。

* gh-103329: 添加了对 "unittest.mock.PropertyMock" 行为的回归测试。

* gh-85984: 在pty测试中利用termios的新“winsize”函数。

* gh-75729: 修复了当工作目录或解释器路径包含空格时，Windows 上
  "os.spawn*" 测试失败的问题。


构建
----

* gh-90005: 修复 "configure" 中的一个回归问题，该问题可能导致无意中与
  "libbsd" 链接。

* gh-104106: 为 macOS 添加 mkfifoat/mknodat 的 gcc 回退。由 Donghee Na
  提供补丁。

* gh-99069: 扩展了当 libc 头文件中缺少 "static_assert" 时的解决方法，
  适用于所有 clang 和 gcc 构建。特别是，这修复了在 macOS <= 10.10 上的
  构建问题。


Windows
-------

* gh-105146: 更新了安装程序末尾的链接，指向Discourse而不是邮件列表。

* gh-104623: 更新 Windows 安装程序以使用 SQLite 3.42.0。

* gh-102997: 更新 Windows 安装程序以使用 SQLite 3.41.2。

* gh-88013: 修复了在某些情况下调用 "ntpath.realpath()" 时传入 bytes 参
  数会引发 "TypeError" 的 bug。


macOS
-----

* gh-103142: Update macOS installer to use OpenSSL 1.1.1u.

* gh-104623: 将 macOS 安装程序更新至 SQLite 3.42.0。

* gh-102997: 将 macOS 安装程序更新至 SQLite 3.41.2。


IDLE
----

* gh-104719: 移除IDLE对tokenize.tabsize的修改，并测试tokenize数据和方
  法在其他用途中的应用。

* gh-104499: 修复 Tk Aqua 8.7 的补全功能（当前为空白）。

* gh-104496: About 现在会打印 tcl 和 tk 的版本（如果不同）（预期某天会
  实现）。

* gh-88496: 修复 macOS 上的 IDLE 测试挂起问题。


Python 3.11.3 final
===================

*发布日期：2023-04-04*


安全性
------

* gh-101727: Updated the OpenSSL version used in Windows and macOS
  binary release builds to 1.1.1t to address CVE-2023-0286,
  CVE-2022-4303, and CVE-2022-4303 per the OpenSSL 2023-02-07 security
  advisory.

* gh-101283: "subprocess.Popen" 现在使用更安全的方法在 "shell=True" 启
  动时查找 "cmd.exe"。由 Eryk Sun 基于 Oleg Iarygin 的补丁提供补丁。


核心与内置函数
--------------

* gh-101975: 修复了跟踪条目上的 "stacktop" 值，以避免垃圾收集时的损坏
  。

* gh-102701: 修复创建非常大的字典时的溢出问题。

* gh-102416: 不记忆解析器中自动生成的错误循环规则。由 Pablo Galindo 提
  供补丁。

* gh-102356: 修复了一个在释放深度嵌套的过滤器对象时导致崩溃的 bug。由
  Marta Gómez Macías 提供补丁。

* gh-102397: 修复垃圾收集过程中信号处理竞争条件导致的段错误。由 Kumar
  Aditya 提供补丁。

* gh-102281: 修复fileutils中潜在的nullptr解引用和未初始化内存使用问题
  。由Max Bachmann提交补丁。

* gh-102126: 修复在关闭时清除线程状态时如果任何终结器尝试获取运行时头
  锁导致的死锁。由Kumar Aditya提供补丁。

* gh-102027: 修复 "_blake2" 内部模块中的SSE2和SSE3检测。由Max Bachmann
  提交补丁。

* gh-101967: 修复在 "positional_only_passed_as_keyword" 函数中创建新列
  表时可能发生的段错误。

* gh-101765: 修复在迭代 "__reduce__" 中当 "builtins.__dict__" 键的内部
  访问改变迭代对象时的SystemError / 段错误。

* gh-101696: 在 "_PyStaticType_Dealloc" 中使静态类型的类型版本标签无效
  ，避免因虚假缓存命中导致解释器崩溃的错误。由 Kumar Aditya 提供补丁。


库
--

* gh-102549: 不再忽略成员类型创建中的异常。

* gh-102947: 当在非数据类上调用 "dataclasses.fields()" 时，改进回溯。
  由Alex Waygood提交补丁。

* gh-102780: "asyncio.Timeout" 上下文管理器现在即使在由于任务取消而执
  行清理时也能可靠工作。之前在这种情况下它可能会引发 "CancelledError"
  而不是 "TimeoutError"。

* gh-88965: typing: 修复了与自定义类中基于 "ParamSpec" 泛型的替换相关
  的 bug。之前，如果 "ParamSpec" 被替换为一个自身包含 "TypeVar" 的参数
  列表，参数列表中的 "TypeVar" 将无法被后续替换。现在这个问题已经修复
  。

  由 Nikita Sobolev 提供补丁。

* gh-101979: 修复了一个错误，其中
  "argparse.ArgumentParser.add_argument()" 的 "metavar" 参数中的括号被
  丢弃。由 Yeojin Kim 提供补丁。

* gh-102179: 修复 "os.dup2()" 对于负文件描述符的错误消息。

* gh-101961: 对于二进制模式，"fileinput.hookcompressed()" 即使值为
  "None" 也不设置 "encoding" 值。由 Gihwan Kim 提供补丁。

* gh-101936: 如果 "HTTPError" 初始化时没有指定 "fp" 参数，则 "fp" 的默
  认值变为 "io.BytesIO"。由 Long Vo 提供补丁。

* gh-102069: 修复自定义数据类的 "__weakref__" 描述符生成。

* gh-101566: In zipfile, apply fix for extractall on the underlying
  zipfile after being wrapped in "Path".

* gh-101892: 可调用迭代器在可调用对象耗尽迭代器但忘记返回哨兵值或引发
  "StopIteration" 时不再引发 "SystemError"。

* gh-97786: 修复浮点数到时间转换在极端情况下潜在的未定义行为。

* gh-101517: 修复了 "bdb" 使用 "lineno=None" 与 "linecache" 查找源代码
  行时导致未处理异常失败的 bug。

* gh-101673: 修复 "pdb" 中的一个错误，其中 "ll" 清除对局部变量的更改。

* gh-96931: 修复了 "ssl.SSLSocket.shared_ciphers()" 返回不正确结果的问
  题。

* gh-88233: 无论 "extra" 字段相对于 zip64 "extra" 的顺序如何，都能正确
  保留 "zipfile" 中的 "extra" 字段。

* gh-96127: "inspect.signature" was raising "TypeError" on call with
  mock objects. Now it correctly returns "(*args, **kwargs)" as
  infered signature.

* gh-95495: When built against OpenSSL 3.0, the "ssl" module had a bug
  where it reported unauthenticated EOFs (i.e. without close_notify)
  as a clean TLS-level EOF. It now raises "SSLEOFError", matching the
  behavior in previous versions of OpenSSL. The "options" attribute on
  "SSLContext" also no longer includes "OP_IGNORE_UNEXPECTED_EOF" by
  default. This option may be set to specify the previous OpenSSL 3.0
  behavior.

* gh-94440: 修复了 "concurrent.futures.process" 中的一个错误，即在快速
  提交并取消一个 future 后，"ProcessPoolExecutor" 关闭可能会挂起。


文档
----

* gh-103112: 向 "http.client.HTTPResponse.read()" 添加了文档字符串以修
  复 "pydoc" 输出。

* gh-85417: 更新 "cmath" 文档以澄清分支切割的行为。

* gh-97725: 修复 "asyncio.Task.print_stack()" 对于 "file=None" 的描述
  。由Oleg Iarygin提供补丁。


测试
----

* gh-102980: 提高了 "pdb" 的测试覆盖率。

* gh-102537: 调整了 "test_zoneinfo.TzPathTest.python_tzpath_context"
  中的错误处理策略。由 Paul Ganssle 提供补丁。

* gh-89792: "test_tools" 现在在 "freeze" 测试期间通过忽略git元数据和其
  他工件，将源数据复制到临时目录的数量减少了10倍。它还基于os.cpu_count
  而不是硬编码为8核心来限制其Python构建并行性。

* gh-101377: 改进了 calendar 的 test_locale_calendar_formatweekday。


构建
----

* gh-102711: 修复 "-Wstrict-prototypes" 编译器警告。


Windows
-------

* gh-101849: 确保安装程序能够正确升级现有的 "py.exe" 启动器安装。

* gh-101763: 更新Windows安装包中捆绑的libffi版本至3.4.4。

* gh-101759: 更新Windows安装程序中的SQLite至3.40.1版本。

* gh-101614: 正确处理引用 "python3_d.dll" 的调试二进制文件构建的扩展。


macOS
-----

* gh-103207: Add instructions to the macOS installer welcome display
  on how to workaround the macOS 13 Ventura “The installer encountered
  an error” failure.

* gh-101759: 更新macOS安装程序中的SQLite至3.40.1版本。


Python 3.11.2 final
===================

*发布日期：2023-02-07*


核心与内置函数
--------------

* gh-92173: 修复 "PyEval_EvalCodeEx()" 中的 "defs" 和 "kwdefs" 参数以
  及该函数中的引用泄漏问题。

* gh-101400: 修复不在循环中的 "continue" 或 "break" 异常消息中的错误行
  号。由 Donghee Na 提供补丁。

* gh-101372: 修复 "is_normalized()" 以正确处理 UCD 3.2.0 的情况。由
  Donghee Na 提供补丁。

* gh-101046: 修复解析器在引发 "MemoryError" 时可能的内存泄漏。由 Pablo
  Galindo 提供补丁。

* gh-101037: 修复值为零的 "int" 子类实例可能的内存分配不足问题。

* gh-100942: 修复了当属性子类覆盖 "__new__" 方法以返回非属性实例时，在
  property.getter/setter/deleter 中发生的段错误。

* gh-100892: 修复在清除 "threading.local" 时迭代线程状态的竞争。由
  Kumar Aditya 提供补丁。

* gh-100776: 修正了 "input()" 的 "__text_signature__" 中误导性的默认值
  。

* gh-100637: Fix "int.__sizeof__()" calculation to include the 1
  element ob_digit array for 0 and False.

* gh-100649: 在fork后更新PyThreadState的native_thread_id字段。

* gh-100374: 修正了 "socket.getfqdn()" 的错误结果和延迟。由Dominic
  Socular提供的补丁。

* gh-99110: 在 frameobject.c 中初始化 frame->previous，以修复访问由
  "PyFrame_New()" 创建的帧时的段错误。

* gh-100050: 在标记器中搜索不匹配的括号时，尊重现有的错误。由 Pablo
  Galindo 提供补丁

* bpo-32782: 从 "ctypes" 长度为0的数组构建 "memoryview" 时，现在会报告
  正确的itemsize，而不是总是给出0的值。


库
--

* gh-101541: [Enum] - 修复伪标志创建。

* gh-101326: 修复了在将 "None" 作为第二个或第三个参数传递给
  "FutureIter.throw" 时的回归问题。

* gh-100795: 在 "socket" 中避免潜在的意外 "freeaddrinfo" 调用（双重释
  放），当 libc 的 "getaddrinfo()" 实现在返回错误时在输出指针中留下垃
  圾时。原始由 Sergey G. Brester 提供补丁。

* gh-101143: 在 "asyncio.base_events.BaseEventLoop._add_callback" 中移
  除对 "TimerHandle" 的未使用引用。

* gh-101144: 使 "zipfile.Path.open()" 和 "zipfile.Path.read_text()" 也
  接受 "encoding" 作为位置参数。这是 Python 3.9 及更早版本的行为。3.10
  引入了回归，将其作为位置参数提供会导致 "TypeError"。

* gh-101015: 修复 "typing.get_type_hints()" 在 "'*tuple[...]'" 和
  "*tuple[...]" 上的问题。它不应该丢弃 "Unpack" 部分。

* gh-100573: 修复 Windows 上 "asyncio" 的一个关于命名管道的 bug，其中
  客户端对管道执行 "os.stat()" 会导致服务器中禁用未来请求服务的错误。

* gh-100805: 修改 "random.choice()" 实现，使其再次与NumPy数组一起工作
  。

* gh-90104: 如果数据类字段定义有循环引用，则在 "repr" 上避免
  RecursionError。

* gh-100750: 在平台中将 encoding 关键字参数传递给子进程

* gh-100689: 通过静态分配 "PyExpat_CAPI" 胶囊来修复 "pyexpat" 中的崩溃
  。

* gh-100740: 修复 "unittest.mock.Mock" 不尊重以 "assert" 前缀开头的属
  性名的规范。

* gh-86508: 修复 "asyncio.open_connection()" 跳过绑定到不同族的本地地
  址。由 Kumar Aditya 提供补丁。

* gh-100287: 修复了 "unittest.mock.seal()" 与
  "unittest.mock.AsyncMock" 的交互问题。

* gh-100474: "http.server" 现在在尝试提供索引页面之前会检查它是否确实
  是一个常规文件。这避免了名为 "index.html" 的目录引起的问题。

* gh-100160: Remove any deprecation warnings in
  "asyncio.get_event_loop()". They are deferred to Python 3.12.

* gh-96290: 修复 "ntpath.splitdrive()" 中部分和无效 UNC 驱动器的处理，
  以及在非 Windows 系统上的 "ntpath.normpath()"。现在 "splitdrive()"
  认为诸如 '\server' 和 '\' 的路径仅包含驱动器，因此在非 Windows 系统
  上不会被 "normpath()" 修改。Windows 系统上 "normpath()" 的行为不受影
  响，因为使用的是原生 OS API。由 Eryk Sun 提供补丁，Barney Gale 有贡
  献。

* gh-78878: 修复了创建 "_ctypes.CField" 实例时崩溃的问题。

* gh-99952: 修复 "ctypes.Structure" 中 "from_param()" 结果大于 C 指针
  时的引用计数不足问题。

* gh-100133: 修复了 "asyncio" 中的一个回归问题，其中子进程有时会丢失从
  管道接收的数据。

* gh-100098: 修复了 "tuple" 子类在被用作枚举值时被强制转换为 "tuple"
  的问题。

* gh-98778: 更新 "HTTPError"，使其即使在 "fp" 为 "None" 时也能正确初始
  化。由 Donghee Na 提供补丁。

* gh-83035: 修复 "inspect.getsource()" 对带有嵌套括号的装饰器调用的处
  理。

* gh-99576: 修复 "LWPCookieJar" 和 "MozillaCookieJar" 的 ".save()" 方
  法：在重复保存时未截断保存的文件。

* gh-99433: 修复模块中对 "types.MethodWrapperType" 的 "doctest" 失败。

* gh-99240: 通过将内存清理提取到新的 "post_parsing" 部分来修复
  Argument Clinic 的 "str_converter" 中的双重释放错误。

* gh-64490: 修复 Argument Clinic 中参数被打包到元组时的引用计数错误。

* gh-85267: 对 "inspect.signature()" 处理 "__text_signature__" 的多项
  改进。 - 修复了 "inspect.signature()" 丢弃参数的情况 - 修复了
  "inspect.signature()" 引发 "tokenize.TokenError" 的情况 - 允许
  "inspect.signature()" 理解涉及常量二元运算的默认值 -
  "inspect.signature()" 文档说明仅引发 "TypeError" 或 "ValueError"，但
  有时会引发 "RuntimeError"。这些情况现在会引发 "ValueError" - 移除了
  一个死代码路径

* gh-95882: 修复了 "asynccontextmanager()" 中的3.11回归问题，该问题导
  致它传播带有不正确回溯的异常；并修复了 "contextmanager()" 中的3.11回
  归问题，该问题导致它为 "StopIteration" 传播带有不正确回溯的异常。

* bpo-44817: 在使用 ntpath.realpath() 时忽略 WinError 53
  (ERROR_BAD_NETPATH)、65 (ERROR_NETWORK_ACCESS_DENIED) 和 161
  (ERROR_BAD_PATHNAME)。

* bpo-40447: 在 "compileall.compile_file()" 和
  "compileall.compile_dir()" 的 "stripdir" 参数中接受 "os.PathLike" (
  如 "pathlib.Path") 。

* bpo-36880: 修复了当 "ctypes" 回调返回类型为 "py_object" 且返回
  "None" 时的引用计数问题，该问题可能导致崩溃。


文档
----

* gh-100616: 在 "curses" 模块中，为 "curses.window.vline()" 函数记录现
  有的 "attr" 参数。

* gh-100472: 从文档中移除关于 "compileall.compile_dir()" 和
  "compileall.compile_file()" 函数的 "stripdir"、"prependdir" 和
  "limit_sl_dest" 参数可以是 "bytes" 类型的声明。

* gh-99931: 使用 sphinxext-opengraph 生成 OpenGraph metadata。


测试
----

* gh-101334: "test_tarfile" 已更新，以便在高 UID 下运行时通过。

* gh-100454: 开始使用 OpenSSL 3.1.0-beta1 运行 SSL 测试。

* gh-96002: 为 Argument Clinic 添加功能测试。


构建
----

* gh-101522: 允许使用 MSBuild 属性覆盖 Windows 依赖项的版本和路径。


Windows
-------

* gh-101543: 确保注册表中的安装路径仅在标准库尚未通过任何其他方式定位
  时使用。

* gh-101467: "py.exe" 启动器现在在仅安装单个运行时正确过滤。它还正确处
  理标签上的前缀匹配，以便 "-3.1" 不匹配 "3.11"，但仍然匹配 "3.1-32"。

* gh-101135: 恢复从 "py.exe" 启动器启动旧版 32 位版本的能力，当同一版
  本的 32 位和 64 位安装都可用时。

* gh-82052: 修复了向控制台屏幕一次性写入超过 32K Unicode 输出可能导致
  乱码的问题。

* gh-100320: 确保在从依赖现有安装提供其模块和标准库副本的不同 Python
  副本启动时，使用安装中的 "PythonPath" 注册表键。

* gh-100247: 恢复对 "py.exe" 启动器在其配置文件中使用完整命令名查找
  shebang 命令的支持。

* gh-100180: 将 Windows 安装程序更新至 OpenSSL 1.1.1s。

* bpo-43984: 现在，"winreg.SetValueEx()" 在转换错误的情况下会保持目标
  值不变。此前，此类错误会写入 "-1"。


macOS
-----

* gh-100180: 将 macOS 安装程序更新至 OpenSSL 1.1.1s


工具/示例
---------

* bpo-45256: 修复了一个在 "python-gdb.py" 中当 "py-locals" 在没有帧的
  情况下使用时会导致抛出 "AttributeError" 的 bug。

* gh-100342: 在 Argument Clinic 的 "*args" 解析中添加了对可能分配失败
  的缺失 "NULL" 检查。

* gh-64490: Argument Clinic varargs 错误修复

  * 修复 "_PyArg_UnpackKeywordsWithVararg()" 中的越界错误。

  * 修复了允许在clinic.py中有多个varargs的错误检查。

  * 修复生成代码中 "noptargs" 的错误计算。

  * 当存在vararg参数但没有可选参数时，不生成 "noptargs"。


C API
-----

* gh-99240: 在参数解析中，释放新分配的内存后，将其指针重置为 NULL。


Python 3.11.1 final
===================

*发布日期：2022-12-06*


安全性
------

* gh-100001: "python -m http.server" 不再允许垃圾请求中发送的终端控制
  字符被打印到 stderr 服务器日志中。

  This is done by changing the "http.server" "BaseHTTPRequestHandler"
  ".log_message" method to replace control characters with a "\xHH"
  hex escape before printing.

* gh-87604: 避免通过 "gc" 模块发布每个解释器的活动审计钩子列表

* gh-98433: The IDNA codec decoder used on DNS hostnames by "socket"
  or "asyncio" related name resolution functions no longer involves a
  quadratic algorithm. This prevents a potential CPU denial of service
  if an out-of-spec excessive length hostname involving bidirectional
  characters were decoded. Some protocols such as "urllib" http "3xx"
  redirects potentially allow for an attacker to supply such a name.

* gh-98739: 更新捆绑的 libexpat 到 2.5.0

* gh-97612: Fix a shell code injection vulnerability in the "get-
  remote-certificate.py" example script. The script no longer uses a
  shell to run "openssl" commands. Issue reported and initial fix by
  Caleb Shortt. Patch by Victor Stinner.


核心与内置函数
--------------

* gh-99886: Fix a crash when an object which does not have a
  dictionary frees its instance values.

* gh-99891: 修复了分词器中的一个 bug，该 bug 在显示源代码第一行发生的
  语法警告时可能导致无限递归。由 Pablo Galindo 提供补丁。

* gh-99729: 修复一个问题，该问题可能导致帧在销毁时对 Python 代码可见，
  可能引发内存损坏或解释器硬崩溃。

* gh-99578: Fix a reference bug in "_imp.create_builtin()" after the
  creation of the first sub-interpreter for modules "builtins" and
  "sys". Patch by Victor Stinner.

* gh-99581: Fixed a bug that was causing a buffer overflow if the
  tokenizer copies a line missing the newline caracter from a file
  that is as long as the available tokenizer buffer. Patch by Pablo
  galindo

* gh-99553: 修复 "ExceptionGroup" 子类可以包装 "BaseException" 的 bug
  。

* gh-99370: 为从非安装的 python 在 POSIX 平台上创建的 venv 修复 zip 路
  径。

* gh-99298: 修复可能导致某些字节码指令错误处理的问题。

* gh-99205: 修复了阻止 "PyThreadState" 和 "PyInterpreterState" 内存被
  正确释放的问题。

* gh-99181: 修复 "except*" 中不可哈希异常导致的失败。

* gh-99204: 修复当在POSIX虚拟环境中使用python二进制副本且基础安装未提
  供venv使用的可执行名称时，"sys._base_executable" 的计算问题。计算将
  回退到替代名称（"python<MAJOR>", "python<MAJOR>.<MINOR>"）。

* gh-96055: 更新 "faulthandler" 以发出包含正确意外信号号的错误消息。由
  Donghee Na提供补丁。

* gh-99153: 修复同时包含 "except" 和 "except*" 的 "try" 块的
  "SyntaxError" 位置。

* gh-99103: 修复当源代码行包含Unicode字符时，专用回溯锚点的错误报告位
  置。

* gh-98852: 修复包含裸泛型类型或类似 "TypeVar" 类型的类型别名的订阅：
  例如``tuple[A, T][int]``和 "tuple[TypeVar, T][int]"，其中 "A" 是泛型
  类型，"T" 是类型变量。

* gh-98925: Lower the recursion depth for marshal on WASI to support
  wasmtime 2.0/main.

* gh-98783: 修复在调试模式下使用 "str" 子类而不是 "str" 本身时的多次崩
  溃。

* gh-99257: 修复了一个问题，即当通过无效类型的实例访问时，成员描述符（
  如 "__slots__" 的描述符）可能会行为不正确或崩溃，而不是引发
  "TypeError"。

* gh-98374: 抑制help()命令无效查询时的ImportError。由Donghee Na提供补
  丁。

* gh-98415: 修复了在某些操作系统上对 "uuid" 的 MAC 地址检测。补丁由
  Chaim Sanders 提供

* gh-92119: 在从 "ctypes" 调用引发错误时，打印异常类名而不是其字符串表
  示。

* gh-96078: "os.sched_yield()" 现在在调用 sched_yield(2) 时释放 GIL。
  由 Donghee Na 提供补丁。

* gh-93354: Fix an issue that could delay the specialization of
  "PRECALL" instructions.

* gh-97943: Bugfix: "PyFunction_GetAnnotations()" should return a
  borrowed reference. It was returning a new reference.

* gh-97779: 确保所有Python框架对象都由“完整”框架支持。

* gh-97591: 修复了 "Exception.__setstate__()" 中缺少的incref/decref对
  。补丁由Ofey Chan提供。

* gh-94526: 修复用于初始化Python启动时 "sys.path" 的Python路径配置。路
  径不再编码为UTF-8/strict以避免如果包含代理字符时出现编码错误（字节路
  径使用surrogateescape错误处理程序解码）。由Victor Stinner提供补丁。

* gh-95921: 修复用作分支条件的链式比较的过于宽泛的源位置信息。

* gh-96387: 在 Python 退出时，有时持有 GIL 的线程会永远等待一个（通常
  是守护线程）请求放弃 GIL 的线程，而该线程已经退出。为了修复这个竞态
  条件，请求放弃 GIL 的线程现在在退出前重置其请求。问题由 Mingliang
  ZHAO 发现并分析。由 Victor Stinner 提供补丁。

* gh-96864: 修复当操作码跟踪启用时，行跟踪事件引发异常可能导致断言失败
  、致命错误或 "SystemError" 的问题。

* gh-96678: 修复 C 代码中的空指针算术未定义行为。

* gh-96754: 确保所有创建的帧对象都是从有效的解释器帧创建的。防止回溯和
  信号处理程序中出现无效帧的可能性。

* gh-95196: 禁用对 C 实现的类方法描述符的错误 pickling。

* gh-96005: On WASI "ENOTCAPABLE" is now mapped to "PermissionError".
  The "errno" modules exposes the new error number. "getpath.py" now
  ignores "PermissionError" when it cannot open landmark files
  "pybuilddir.txt" and "pyenv.cfg".

* gh-93696: 允许 "pdb" 定位标准库中冻结模块的源代码。

* bpo-31718: 当调用未初始化的 "io.IncrementalNewlineDecoder" 对象的方
  法时，抛出 "ValueError" 而不是 "SystemError"。由 Oren Milman 提供补
  丁。

* bpo-38031: 修复 "io.FileIO" 中当开启器返回无效文件描述符时可能出现的
  断言失败。


库
--

* gh-100001: Also escape s in the http.server
  BaseHTTPRequestHandler.log_message so that it is technically
  possible to parse the line and reconstruct what the original data
  was.  Without this a xHH is ambiguious as to if it is a hex
  replacement we put in or the characters r"x" came through in the
  original request line.

* gh-93453: "asyncio.get_event_loop()" now only emits a deprecation
  warning when a new event loop was created implicitly. It no longer
  emits a deprecation warning if the current event loop was set.

* gh-51524: 修复在调用 trace.CoverageResults 时使用有效的 infile 时的
  错误。

* gh-99645: 修复 "unittest.TestCase" 中处理类清理时的错误。现在
  "addClassCleanup()" 为不同的 "TestCase" 子类使用单独的列表，而
  "doClassCleanups()" 只清理特定的类。

* gh-97001: 在调用 termios API 时释放 GIL 以避免阻塞线程。

* gh-99341: 修复 "ast.increment_lineno()"，使其在更改行号时也能覆盖
  "ast.TypeIgnore"。

* gh-99418: 修复 "urllib.parse.urlparse()" 中的错误，该错误会导致以数
  字、加号或减号开头的 URL 方案被错误解析。

* gh-99382: 在包含 "TypeVarTuple" 和一个或多个 "TypeVar" 的用户泛型中
  检查替换中的参数数量。

* gh-99379: 修复泛型别名中 "ParamSpec" 后跟 "TypeVarTuple" 的替换问题
  。

* gh-99344: 修复用户泛型中 "TypeVarTuple" 和 "ParamSpec" 一起替换的问
  题。

* gh-74044: 修复了 "inspect.signature()" 报告装饰方法参数不正确的问题
  。

* gh-99275: 修复 "ctypes" 中的 "SystemError"，当 "__initsubclass__" 期
  间未设置异常时。

* gh-99277: 移除 "asyncio.sslproto" 中旧版本的
  "_SSLProtocolTransport.get_write_buffer_limits"。

* gh-99248: 修复 verify() 中负数失败的问题。

* gh-99155: 修复 "statistics.NormalDist" 使用 "0" 和 "1" 协议时的
  pickle 问题。

* gh-93464: "enum.auto()" 现在与其他赋值值结合使用时能正确激活。例如，
  "ONE = auto(), 'some text'" 现在会评估为 "(1, 'some text')"。

* gh-99134: 将捆绑的 pip 更新到版本 22.3.1。

* gh-83004: Clean up refleak on failed module initialisation in
  "_zoneinfo"

* gh-83004: Clean up refleaks on failed module initialisation in in
  "_pickle"

* gh-83004: Clean up refleak on failed module initialisation in "_io".

* gh-98897: 修复当两个点不具有相同维度时 "math.dist()" 中的内存泄漏。
  由 Kumar Aditya 提供补丁。

* gh-98706: [3.11] Applied changes from importlib_metadata 4.11.4
  through 4.13, including compatibility and robustness fixes for
  "Distribution" objects without "_normalized_name", disallowing
  invalid inputs to "Distribution.from_name", and refined behaviors in
  "PathDistribution._name_from_stem" and
  "PathDistribution._normalized_name".

* gh-98793: 修复 "_overlapped.WSAConnect()" 和
  "_overlapped.Overlapped.WSASendTo()" 函数中的参数类型检查。

* gh-98744: 防止在 "traceback" 中检索包含某些特定 Unicode 字符的某些源
  文件的字节偏移时崩溃。

* gh-98740: 修复 "re" 模块中的内部错误，该错误在极少数情况下阻止编译包
  含 条件表达式 而没有 "else" 分支的正则表达式。

* gh-98703: 修复 "asyncio.StreamWriter.drain()" 以在 Windows 上仅调用
  "protocol.connection_lost" 回调一次。

* gh-98624: 向 unittest.mock.NonCallableMock 添加互斥锁以保护对模拟属
  性的并发访问。

* gh-89237: 修复了在 Windows 上使用 "ProactorEventLoop" 时，"asyncio"
  中 "subprocess.wait_closed()" 的挂起问题。由 Kumar Aditya 提供补丁。

* gh-98458: 修复 unittest 中当引发自引用链式异常时的无限循环问题

* gh-97928: "tkinter.Text.count()" 现在会对以 "-" 开头的选项抛出异常，
  而不是静默忽略它们。

* gh-97966: 在 "uname_result" 上，恢复了 "_fields" 和 "_asdict" 包括所
  有六个属性（包括 "processor"）的期望。

* gh-98307: 向 "SysLogHandler" 添加了一个 "createSocket()" 方法。

* gh-96035: 修复了 "urllib.parse.urlparse()" 中的一个错误，该错误导致
  某些包含空格、下划线、加号和减号或非ASCII数字的端口号被错误地接受。

* gh-98251: Allow "venv" to pass along "PYTHON*" variables to
  "ensurepip" and "pip" when they do not impact path resolution

* gh-98178: 在 macOS 上，修复 "syslog.syslog()" 在多线程应用程序中的崩
  溃问题。在 macOS 上，libc "syslog()" 函数不是线程安全的，因此
  "syslog.syslog()" 不再释放 GIL 来调用它。由 Victor Stinner 提供补丁
  。

* gh-96151: 允许 "BUILTINS" 作为冻结数据类的有效字段名。

* gh-87730: 在 urllib FTP 支持中一致地包装网络错误，因此当网络可用但无
  法访问公共互联网时，测试套件不会失败。

* gh-98086: 确保 "patch.dict()" 可以应用于异步函数。

* gh-90985: 在 3.11 早期版本中，我们弃用了
  "asyncio.Task.cancel("message")"。我们意识到我们过于严厉，因此取消了
  弃用。

* gh-97837: 更改 "unittest" 中的弃用警告消息，从

  "返回一个值!=None 已被弃用"

  to

  "从测试用例返回一个非 None 的值已被弃用"

* gh-97825: 修复了当 "subprocess.check_output()" 与参数 "input=None"
  以及 *encoding* 或 *errors* 参数一起使用时引发的 "AttributeError"。

* gh-82836: Fix "is_private" properties in the "ipaddress" module.
  Previously non-private networks (0.0.0.0/0) would return True from
  this method; now they correctly return False.

* gh-96827: 当默认执行器清理被延迟到事件循环关闭之后（例如，由于键盘中
  断的结果）时，避免来自 "asyncio" 的虚假回溯。

* gh-97592: 当传递恶意参数时，避免 C 版本的
  "asyncio.Future.remove_done_callback()" 崩溃。

* gh-97639: 从 "tabnanny" 中移除 "tokenize.NL" 检查。

* gh-73588: 修复 "tkinter.Checkbutton" 的默认名称生成。以前，如果未指
  定参数 "name" 和 "variable"，不同父部件中的复选框可以有相同的短名称
  并共享相同的状态。现在它们是全局唯一的。

* gh-97005: 将捆绑的 libexpat 更新到 2.4.9

* gh-85760: 修复 "asyncio" 中的竞争条件，其中 "process_exited()" 在
  "pipe_data_received()" 之前被调用，导致输出不一致。补丁由 Kumar
  Aditya 提供。

* gh-96819: 修复 "multiprocessing.resource_tracker" 中的检查，确保写入
  管道的长度不大于 "PIPE_BUF"。

* gh-96741: 修正了数据类属性 "pstats.FunctionProfile.ncalls" 的类型注
  解为 "str"。

* gh-95987: 修复 "Any" 子类的 "repr"。

* gh-96388: 解决 "socket" 的 "__repr__" 中缺少的套接字函数问题。

* gh-96073: 在 "inspect" 中，修复格式化注解中过度替换 ""typing."" 的问
  题。

* gh-96192: Fix handling of "bytes" *path-like objects* in
  "os.ismount()".

* gh-96052: 在 "codeop.compile_command()" 中检查不完整输入时修复处理编
  译器警告（SyntaxWarning 和 DeprecationWarning）的问题。以前它会发出
  警告并引发 SyntaxError。现在对于不完整输入，它总是返回 "None"，而不
  发出任何警告。

* gh-88863: 为了避免 "asyncio.open_connection()" 引发时出现明显的内存
  泄漏，打破由局部异常和 future 实例（其成员变量为异常实例）生成的引用
  循环。由 Dong Uk, Kang 提供补丁。

* gh-91212: 修复当追踪器关闭时 turtle 窗口的闪烁问题。由 Shin-myoung-
  serp 提供补丁。

* gh-88050: 修复 "asyncio" 子进程传输，以便在进程被阻塞时干净地杀死进
  程，并避免在循环关闭时出现 "RuntimeError"。由 Kumar Aditya 提供补丁
  。

* gh-93858: 防止在嵌套的 fish 实例中激活 venv 时出错。

* gh-91078: "TarFile.next()" 现在在调用空的 tarfile 时返回 "None"。

* bpo-47220: 文档化 "WeakMethod" 的可选 *callback* 参数。由 Géry Ogam
  提供补丁。

* bpo-46364: 限制使用套接字而不是管道作为 "asyncio" 创建的子进程的标准
  输入，仅限于 AIX 平台。

* bpo-38523: "shutil.copytree()" 现在递归应用
  *ignore_dangling_symlinks* 参数。

* bpo-36267: 修复了当 "store_true" 动作被赋予显式参数时，在
  "argparse.ArgumentParser" 中出现的 IndexError。


文档
----

* gh-92892: 文档说明在 macOS/arm64（以及其他可能的平台）上使用 ctypes
  调用可变参数函数需要特别注意。

* gh-85525: 移除额外的行

* gh-95588: 澄清了 "ast" 文档中关于 "ast.literal_eval()" 对不可信输入“
  安全”使用的冲突建议，同时警告它可能会崩溃进程。后一种说法是正确的，
  并且被认为在不适合 bugfix 的大量工作下无法修复。因此我们保留警告，不
  再声称 "literal_eval" 是安全的。

* bpo-41825: 重构了 "os.wait*" 系列函数的文档，并通过更多解释可能的参
  数常量改进了 "os.waitid()" 的文档。


测试
----

* gh-99892: 如果无法从 pythontest.net 下载 NormalizationTest.txt 文件
  ，则跳过 test_unicodedata 的 test_normalization()。由 Victor Stinner
  提供补丁。

* gh-99934: 在（32 位）x86 上修正 test_marsh：test_deterministic sets
  失败。

* gh-99659: "test_sqlite3" 中的可选大内存测试现在在传递过大的字符串和/
  或 blob 时捕获正确的 "sqlite.DataError" 异常类型。

* gh-98713: 修复了 "typing" 测试中的一个错误，该错误中一个依赖 CPython
  特定实现细节的测试未被装饰为 "@cpython_only"，也未在其他实现上跳过。

* gh-87390: 为 PEP 646 添加了星号解包测试，以及其他一些杂项 PEP 646 测
  试。

* gh-96853: 将 "Py_Initialize" (以及 "Py_InitializeEx") 的显式覆盖添加
  回嵌入测试（Python 3.11 中所有其他嵌入测试已迁移到
  "Py_InitializeFromConfig"）。

* bpo-34272: 一些 C API 测试被移到了新的 Lib/test/test_capi/ 目录。


构建
----

* gh-99086: 修复 **configure** 检查中的 "-Wimplicit-int"、"-Wstrict-
  prototypes" 和 "-Wimplicit-function-declaration" 编译器警告。

* gh-99337: 修复在 macOS 上使用 GCC 12 时的编译问题。

* gh-99086: 修复了在 **configure** 检查 "PTHREAD_SCOPE_SYSTEM" 时的
  "-Wimplicit-int" 编译器警告。

* gh-98872: 修复了Python 3.11中 "Programs/_freeze_module.c" 可能存在的
  文件描述符泄漏问题。

* gh-99016: 修复了使用 "PYTHON_FOR_REGEN=python3.8" 时的构建问题。

* gh-97731: 为 "make docclean" 指定了源位置的完整路径（跨构建所需）。

* gh-98707: Don't use vendored "libmpdec" headers if "--with-system-
  libmpdec" is passed to **configure**. Don't use vendored "libexpat"
  headers if "--with-system-expat" is passed to **!configure**.

* gh-96761: 修复 **_bootstrap_python** 的 clang 编译器构建过程，如果应
  用了 LTO 优化。由 Matthias Görgens 和 Donghee Na 提供补丁。

* gh-96883: 浏览器的 "wasm32-emscripten" 构建现在包括
  "concurrent.futures" 用于 "asyncio" 和 "unittest.mock"。

* gh-84461: "wasm32-emscripten" 平台不再构建 "resource" 模块，
  "getresuid()"，"getresgid()"，以及它们的设置器。这些 API 是存根且不
  可用。

* gh-94280: 在Windows上更新了pegen重新生成脚本，以查找并使用Python 3.9
  或更高版本。在此之前，pegen重新生成已经要求3.9或更高版本，但脚本可能
  使用了较低版本的Python。


Windows
-------

* gh-99345: 使用更快的初始化函数来检测Windows Store包的安装位置

* gh-98629: 修复Windows上 "sys.version" 和 "sys._git" 的初始化问题

* gh-99442: 修复当 "argv[0]" 不包含文件扩展名时 适用于Windows的Python
  启动器 中的处理问题。

* gh-98689: Update Windows builds to zlib v1.2.13.  v1.2.12 has
  CVE-2022-37434, but the vulnerable "inflateGetHeader" API is not
  used by Python.

* gh-98790: 假设缺失的 "DLLs" 目录意味着标准扩展模块位于可执行文件的目
  录中。

* gh-98745: 更新 "py.exe" 启动器，默认安装3.11，按请求安装3.12。

* gh-98692: 修复 适用于Windows的Python启动器 忽略无法识别的shebang行而
  不是将它们视为本地路径的问题。

* gh-94328: 更新Windows安装程序以使用SQLite 3.39.4。

* gh-97728: 修复了在Windows上 "os.system()" 和Windows特定模块（如
  "winreg"）中传递无效参数时使用未初始化变量可能导致的崩溃。

* gh-96965: 将libffi更新至3.4.3。

* gh-94781: Fix "pcbuild.proj" to clean previous instances of ouput
  files in "Python\deepfreeze" and "Python\frozen_modules" directories
  on Windows. Patch by Charlie Zhao.

* bpo-40882: 修复Windows上
  "multiprocessing.shared_memory.SharedMemory" 中的内存泄漏问题。


macOS
-----

* gh-87235: 在macOS上 "python3 /dev/fd/9 9</path/to/script.py" 对于任
  何超过几个字节的脚本都会失败。

* gh-98940: 修复 "Mac/Extras.install.py" 文件过滤器错误。

* gh-94328: 更新macOS安装程序至SQLite 3.39.4。


IDLE
----

* gh-97527: 修复了之前的一个 bug，该 bug 导致在运行 3.10.8、3.12.0a1
  和至少 Microsoft Python 3.10.2288.0 且未安装 Lib/test 包时，IDLE 无
  法启动。3.11.0 从未受到影响。


工具/示例
---------

* gh-95853: "wasm_build.py" 脚本现在预构建Emscripten端口，检查损坏的
  EMSDK版本，并警告关于pkg-config环境变量。

* gh-95853: 新工具 "Tools/wasm/wasm_builder.py" 自动化了在WebAssembly
  平台上构建CPython的配置、编译和测试步骤。

* gh-95731: 修复 "Tools/i18n/pygettext.py" 中模块文档字符串的处理。


C API
-----

* gh-98680: "PyBUF_*" 常量被标记为Python 3.11+的有限API的一部分。这些
  在3.11.0版本中可用，定义了 "Py_LIMITED_API" 为3.11，并且是使用缓冲区
  API所必需的。

* gh-98978: 修复在 "Py_SetPythonHome(NULL)"、"Py_SetProgramName(NULL)"
  和``_Py_SetProgramFullPath(NULL)``函数调用中的释放后使用问题。问题由
  Benedikt Reinartz报告，由Victor Stinner提供补丁。

* gh-96853: "Py_InitializeEx" 现在在初始化解释器后正确调用
  "PyConfig_Clear" (遗漏没有导致内存泄漏只是因为包装函数没有填充任何动
  态分配的配置字段)


Python 3.11.0 final
===================

*Release date: 2022-10-24*


安全性
------

* gh-97616: 修复列表乘以整数("list *= int")的问题：当新分配的长度接近
  最大大小时检测整数溢出。问题由Jordan Limor报告，由Victor Stinner提供
  补丁。

* gh-97514: 在Linux系统上，"multiprocessing" 模块恢复使用基于文件系统
  的Unix域套接字与 *forkserver* 进程通信，而不是使用Linux抽象套接字命
  名空间。只有选择使用 "forkserver"启动方法 的代码会受到影响。

  抽象套接字没有权限设置，可能允许同一`网络命名空间
  <https://man7.org/linux/man-pages/man7/network_namespaces.7.html>`_
  （通常是整个系统）内的任何用户向multiprocessing的 *forkserver* 进程
  注入代码。这是一个潜在的特权提升风险。基于文件系统的套接字权限将这一
  行为限制为 *forkserver* 进程的用户，这是Python 3.8及更早版本的默认行
  为。

  This prevents Linux CVE-2022-42919.


核心与内置函数
--------------

* gh-97002: 修复了一个问题，其中多个帧对象可能由同一个解释器帧支持，可
  能导致内存损坏和解释器的硬崩溃。

* gh-97752: 修复访问新创建的生成器或协程框架的 "f_back" 成员时可能出现
  的数据损坏或崩溃问题。

* gh-96975: 修复当调用 "PyEval_GetFrame()" 时最顶层的Python框架处于部
  分初始化状态时发生的崩溃。

* gh-96848: 修复命令行解析：当 "PYTHONINTMAXSTRDIGITS" 环境变量设置为
  有效限制时，拒绝没有值的 "-X int_max_str_digits" 选项（无效）。由
  Victor Stinner提供补丁。

* gh-96821: 修复 "_testcapimodule.c" 中的未定义行为。

* gh-95778: 当整数超过限制时引发 "ValueError" 时，在错误消息中提到
  "sys.set_int_max_str_digits()" 函数。由 Victor Stinner 提供补丁。

* gh-96587: 在 Python 3.11 之前的版本中，正确地针对异常组 (**PEP
  654**) 抛出 "SyntaxError"。

* bpo-42316: 记录一些需要括号的赋值表达式的地方。


库
--

* gh-98331: 将捆绑的 pip 和 setuptools 的副本分别更新到 22.3 和 65.5.0
  版本。

* gh-90985: 在 3.11 早期版本中，我们弃用了
  "asyncio.Task.cancel("message")"。我们意识到我们过于严厉，因此取消了
  弃用。

* gh-97545: 使 Semaphore 运行得更快。

* gh-96865: 修复 Flag 以使用边界 CONFORM

  这恢复了 Flag 以前的行为，即允许组合具有非顺序值的标志；例如。

  class Skip(Flag):         TWO = 2         EIGHT = 8

  Skip.TWO | Skip.EIGHT -> <Skip.TWO|EIGHT: 10>

* gh-90155: 修复当获取被取消时损坏的 "asyncio.Semaphore"。


文档
----

* gh-97741: 通过 "conf.py" 补丁修复了 c 域引用目标语法中的 "!"，使其按
  预期禁用引用目标解析。

* gh-93031: 更新教程介绍输出，以使用 3.10+ 的 SyntaxError 无效范围。


测试
----

* gh-95027: 在 Windows 上，当 Python 测试套件使用 "-jN" 选项运行时，现
  在将 ANSI 代码页用作 stdout 临时文件的编码，而不是使用可能导致解码错
  误的 UTF-8。补丁由 Victor Stinner 提供。


构建
----

* gh-96729: 确保使用 "Tools\msi\buildrelease.bat" 构建的 Windows 版本
  可以升级到官方 Python 版本，也可以从官方 Python 版本升级。


Windows
-------

* gh-98360: 修复了 "multiprocessing" 在Windows上从虚拟环境生成子进程的
  问题，以确保同样使用 "multiprocessing" 生成更多子进程的子进程能够识
  别它们处于虚拟环境中。

* gh-98414: Fix "py.exe" launcher handling of "-V:<company>/" option
  when default preferences have been set in environment variables or
  configuration files.

* gh-90989: Clarify some text in the Windows installer.


macOS
-----

* gh-97897: macOS 13 SDK 包含对 "mkfifoat" 和 "mknodat" 系统调用的支持
  。如果在使用 macOS 13 SDK 构建的 cpython 但在较早版本的 macOS 上运行
  时，使用 "dir_fd" 选项与 "os.mkfifo()" 或 "os.mknod()" 可能导致段错
  误。通过添加对这些系统调用的运行时支持检测（“弱链接”）来防止这种情况
  ，就像在 macOS 上对其他更新的系统调用所做的那样。


Python 3.11.0 release candidate 2
=================================

*Release date: 2022-09-11*


安全性
------

* gh-95778: Converting between "int" and "str" in bases other than 2
  (binary), 4, 8 (octal), 16 (hexadecimal), or 32 such as base 10
  (decimal) now raises a "ValueError" if the number of digits in
  string form is above a limit to avoid potential denial of service
  attacks due to the algorithmic complexity. This is a mitigation for
  CVE-2020-10735.

  This new limit can be configured or disabled by environment
  variable, command line flag, or "sys" APIs. See the integer string
  conversion length limitation documentation.  The default limit is
  4300 digits in string form.

  Patch by Gregory P. Smith [Google] and Christian Heimes [Red Hat]
  with feedback from Victor Stinner, Thomas Wouters, Steve Dower, Ned
  Deily, and Mark Dickinson.


核心与内置函数
--------------

* gh-96678: 修复 ceval.c 中的未定义行为情况。

* gh-96641: Do not expose "KeyWrapper" in "_functools".

* gh-96636: 确保跟踪 "sys.setrace()" 立即开启。在 3.11 的预发布版本中
  ，当在 "__del__" 方法或中断中开启跟踪时，可能会丢失一些跟踪事件。

* gh-96572: 修复跟踪引用构建模式中的释放后使用问题。由 Kumar Aditya 提
  供补丁。

* gh-96611: 当在多行字符串中加载包含无效 UTF-8 的文件时，会发出正确的
  SyntaxError。

* gh-96612: 确保不完整的帧不会出现在 tracemalloc 跟踪中。

* gh-96569: 通过添加 NULL 检查，移除两种未定义行为的情况。

* gh-96582: 修复 "_PyThread_CurrentFrames" 中可能的 "NULL" 指针解引用
  问题。由 Kumar Aditya 提供补丁。

* gh-96352: 修复 "AttributeError" 在 "object.__getattribute__()" 中缺
  少 "name" 和 "obj" 属性的问题。由 Philip Georgi 提供补丁。

* gh-96268: 加载包含无效 UTF-8 编码的文件现在会在正确的位置报告损坏的
  字符。

* gh-96187: 修复了一个导致 "_PyCode_GetExtra" 对于负索引返回垃圾值的
  bug。由 Pablo Galindo 提供补丁

* gh-96071: 修复了在分配新线程状态时 "PyGILState_Ensure()" 中的死锁问
  题。由 Kumar Aditya 提供补丁。

* gh-96046: "PyType_Ready()" 现在初始化 "ht_cached_keys" 并执行额外检
  查以确保类型对象正确配置。这避免了不使用常规 API 创建新类型的第三方
  包中的崩溃。

* gh-95818: 在 "PyThreadState_GetFrame()" 中跳过不完整的帧。

* gh-95876: 修复 "_PyPegen_raise_error_known_location" 中的格式字符串
  ，该字符串在某些64位系统上可能导致内存损坏。该函数在为Py_ssize_t参数
  构建元组时使用了 "i" (int) 而不是 "n" (Py_ssize_t) 。

* gh-95605: 修复将全空白字符串转换为 "float" 时错误消息内容误导性的问
  题。

* gh-94996: "ast.parse()" 在传递的 "feature_version" 小于 "(3, 8)" 时
  ，将不再解析带有位置唯一参数（positional-only params）的函数定义。由
  Shantanu Jain 提供补丁。


库
--

* gh-96700: Fix incorrect error message in the "io" module.

* gh-96652: 如果 "sigaction()" 函数不可用，则修复
  "faulthandler.register(signal, chain=True)" 的 faulthandler 实现：如
  果之前的信号处理器为 NULL，则不调用它。由 Victor Stinner 提供补丁。

* gh-68163: 修正 "numbers.Rational" 到 "float" 的转换。

* gh-96385: 修复 "TypeVarTuple.__typing_prepare_subst__"。在使用多个
  "TypeVarTuple" 时，如类型别名替换中的 "[*T, *V]"，未引发 "TypeError"
  。

* gh-90467: 修复 "asyncio.streams.StreamReaderProtocol" 以保持对创建的
  任务的强引用，从而避免被垃圾回收。

* gh-96159: 修复日志 TimedRotatingFileHandler 中的性能回归问题。仅在滚
  动时间过去时检查特殊文件。

* gh-96175: 修复 "xml.dom.minidom" 中 "Attr" 类未使用的 "localName" 参
  数。

* gh-96125: 修复导致 "sys.thread_info.name" 在 pthread 平台上错误的错
  误条件。

* gh-95463: 移除来自 bpo-28080 的不兼容更改，该更改导致了一个回归问题
  ，即忽略了 "ZipInfo.flag_bits" 中的 utf8。由 Pablo Galindo 提供补丁
  。

* gh-95899: 修复 "asyncio.Runner" 使其只调用
  "asyncio.set_event_loop()" 一次，以避免在子监视器上多次调用
  "attach_loop()"。由 Kumar Aditya 提供补丁。

* gh-95736: 修复 "unittest.IsolatedAsyncioTestCase" 在调用设置函数之前
  设置事件循环。由 Kumar Aditya 提供补丁。

* gh-95704: 当一个任务捕获 "asyncio.CancelledError" 并引发其他错误时，
  其他错误通常不应被静默抑制。

* gh-95231: Fail gracefully if "EPERM" or "ENOSYS" is raised when
  loading "crypt" methods. This may happen when trying to load "MD5"
  on a Linux kernel with FIPS (Federal Information Processing
  Standard) enabled.

* gh-74116: 允许 "asyncio.StreamWriter.drain()" 被多个任务并发等待。由
  Kumar Aditya 提供补丁。

* gh-92986: Fix "ast.unparse()" when "ImportFrom.level" is None


文档
----

* gh-96098: 通过从较低级别的 threading 和 multiprocessing 模块提供更清
  晰的链接，提高了较高层次 concurrent.futures 模块的可发现性。

* gh-95957: What's New 3.11 现在提供了关于如何在 RHEL 7 和 CentOS 7 上
  为 Tcl/Tk 和 OpenSSL 提供编译器和链接器标志的说明。


测试
----

* gh-95243: 通过在失败前尝试多次找到未使用的端口，缓解了在
  testSockName() 中使用 find_unused_port() 固有的竞态条件。由 Ross
  Burton 提供补丁。


构建
----

* gh-94682: 使用 OpenSSL 1.1.1q 进行构建和测试


Windows
-------

* gh-96577: Fixes a potential buffer overrun in "msilib".

* gh-96559: 修复了当没有向命令传递标签时，Windows启动器不使用配置文件
  中找到的默认标签的兼容性解释的问题。


Python 3.11.0 release candidate 1
=================================

*Release date: 2022-08-05*


核心与内置函数
--------------

* gh-95150: 更新代码对象的哈希和相等性考虑，以考虑所有调试和异常处理表
  。这修复了在编译过程中某些非相同代码对象可能被"去重"的问题。

* gh-95355: "_PyPegen_Parser_New" 现在能正确检测令牌内存分配错误。补丁
  由Honglin Zhu提供。

* gh-90081: 在追踪器/分析器函数中以全速运行Python代码。修复了早期3.11
  版本中的速度下降问题。

* gh-95324: 在调试模式下，如果对象在释放前未调用
  "PyObject_GC_UnTrack()"，则发出警告。由Pablo Galindo提供补丁。

* gh-95185: 防止在编译一些极长表达式如 ""+0"*1000000" 时AST构造器崩溃
  。现在会改为抛出 "RecursionError"。由Pablo Galindo提供补丁。

* gh-93351: 现在，当向 "compile()" 和其他相关函数提供 "ast.AST" 节点位
  置时，会验证这些位置。如果检测到无效位置，将抛出 "ValueError"。

* gh-94938: 修复当关键字参数名称是重载了 "__eq__" 和 "__hash__" 的 str
  子类实例时，某些内置函数中的错误检测。之前这可能导致 SystemError 或
  其他不希望的行为。


库
--

* gh-95609: 更新捆绑的 pip 到 22.2.2 版本。

* gh-95289: Fix "asyncio.TaskGroup" to propagate exception when
  "asyncio.CancelledError" was replaced with another exception by a
  context manger. Patch by Kumar Aditya and Guido van Rossum.

* gh-95339: 更新捆绑的 pip 到 22.2.1。

* gh-95045: 通过在调用任何回调之前取消跟踪，修复在释放
  "_lsprof.Profiler" 时的 GC 崩溃。由 Kumar Aditya 提供补丁。

* gh-95097: 为没有 "uncancel()" 方法的 "asyncio.Task" 实现修复
  "asyncio.run()"。由 Kumar Aditya 提供补丁。

* gh-93899: Fix check for existence of "os.EFD_CLOEXEC",
  "os.EFD_NONBLOCK" and "os.EFD_SEMAPHORE" flags on older kernel
  versions where these flags are not present. Patch by Kumar Aditya.

* gh-95166: 修复 "concurrent.futures.Executor.map()"，使其在错误（例如
  TimeoutError 或 KeyboardInterrupt）时取消当前等待的 future。

* gh-95109: 确保已过期的时间调度（使用 "asyncio.Timeout"）能够被及时传
  递。

* gh-91810: 在使用 "encoding='unicode'" 和 "xml_declaration=None" 的
  "ElementTree.write()" 中，抑制在打开的文件中写入 XML 声明。

* gh-91447: Fix findtext in the xml module to only give an empty
  string when the text attribute is set to None.


文档
----

* gh-91207: 修复了 Windows CHM htmlhelp 文档中样式表不起作用的问题，并
  添加了它们已被弃用的警告。由 C.A.M. Gerlach 贡献。

* gh-95451: 更新了库文档，添加了关于 WebAssembly 平台
  "wasm32-emscripten" 和 "wasm32-wasi" 的 availability information。

* gh-95415: 对平台可用性使用一致的语法。该指令现在支持内容体，并在遇到
  未知平台时发出警告。

* gh-86128: 文档化 ThreadPoolExecutor 中的一个限制，即其退出处理程序在
  任何 atexit 处理程序之前执行。


测试
----

* gh-95573: Lib/test/test_asyncio/test_ssl.py 暴露了 macOS 内核中的一
  个 bug，其中非阻塞套接字上的高强度并发负载偶尔会导致 "errno.ENOBUFS"
  (“无缓冲区空间可用”) 被发出。已向 Apple 提交 FB11063974，同时作为一
  种临时解决方案，减少在 macOS 上测试中使用的缓冲区大小以避免间歇性失
  败。由 Fantix King 提供补丁。

* gh-95280: 修复了在需要完美前向保密（PFS）密码的系统上 "test_ssl"
  "test_get_ciphers" 的问题。

* gh-94675: 为 "re" 在使用 rjsmin 时的指数级减速添加了一个回归测试。


构建
----

* gh-94801: 修复 "configure" 脚本中的一个回归，该回归导致某些头文件检
  查忽略自定义的 "CPPFLAGS"。该回归在 gh-94802 中引入。

* gh-95145: wasm32-wasi 构建不再依赖 WASIX 的 pthread 存根。Python 现
  在有自己的存根 pthread API。

* gh-95174: Python 现在检测 WASI 中缺失的 "dup" 函数，并解决一些缺失的
  "errno"，"select"，和 "socket" 常量。

* gh-95174: Python 现在在 WASI 上跳过缺失的 "socket" 函数和方法。WASI
  只能从现有的 fd 创建套接字 / accept 并且没有 netdb。

* gh-95085: 平台 "wasm32-unknown-emscripten" 和 "wasm32-unknown-wasi"
  已被提升为 **PEP 11** 第3层平台支持。


Windows
-------

* gh-95656: 启用 "enable_load_extension()" "sqlite3" API。

* gh-95587: 修复了 Windows 安装程序在升级时错误检测现有安装的某些功能
  的问题。

* gh-94399: 恢复了 适用于Windows的Python启动器 对于 "/usr/bin/env"
  shebang 行的行为，现在将在 "PATH" 中搜索与给定命令匹配的可执行文件。
  如果没有找到，则使用通常的搜索过程。

* gh-95445: 修复了在使用 Windows msi 卸载时未能成功删除 HTML 文档目录
  的问题。

* gh-95359: 修复 适用于Windows的Python启动器 对 "py.ini" 命令的处理（
  它错误地期望键上有 "py_" 前缀）以及在读取每用户配置文件时的崩溃问题
  。

* gh-95285: 修复 适用于Windows的Python启动器 处理仅传递短可执行名称的
  命令行的问题。


IDLE
----

* gh-65802: 记录在另存为对话框中处理扩展名的方法。

* gh-95191: 保存 Shell（交互式输入和输出）时包括提示。

* gh-95511: 修复 Shell 上下文菜单复制带提示的 bug，即当选择整行时会复
  制额外的行。

* gh-95471: 在编辑菜单中，移动 "Select All" 并添加一个新的分隔符。

* gh-95411: 启用IDLE的模块浏览器以支持.pyw文件。

* gh-89610: 在macOS上为IDLE添加.pyi作为已识别的扩展名。这允许通过双击
  Finder中的存根文件来打开它们。


C API
-----

* gh-92678: 恢复了 3.10 的行为，对于在结构体末尾存储字典的 C 扩展类支
  持多重继承。

* gh-94936: 添加了 "PyCode_GetVarnames()"、"PyCode_GetCellvars()" 和
  "PyCode_GetFreevars()"，用于通过 C API 分别访问 "co_varnames"、
  "co_cellvars" 和 "co_freevars"。


Python 3.11.0 beta 5
====================

*Release date: 2022-07-25*


核心与内置函数
--------------

* gh-93351: 现在，当向 "compile()" 和其他相关函数提供 "ast.AST" 节点位
  置时，会验证这些位置。如果检测到无效位置，将抛出 "ValueError"。

* gh-94438: 修复了一个问题，该问题导致在计算对帧对象的 "f_lineno" 属性
  赋值的有效跳转目标时，忽略扩展操作码参数和一些条件弹出。在某些情况下
  ，这可能导致内部状态不一致，导致解释器硬崩溃。

* gh-95060: 未记录的 "PyCode_Addr2Location" 函数现在在 "addrq" 参数小
  于零时正确返回。

* gh-95113: 在非快速化代码中，将所有 "EXTENDED_ARG_QUICK" 指令替换为基
  本的 "EXTENDED_ARG" 指令。非自适应字节码的使用者应该能够以与CPython
  3.10及更早版本相同的方式处理扩展参数。

* gh-91409: 修复由字节码编译器中的某些优化引起的错误源代码位置信息。

* gh-94036: 修复一些多行属性访问和方法调用的错误源代码位置信息。

* gh-94739: 允许在调试器中跳入、跳出以及跨异常处理器跳转。

* gh-94949: "ast.parse()" 在传递的 "feature_version" 小于 "(3, 9)" 时
  ，将不再解析带括号的上下文管理器。由 Shantanu Jain 提供补丁。

* gh-94947: "ast.parse()" 在传递的 "feature_version" 小于 "(3, 8)" 时
  ，将不再解析赋值表达式。由 Shantanu Jain 提供补丁。

* gh-91256: 确保解释器启动期间帮助文本的程序名称是已知的。

* gh-94869: 修复多行 f-字符串 "ast" 节点中某些表达式的列偏移。由 Pablo
  Galindo 提供补丁。

* gh-94822: 修复当类本身也存在同名属性时，元类描述符的查找可能被忽略的
  问题。

* gh-91153: 修复 "bytearray" 项赋值在通过新值的 "__index__()" 方法调整
  大小时可能崩溃的问题。

* gh-90699: 修复 "bool.__repr__()" 中的引用计数错误。由 Kumar Aditya
  提供补丁。


库
--

* gh-95087: 修复 "email" 模块中解析无效日期时的 IndexError。

* gh-95199: 更新捆绑的 setuptools 到 63.2.0。

* gh-95194: 更新捆绑的 pip 到 22.2。

* gh-95132: Fix a "sqlite3" regression where "*args" and "**kwds" were
  incorrectly relayed from "connect()" to the "Connection" factory.
  The regression was introduced in 3.11a1 with PR 24421 (gh-85128).
  Patch by Erlend E. Aasland.`

* gh-93157: 修复 "fileinput" 模块在 "inplace" 为 true 时不支持
  "errors" 选项的问题。

* gh-95105: "wsgiref.types.InputStream.__iter__()" 应返回
  "Iterator[bytes]"，而不是 "Iterable[bytes]"。由 Shantanu Jain 提供补
  丁。

* gh-94857: 修复 "_io.TextIOWrapper.reconfigure" 中的内存泄漏。补丁由
  Kumar Aditya 提供。

* gh-94821: 修复 Linux 上 Unix 套接字绑定到空地址时使用抽象命名空间中
  的可用地址，而不是 "0"。

* gh-89988: 修复 "pickle.Pickler" 在查找 "dispatch_table" 时的内存泄漏
  。补丁由 Kumar Aditya 提供。

* bpo-47025: Drop support for "bytes" on "sys.path".


测试
----

* gh-95212: 使多进程测试用例 "test_shared_memory_recreate" 并行安全。


构建
----

* gh-94847: 修复了在 GCC 使用 LTO 和 pydebug 编译时 "_decimal" 模块的
  构建问题。调试构建不再强制内联函数。

* gh-94841: 修复了使用 MSVC 版本 1932 编译的 "PyObject_Free()" 可能的
  性能回归。

* gh-94801: "configure" 现在在搜索头文件和库时使用自定义标志如
  "ZLIB_CFLAGS" 和 "ZLIB_LIBS"。

* gh-94773: "deepfreeze.py" 现在支持包含不兼容、不可排序类型的
  frozensets 的代码对象。


Windows
-------

* gh-90844: 允许虚拟环境在路径中有空格时正确启动。

* gh-94772: 修复 py.exe 启动器中 shebang 行的错误处理


C API
-----

* gh-92678: 添加了不稳定的 C-API 函数 "_PyObject_VisitManagedDict" 和
  "_PyObject_ClearManagedDict"，允许 C 扩展让虚拟机管理它们的对象字典
  。

* gh-94930: 修复了当 "PyArg_ParseTupleAndKeywords()" 与 "#" 在 "(...)"
  中一起使用但未定义 "PY_SSIZE_T_CLEAN" 时引发的 "SystemError"。

* gh-94864: Fix "PyArg_Parse*" with deprecated format units "u" and
  "Z". It returned 1 (success) when warnings are turned into
  exceptions.

* gh-94731: Python 在使用 C++ 编译时，再次对大多数类型转换操作使用 C
  风格的转换。这可能会触发编译器警告，如果它们是通过例如 "g++" 的
  "-Wold-style-cast" 或 "-Wzero-as-null-pointer-constant" 选项启用的。


Python 3.11.0 beta 4
====================

*Release date: 2022-07-11*


安全性
------

* gh-87389: "http.server": 修复了HTTP服务器中当URI路径以 "//" 开头时的
  开放重定向漏洞。漏洞由Hamza Avvan发现并提出了初步修复方案。

* gh-79096: LWPCookieJar和MozillaCookieJar创建的文件模式改为600而非644
  （Microsoft Windows不受影响）

* gh-92888: 修复了在某些情况下访问底层缓冲区时的 "memoryview" 释放后使
  用问题。

* gh-68966: 已弃用的mailcap模块现在拒绝将不安全的文本（文件名、MIME类
  型、参数）注入到shell命令中。它将发出警告并视为未找到匹配（或对于测
  试命令，视为测试失败），而不是使用此类文本。


核心与内置函数
--------------

* gh-94694: 修复可能导致具有多行方法查找的代码具有误导性或错误的列偏移
  信息的问题。在某些情况下（当编译手动构建的 AST 时），这可能导致解释
  器硬崩溃。

* gh-93252: 修复导致内部帧在失败的 Python 函数调用后仍然存活的问题，可
  能导致内存泄漏或解释器硬崩溃。

* gh-94215: 修复了一个问题，即由行追踪事件引发的异常会导致帧处于无效状
  态，可能导致解释器硬崩溃。

* gh-92228: 对于与源代码行相关联的退出块，禁用编译器的内联小退出块优化
  。这修复了一个bug，即调试器无法区分异常处理器的结束和后续代码块的开
  始。

* gh-94485: 根据 **PEP 626** 的规定，模块的 "RESUME" 指令的行号被设置
  为0。

* gh-94438: 在设置帧中的行号时，考虑可以推NULL到堆栈的指令。防止一些（
  不太可能的）崩溃。

* gh-91719: 在解释器主循环中引发 "unknown opcode error" 时重新加载
  "opcode"，以便C编译器独立生成调度代码。

* gh-94329: 编译并运行具有极大序列（1000多个元素）解包的代码。此类代码
  之前无法编译。现在可以正确编译并运行。

* gh-94360: 修复了当从 "stdin" 读取带有语法错误的非utf-8编码文本文件时
  ，分词器崩溃的问题。由Pablo Galindo提供补丁。

* gh-88116: 修复了当从代码对象读取行号时，如果编码的行号接近 "INT_MIN"
  时的问题。由Pablo Galindo提供补丁。

* gh-94262: 不为不完整的帧创建帧对象。防止Python和C扩展可以观察到生成
  器和闭包的创建，恢复了3.10及更早版本的行为。

* gh-94192: 修复了字典字面量中值表达式无效时的错误。

* gh-93883: 修订了回溯增强错误位置的显示策略。指示器仅在位置不跨越整行
  时显示。

* gh-94021: 修复 "Python/specialize.c" 中不可达代码的警告。

* gh-93516: 在代码对象中存储第一个可跟踪指令的偏移量，以避免在跟踪时对
  每个指令重新计算。

* gh-93516: 延迟创建将字节码偏移量映射到行号的表，以加快跟踪时行号的计
  算速度。

* gh-89828: "types.GenericAlias" 不再中继 "__class__" 属性。例如，
  "isinstance(list[int], type)" 不再返回 "True"。

* gh-93671: 修复在匹配语句中深度嵌套序列模式时发生的一些指数回溯情况。
  由 Pablo Galindo 提供补丁。

* gh-93662: 确保在多行方法调用中结束列偏移是正确的。以前，结束列可能会
  在列偏移之前。

* gh-93461: "importlib.invalidate_caches()" 现在会从
  "sys.path_importer_cache" 中删除以相对路径为名称的条目。这解决了进程
  改变其当前工作目录时的缓存问题。

  "FileFinder" 不再在路径中插入点，例如 "/egg/./spam" 现在是
  "/egg/spam"。

* gh-93418: 修复了一个断言错误，其中 f-string 在表达式后有一个等号 '='
  ，但没有尾随的大括号。例如，f"{i="。

* gh-93382: Cache the result of "PyCode_GetCode()" function to restore
  the O(1) lookup of the "co_code" attribute.

* gh-93354: 在解释器中对专门化计数器使用指数退避。可以显著减少失败专门
  化的数量，并避免对程序中不适合专门化的部分造成减速。

* gh-93021: 修复了在 C 中实现的 "__get__()" 方法的
  "__text_signature__"。补丁由 Jelle Zijlstra 提供。

* gh-92930: 修复了在 "__reduce__" 或 "persistent_id" 期间修改集合导致
  的 "_pickle.c" 崩溃。

* gh-92914: 总是将列表的分配大小向上舍入到最近的偶数。

* gh-92858: 改进在 ':' 之前有语法错误的某些套件的错误消息。

* bpo-46142: 通过将一些信息移至新的命令行选项 "--help-env" 和 "--help-
  xoptions"，使 "--help" 输出更简短。同时添加 "--help-all" 选项以打印
  完整用法。


库
--

* gh-94736: 修复在释放 "_multiprocessing.SemLock" 子类实例时的崩溃问题
  。由 Kumar Aditya 提供补丁。

* gh-94637: "SSLContext.set_default_verify_paths()" 现在在
  "SSL_CTX_set_default_verify_paths" 调用周围释放 GIL。该函数调用执行
  I/O 和 CPU 密集型工作。

* gh-94607: 修复在 "typing" 中使用类型变量子类化复杂泛型的问题。之前会
  显示错误消息 "Some type variables ... are not listed in
  Generic[...]"。"typing" 不再用 Python 类的 "__parameters__" 填充
  "__parameters__"。

* gh-93910: 恢复了访问枚举上其他值的能力（例如 "Color.RED.BLUE"），以
  修复性能回归问题。

* gh-93896: 修复 "asyncio.run()" 和 "unittest.IsolatedAsyncioTestCase"
  以始终设置事件循环，如同在 Python 3.10 及更早版本中所做的那样。由
  Kumar Aditya 提供补丁。

* gh-94510: 对 "sys.setprofile()" 和 "sys.settrace()" 的重新进入调用现
  在会引发 "RuntimeError"。由 Pablo Galindo 提供补丁。

* gh-92336: 修复了 "linecache.getline()" 在坏文件上因
  "UnicodeDecodeError" 或 "SyntaxError" 而失败的错误。根据文档，现在它
  返回一个空字符串。

* gh-94398: 一旦 "asyncio.TaskGroup" 开始关闭（即，至少一个任务失败并
  且任务组开始取消剩余任务），就不应再向任务组添加新任务。

* gh-94254: 修正 "struct" 模块的类型为不可变。由 Kumar Aditya 提供补丁
  。

* gh-94207: Made "_struct.Struct" GC-tracked in order to fix a
  reference leak in the "_struct" module.

* gh-91742: 修复 "pdb" 因空指针解引用导致的跳转后崩溃问题。补丁由
  Kumar Aditya 提供。

* gh-94101: 不再允许手动实例化 "ssl.SSLSession" 对象，因为这会导致配置
  错误的实例，在访问其属性时解释器崩溃。

* gh-84753: "inspect.iscoroutinefunction()"、
  "inspect.isgeneratorfunction()" 和 "inspect.isasyncgenfunction()" 现
  在能正确地为鸭子类型的函数式对象（如 "unittest.mock.AsyncMock" 的实
  例）返回 "True"。

  这使得 "inspect.iscoroutinefunction()" 的行为与
  "asyncio.iscoroutinefunction()" 保持一致。由 Mehdi ABAAKOUK 提供补丁
  。

* gh-94028: 修复 "sqlite3" 中的一个回归问题，其中语句对象在游标迭代器
  使用后未被正确清除和重置。该回归问题由 Python 3.11a1 中的 PR 27884
  引入。由 Erlend E. Aasland 提供补丁。

* gh-93820: 通过名称 Pickle "enum.Flag"。

* gh-93847: 修复泛型别名枚举的 repr。

* gh-91404: 恢复 "re" 在匹配被信号或内存分配失败终止时的内存泄漏，因为
  已实现的修复导致了严重的性能回归。

* gh-83499: 修复 "tempfile" 中文件描述符的双重关闭问题。

* gh-93820: 修复了一个回归问题，当 "copy.copy()"-ing 带有多个标志成员
  的 "enum.Flag" 时。

* gh-79512: 修复了 "weakref" 模块中 "ReferenceType"、"ProxyType"、
  "CallableProxyType" 类的名称和 "__module__" 值，使它们可以被 pickle
  。

* gh-91389: 修复了一个问题，其中 "dis" 工具在存在 "CACHE" 条目时可能会
  报告缺失或不正确的位置信息。

* gh-93626: 将 "__future__.annotations" 的 "None" mandatoryRelease 设
  置为表示当前为“待定”。

* gh-90473: Emscripten 和 WASI 没有主目录，无法提供 **PEP 370** 用户站
  点目录。

* gh-90494: 如果 "__reduce__()" 返回长度为6的元组，"copy.copy()" 和
  "copy.deepcopy()" 现在总是会引发 TypeError，而不是静默忽略第6项或产
  生不正确的结果。

* gh-90549: 修复了一个多进程错误，其中在创建子进程（与 fork 相对）时，
  全局命名资源（如信号量）可能会泄漏。

* gh-93521: 修复了一个情况，其中数据类会尝试将 "__weakref__" 添加到已
  经在其基类中定义了 "weakref_slot=True" 的数据类的 "__slots__" 中。这
  会导致在创建新类时引发 "TypeError"。

* gh-79579: "sqlite3" 现在能正确检测带有前导注释的 DML 查询。由 Erlend
  E. Aasland 提供补丁。

* gh-93421: 当 DML 语句运行完成时更新 "sqlite3.Cursor.rowcount"。这修
  复了像 "UPDATE ... RETURNING" 这样的 SQL 查询的行计数。由 Erlend E.
  Aasland 提供补丁。

* gh-91162: 支持在 "TypeVar" 和 "TypeVarTuple" 参数上解包任意长度的元
  组拆分。例如：

  * "A[T, *Ts][*tuple[int, ...]]" -> "A[int, *tuple[int, ...]]"

  * "A[*Ts, T][*tuple[int, ...]]" -> "A[*tuple[int, ...], int]"

* gh-93353: 修复 "importlib.resources.as_file()" 上下文管理器，在
  Python最终化过程中如果被延迟销毁则删除临时文件：保留对 "os.remove()"
  函数的本地引用。由 Victor Stinner 提供补丁。

* gh-83658: 如果 "maxtasksperchild" 不是 "None" 或正整数，则使
  "multiprocessing.Pool" 抛出异常。

* gh-93156: 使用负索引值访问绝对路径的 "pathlib.PurePath.parents" 序列
  会产生不正确的结果。

* gh-74696: "shutil.make_archive()" 在创建标准 ".zip" 或 tar 归档文件
  时不再临时更改当前工作目录。

* gh-89973: 修复了如果在模式中包含上限低于下限的字符范围（例如 "[c-a]"
  ）时 "fnmatch" 中引发的 "re.error"。现在这样的范围被解释为空范围。

* gh-92932: 现在 "dis()" 和 "get_instructions()" 处理以
  "EXTENDED_ARG_QUICK" 为前缀的指令的操作数值。补丁由 Sam Gross 和
  Donghee Na 提交。

* gh-91577: 将 "SharedMemory" 方法中的导入移动到模块级别，以便它们可以
  在Python终止的后期执行。

* gh-91456: 弃用当前的默认auto()行为：在3.13版本中，auto()的默认行为将
  始终返回最大成员值加1，并在使用不兼容的值类型时引发错误。

* bpo-47231: 修复了tarfile长名字目录中不一致的尾部斜杠问题。

* bpo-46755: 在 "QueueHandler" 中，清除 "LogRecord" 中的 "stack_info"
  以防止堆栈跟踪被写入两次。

* bpo-46197: 修复了 "ensurepip" 对运行 "pip" 的子进程的环境隔离。

* bpo-45924: 修复了 "asyncio" 在多次引发 future 的异常时的错误回溯。由
  Kumar Aditya 提供补丁。

* bpo-34828: "sqlite3.Connection.iterdump()" 现在可以处理在一个或多个
  表中使用 "AUTOINCREMENT" 的数据库。


文档
----

* gh-94321: 文档化 **PEP 246** 风格的协议类型
  "sqlite3.PrepareProtocol"。

* gh-61162: 澄清 "sqlite3" 在 如何使用连接上下文管理器 时的行为。

* gh-87260: 将 "sqlite3" 的参数规范与实际实现对齐。

* gh-86986: 构建文档所需的最低 Sphinx 版本现在是 3.2。

* gh-88831: Augmented documentation of asyncio.create_task().
  Clarified the need to keep strong references to tasks and added a
  code snippet detailing how to to this.

* bpo-47161: 文档说明 "pathlib.PurePath" 不会合并开头的双斜杠，因为它
  们表示 UNC 路径。


测试
----

* gh-91330: 为 "dataclasses" 添加了更多测试，以覆盖基于数据描述符的字
  段的行为。

* gh-94208: "test_ssl" 现在在更多测试中检查支持的 TLS 版本和协议。

* gh-94315: 测试现在检查 DAC 覆盖能力，而不是依赖于 "os.geteuid()"。

* gh-93951: 在 test_bdb.StateTestCase.test_skip 中，避免包括辅助导入器
  。

* gh-93957: 在 test_venv.EnsurePipTest.test_with_pip 中提供来自子进程
  的更友好的错误报告。

* gh-84461: "run_tests.py" 现在正确处理交叉编译环境变量，并将
  "HOSTRUNNER" 传递给回归测试。

* gh-93616: "test_modulefinder" 现在在 "ModuleFinderTest.setUp()" 中创
  建临时目录，而不是在模块范围内。

* gh-93575: 修复 test_unicode test_raiseMemError 的问题。测试用例现在
  使用 "test.support.calcobjsize" 来计算 PyUnicode 结构的大小。
  "sys.getsizeof()" 在字符串具有 UTF-8 内存时可能返回不同的大小。

* gh-90473: WASI 没有 "chmod(2)" 系统调用。"os.chmod()" 现在在 WASI 上
  是一个虚拟函数。跳过所有依赖于 "os.chmod()" 正常工作的测试。

* gh-90473: 在 WASI 上跳过需要绝对路径符号链接的测试。

* gh-57539: 增加 "calendar.LocaleTextCalendar.formatweekday()" 的日历
  测试覆盖率。

* gh-90473: 在 WASI 上跳过符号链接测试。wasmtime 使用 "openat2(2)" 和
  "RESOLVE_BENEATH" 标志，这阻止了具有绝对路径的符号链接。

* gh-89858: 为树外构建修复 "test_embed"。由 Kumar Aditya 提供补丁。

* gh-92886: 修复在 "test_imaplib.py" 中使用优化 ("-O") 运行时失败的测
  试。

* gh-92886: 修复在 "test_zipimport.py" 中使用优化 ("-O") 运行时失败的
  测试。

* bpo-47016: 创建一个 GitHub Actions 工作流用于验证捆绑的 pip 和
  setuptools。由 Illia Volochii 和 Adam Turner 提供补丁。


构建
----

* gh-94404: "makesetup" 现在解决了 macOS 上 sed 的问题，并为最终出现在
  共享扩展中的对象文件使用了正确的 CFLAGS。模块 CFLAGS 在
  PY_STDMODULE_CFLAGS 之前使用，以避免与系统头文件冲突。

* gh-93584: 解决了在安装PGO构建时 "Makefile``中的竞争条件。所有
  ``test" 和 "install" 目标现在都依赖于 "all" 目标。

* gh-93491: "configure" 现在检测并报告 **PEP 11** 支持层级。


Windows
-------

* gh-93824: 对于 Windows ARM64，已启用将文件拖放到 Windows 资源管理器
  中的 Python 文件上。

* bpo-42658: Support native Windows case-insensitive path comparisons
  by using "LCMapStringEx" instead of "str.lower()" in
  "ntpath.normcase()". Add "LCMapStringEx" to the "_winapi" module.


工具/示例
---------

* gh-94538: 修复Argument Clinic输出到自定义文件目的地的问题。补丁由
  Erlend E. Aasland提供。

* gh-94430: 允许在Argument Clinic中使用名为 "module" 和 "self" 的参数
  ，并带有自定义C名称。由Erlend E. Aasland提供补丁。


C API
-----

* gh-93937: 以下帧函数和类型现在可以直接通过 "#include <Python.h>" 使
  用，不再需要添加 "#include <frameobject.h>"：

  * "PyFrame_Check()"

  * "PyFrame_GetBack()"

  * "PyFrame_GetBuiltins()"

  * "PyFrame_GetGenerator()"

  * "PyFrame_GetGlobals()"

  * "PyFrame_GetLasti()"

  * "PyFrame_GetLocals()"

  * "PyFrame_Type"

  由Victor Stinner提供补丁。

* gh-91321: 修复了 Python C API 与 C++11 之前版本的兼容性。由 Victor
  Stinner 提供补丁。

* gh-91731: 在使用 C++11 编译时避免定义 "static_assert"，因为在 C++11
  中这是一个关键字，重新定义它可能导致未定义行为。由 Pablo Galindo 提
  供补丁。

* gh-93442: 为 _Py_CAST_impl() 添加 C++ 重载以处理 0/NULL。这将允许传
  递 0 或 NULL 到使用 _Py_CAST() 的宏的 C++ 扩展继续编译。


Python 3.11.0 beta 3
====================

*Release date: 2022-06-01*


核心与内置函数
--------------

* gh-93359: 确保没有明确结束位置的自定义 "ast" 节点可以被编译。由
  Pablo Galindo 提供补丁。

* gh-93345: 修复了在 "TypeVarTuple" 之后嵌套泛型别名中替换 "TypeVar"
  时的崩溃问题。


构建
----

* gh-69093: 修复了 "Modules/Setup.stdlib.in" 中 "_sqlite3" 扩展的规则
  。


Python 3.11.0 beta 2
====================

*Release date: 2022-05-30*


核心与内置函数
--------------

* gh-84694: 配置选项 "--experimental-isolated-subinterpreters" 和宏
  "EXPERIMENTAL_ISOLATED_SUBINTERPRETERS" 已被移除。

* gh-91924: 修复了当标准输出编码不是 UTF-8 时的 "__lltrace__" 调试功能
  。由 Victor Stinner 提供补丁。

* gh-93061: "async for" 循环后的向后跳转不再赋予可疑的行号。

* gh-93065: 修复了 contextvars HAMT 实现以处理对深树的迭代。

  该错误由 Eli Libman 发现并修复。更多详情请见
  MagicStack/immutables#84。

* gh-90473: 在 WASI 上降低默认递归限制以解决有限的调用栈大小问题。

* gh-92804: 修复 "memoryview" 迭代器中的内存泄漏，因为它未在退出时完成
  。由 Kumar Aditya 提供补丁。

* gh-92236: 移除在启动生成器或协程时可见的虚假 "LINE" 事件，这些事件在
  C 中实现的追踪函数中可见。

* gh-92619: 使编译器仅在退出块中的指令都没有行号时才复制退出块（之前仅
  检查块中的第一条指令，导致不必要的块复制）。

* gh-92261: 修复尝试迭代 "typing.Union" 时的挂起问题。


库
--

* gh-93297: 使 asyncio 任务组阻止子任务被垃圾回收。

* gh-90817: "locale.resetlocale()" 函数已被弃用，并将在 Python 3.13 中
  移除。请改用 "locale.setlocale(locale.LC_ALL, "")"。由 Victor
  Stinner 提交补丁。

* gh-92728: "re.template()" 函数及对应的 "re.TEMPLATE" 和 "re.T" 标志
  在 3.11.0b1 中被移除后已恢复，但它们现在已被弃用，因此可能会在
  Python 3.13 中移除。

* gh-93044: 不再在将数据库参数传递给工厂之前将其转换为字节。

* gh-93010: 在一种非常特殊的情况下，email 包尝试将不存在的
  "InvalidHeaderError" 添加到缺陷列表中。应该是 "InvalidHeaderDefect"
  。

* gh-92675: 修复 "venv.ensure_directories()" 以接受 "pathlib.Path" 参
  数以及 "str" 路径。补丁由 David Foster 提交。

* gh-87901: 从 "os.popen()" 中移除了在 3.11b1 中添加的 "encoding" 参数
  。

* gh-91922: 修复了在非UTF-8语言环境下 "sqlite.connect()" 函数和
  "sqlite.Connection" 构造函数的问题。此外，它们现在支持无法用当前文件
  系统编码解码的字节路径。

* gh-92839: Fixed crash resulting from calling bisect.insort() or
  bisect.insort_left() with the key argument not equal to None.

* gh-90473: "subprocess" 现在在Emscripten和WASI平台上早期失败，以解决
  WASI上缺少 "os.pipe()" 的问题。

* gh-92671: 修复了在赋值目标上下文中 "ast.unparse()" 对于空元组的问题
  。

* gh-91581: "utcfromtimestamp()" 在纯Python实现中不再尝试解析 "fold"，
  因为在UTC中fold永远不会是1。除了在常见情况下稍微快一些之外，这还防止
  了当时间戳接近 "datetime.min" 时的一些错误。由Paul Ganssle提供补丁。

* gh-92550: 修复了 "pathlib.Path.rglob()" 对于空模式的问题。

* gh-92530: 修复了在中断 "threading.Condition.notify()" 后出现的问题。

* gh-92531: statistics.median_grouped() 函数现在总是返回一个浮点数。以
  前，对于长度为1的序列，它不会转换输入类型。

* gh-91810: "ElementTree" 方法 "write()" 和函数 "tostring()" 现在在指
  定 "encoding="unicode"" 时使用文本文件的编码（如果不可用则为 "UTF-8"
  ）而不是 XML 声明中的区域设置编码。

* gh-90622: 当多进程上下文启动方法为 >>``<<"fork">>``<<时，
  "concurrent.futures.ProcessPoolExecutor" 的工作进程不再按需生成（这
  是3.9版本中添加的特性），因为这可能会导致子进程中的死锁，因为在线程
  运行时发生了fork。

* gh-91581: 移除了在调用没有时区的 "datetime.fromtimestamp" 的C实现中
  未处理的错误情况（即从epoch时间戳获取本地时间）。这除了在调用落在本
  地时间10000-01-01的时间戳时可能给出更准确的错误消息外，应该不会对用
  户产生影响。由Paul Ganssle提供补丁。

* bpo-39064: "zipfile.ZipFile" 现在在读取损坏的 zip 文件时，如果中央目
  录偏移为负，会引发 "zipfile.BadZipFile" 而不是 "ValueError"。

* bpo-45393: 在使用 "help()" 系统时，修复了操作符优先级表中 "await x"
  和 "not x" 的格式化。

* bpo-28249: Set "doctest.DocTest.lineno" to "None" when object does
  not have "__doc__".

* bpo-45046: 在 "unittest" 中添加对上下文管理器的支持：类 "TestCase"
  的方法 "enterContext()" 和 "enterClassContext()"，类
  "IsolatedAsyncioTestCase" 的方法 "enterAsyncContext()" 以及函数
  "unittest.enterModuleContext()"。

* bpo-42627: 修复了 Windows 注册表代理设置的错误解析。


文档
----

* gh-86438: 澄清了在 "warnings" 中，"-W" 和 "PYTHONWARNINGS" 是字面匹
  配且不区分大小写的，而不是作为正则表达式匹配。

* gh-92240: 为 "Python 3.X 中的新特性" 添加了 3.0、3.1、3.2、3.8 和
  3.10 版本的发布日期。

* bpo-40838: 文档说明 "inspect.getdoc()"、"inspect.getmodule()" 和
  "inspect.getsourcefile()" 可能会返回 "None"。

* bpo-38056: 全面修改了 "codecs" 中的 错误处理方案 文档。

* bpo-13553: 文档说明 tkinter.Tk 的参数。


测试
----

* gh-92670: 在 AIX 上跳过
  "test_shutil.TestCopy.test_copyfile_nonexistent_dir" 测试，因为测试
  使用尾部斜杠强制操作系统将路径视为目录，但在 AIX 上尾部斜杠没有效果
  ，被视为文件。


构建
----

* gh-90473: 在 "wasm32-wasi" 上禁用pymalloc并增加堆栈大小。

* bpo-34449: 为HP-UX上的HP aCC移除无效的编译器开关 "-fPIC"。由Michael
  Osipov提供补丁。


Windows
-------

* gh-92817: 确保 "py.exe" 将优先选择活动的虚拟环境，而不是通过环境变量
  或 "py.ini" 文件指定的默认标签。

* gh-92984: 明确为非调试构建禁用增量链接

* gh-92841: "asyncio" 在异步套接字活动后解释器退出时不再抛出
  "RuntimeError: Event loop is closed"。由 Oleg Iarygin 提供补丁。

* bpo-46907: 更新 Windows 安装程序以使用 SQLite 3.38.4。


C API
-----

* gh-92898: 修复将函数参数转换为 "PyObject*" 时产生的 C++ 编译器警告。
  由 Serge Guelton 提供补丁。

* gh-92913: 确保除非设置了 "PyConfig.module_search_paths_set"，否则对
  "PyConfig.module_search_paths" 的更改将被忽略

* gh-92781: 避免在 C API 中混合声明和代码以修复编译器警告："ISO C90 禁
  止混合声明和代码" [-Werror=declaration-after-statement]。由 Victor
  Stinner 提供补丁。


Python 3.11.0 beta 1
====================

*发布日期：2022-05-06*


安全性
------

* gh-57684: 添加 "-P" 命令行选项和 "PYTHONSAFEPATH" 环境变量，以避免将
  可能不安全的路径前置到 "sys.path"。由 Victor Stinner 提供补丁。


核心与内置函数
--------------

* gh-89519: 链式 classmethod 描述符（在 bpo-19072 中引入）已被弃用。它
  不能再用于包装其他描述符，如 property()。此功能的核心设计存在缺陷，
  并导致了一系列下游问题。

* gh-92345: "pymain_run_python()" 现在在 sys.path 被扩展以包括交互式解
  释器的当前工作目录之前导入 "readline" 和 "rlcompleter"。非交互式解释
  器不受影响。

* bpo-43857: 当删除一个缺失的属性时，改进 "AttributeError" 消息。由
  Géry Ogam 提供补丁。

* gh-92245: 确保在所有情况下都遵循 PEP 523。在 3.11a7 中，专业化可能阻
  止了 Python 到 Python 的调用遵循 PEP 523。

* gh-92203: Add a closure keyword-only parameter to exec(). It can
  only be specified when exec-ing a code object that uses free
  variables. When specified, it must be a tuple, with exactly the
  number of cell variables referenced by the code object. closure has
  a default value of None, and it must be None if the code object
  doesn't refer to any free variables.

* gh-91173: 在调试构建中禁用冻结模块。由 Kumar Aditya 提供补丁。

* gh-92114: 当使用设置为 "None" 的 "__class_getitem__" 下标类型时，改
  进错误消息。

* gh-92112: 修复由元类上的恶意自定义 "mro()" 触发的崩溃。

* gh-92063: "PRECALL_METHOD_DESCRIPTOR_FAST_WITH_KEYWORDS" 指令现在确
  保方法仅在正确类型的对象上调用。

* gh-92031: 在 "Py_FINALIZE()" 期间静态分配的代码对象进行去优化，以便
  未来的 "_PyCode_Quicken" 调用总是从未优化的代码开始。

* gh-92036: 修复了与垃圾收集器相关的子解释器崩溃问题。当删除子解释器时
  ，取消跟踪其垃圾收集器跟踪的所有对象。为了防止在期望对象被垃圾收集器
  跟踪的析构函数中崩溃，有意泄露这些对象的强引用，这样它们就永远不会被
  删除，它们的析构函数也不会被调用。由Victor Stinner提供补丁。

* gh-92032: 解释器现在可以自动完成软关键字，截至目前包括来自 **PEP
  634** 的 "match"、"case" 和 "_" (通配符模式) 。

* gh-87999: Python解析器对于紧跟在关键字后的数字字面量发出的警告已从弃
  用警告更改为语法警告。

* gh-91869: 修复了一个问题，即带有扩展参数的专业操作码可能产生不正确的
  跟踪输出或导致断言失败。

* gh-91603: 加速 "types.UnionType" 的实例化。基于Yurii Karabas提供的补
  丁。

* gh-89373: 如果Python在调试模式下构建，Python现在确保析构函数不会改变
  当前异常。由Victor Stinner提供补丁。

* gh-91632: 修复了一个退出时的轻微内存泄漏：释放
  "generic_alias_iterator" 类型的内存。由Donghee Na提供补丁。

* gh-81548: 值大于 "0o377" 的八进制转义现在会产生 "DeprecationWarning"
  。在未来的Python版本中，它们将变为 "SyntaxWarning"，最终变为
  "SyntaxError"。

* bpo-43950: 使用单个紧凑表来表示行的开始、结束和列偏移。将位置信息的
  内存消耗减少了一半。

* gh-91102: 对 "EncodingMap" 使用Argument Clinic。由Oleg Iarygin提供补
  丁。

* gh-91636: 修复了垃圾回收边缘情况下的崩溃问题，其中
  "PyFunction_Type.tp_clear" 函数可能让Python函数对象处于不一致状态。

* gh-91603: 加速 "isinstance()" 和 "issubclass()" 对 "types.UnionType"
  的检查。由Yurii Karabas提供补丁。

* gh-91625: 修复了一个在自适应操作码特化失败时忽略任何前置
  "EXTENDED_ARG" 的错误。

* gh-78607: LLTRACE特殊构建现在查找模块全局中定义的名称 "__lltrace__"
  ，而不是之前因拼写错误引入的名称 "__ltrace__"。

* gh-91576: 通过Kumar Aditya的补丁，将ASCII字符串的迭代速度提高了50%。

* gh-89279: 通过内联几个特定的宏来提高Windows上解释器的性能。

* gh-91502: Add a new "_PyFrame_IsEntryFrame()" API function, to check
  if a "PyFrameObject" is an entry frame. Patch by Pablo Galindo.

* gh-91266: 重构 "bytearray" 的去除方法 "strip"、"lstrip" 和 "rstrip"
  ，以使用共同的实现。

* gh-91479: 将 "BaseException" 的 "__note__" 字段（在3.11的早期版本中
  添加）替换为 **PEP 678** 的最终设计。即 "BaseException" 获得一个
  "add_note()" 方法，其 "__notes__" 字段在必要时创建。

* gh-46055: 通过移除不必要的临时创建，加速负整数的右移操作。原始由
  Xinhang Xu提供补丁，由Mark Dickinson重新设计。

* gh-91462: 通过显示操作码名称（而不仅仅是数字）和每个操作码前的堆栈内
  容，使解释器的低级跟踪（lltrace）功能输出更易读。

* gh-89455: 修复了由初始的 bpo-45292 异常组工作引入的跟踪打印代码路径
  中未初始化的布尔值。

* gh-91421: 修复了 _Py_DecodeUTF8Ex 中潜在的整数溢出问题。

* gh-91428: 在调试版本的 "opcode.h" 中添加 "static const char *const
  _PyOpcode_OpName[256] = {...};"，以帮助调试Python解释器。现在，通过
  包含操作码名称而不仅仅是相应的十进制数字，使得各种形式的调试输出更便
  于人类阅读变得更加方便。

* bpo-47120: 使 "POP_JUMP_IF_TRUE"、"POP_JUMP_IF_FALSE"、
  "POP_JUMP_IF_NONE" 和 "POP_JUMP_IF_NOT_NONE" 虚拟化，映射到新的相对
  跳转操作码。

* bpo-45317: 添加内部文档，解释新的（针对3.11版本）帧栈的设计。

* bpo-47197: ctypes 过去错误处理 "void" 返回类型，例如，像
  "ctypes.CFUNCTYPE(None, ctypes.c_int)" 这样声明的函数会以 "int
  f(int)" 的签名被调用，而不是 "void f(int)"。Wasm 目标要求以正确的签
  名调用函数指针，因此这导致了崩溃。现在这个问题已经修复。

* bpo-47120: Make opcodes "JUMP_IF_TRUE_OR_POP" and
  "JUMP_IF_FALSE_OR_POP" relative rather than absolute.

* bpo-47177: 将内部 "_PyInterpreterFrame" 结构体的 "f_lasti" 成员替换
  为 "prev_instr" 指针，这减少了主解释器循环的开销。 Python 层面框架对
  象的 "f_lasti" 属性被保留用于向下兼容。

* bpo-46961: 整数模/余数操作，包括 "pow()" 的三参数形式，现在在适用时
  一致地从全局小整数缓存返回整数。

* bpo-46962: 类和函数不再无视 "--without-doc-strings" 编译标志无条件声
  明它们的文档字符串。

  受影响的类有 "ctypes.UnionType"、"pickle.PickleBuffer"、
  "testcapi.RecursingInfinitelyError" 和 "types.GenericAlias"。

  受影响的函数是 "ctypes" 中的24个方法。

  由 Oleg Iarygin 提供补丁。

* bpo-46942: 使用 Argument Clinic 为 "types.MethodType" 构造函数。由
  Oleg Iarygin 提供补丁。

* bpo-46764: 修复使用 @classmethod 包装绑定方法的问题。

* bpo-43464: 为非集合参数优化 "set.intersection()"。

* bpo-46721: 为非集合参数优化 "set.issuperset()"。

* bpo-46509: 添加 "Py_DECREF()" 的类型特化版本，并为 "float"、"int"、
  "str"、"bool" 和 "None" 使用它们，以避免在运行时类型已知的情况下进行
  指针追踪。

* bpo-46045: 在 NetBSD 上不使用 POSIX 信号量。

* bpo-36819: 修复内置编码器中错误处理程序返回的位置小于或等于不可编码
  字符起始位置时的崩溃问题。

* bpo-34093: "marshal.dumps()" 对所有内部字符串使用 "FLAG_REF"。这使得
  输出更加确定性，有助于可重现的构建。

* bpo-26579: 添加了 "object.__getstate__"，提供了 "__getstate__()" 方
  法的默认实现。

  现在复制和腌制内置类型 bytearray、set、frozenset、
  collections.OrderedDict、collections.deque、weakref.WeakSet 和
  datetime.tzinfo 的子类实例时，会复制和腌制作为槽实现的实例属性。


库
--

* gh-87901: 向 "os.popen()" 添加 *encoding* 参数。

* gh-90997: 修复 "dis" 工具可能将填充的内联缓存条目解释为有效指令的问
  题。

* gh-92332: 弃用 "typing.Text" (目前未计划移除该类) 。由 Alex Waygood
  提供补丁。

* gh-78157: 弃用枚举定义中成为成员的嵌套类——在 3.13 中它们将成为普通类
  ；添加 "member" 和 "nonmember" 函数以允许现在控制结果。

* gh-92356: 修复了 ctypes 函数调用中的性能回归问题。

* gh-90997: 当向 "dis" 工具传递 "show_caches=True" 时，显示存储在内联
  缓存中的实际命名值。

* gh-92301: 在 "subprocess" 模块中，优先使用 "close_range()" 而非遍历
  procfs来关闭文件描述符，以获得更好的性能。

* gh-67248: 在Cmd.do_help()中对杂项主题进行排序。

* gh-92210: 将 "socket.__init__" 移植到Argument Clinic。由Cinder提供补
  丁。

* gh-80010: 为 "datetime.datetime.fromisoformat()"、
  "datetime.date.fromisoformat()" 和 "datetime.time.fromisoformat()"
  添加对广义ISO 8601解析的支持。由Paul Ganssle提供补丁。

* gh-92118: 修复了 "contextmanager()" 在3.11版本中的一个回归问题，该问
  题导致异常传播时跟踪信息不正确。

* gh-90887: 为macOs上的 "os.fcopyfile()" 添加 "COPYFILE_STAT"、
  "COPYFILE_ACL" 和``COPYFILE_XATTR``常量。

* gh-91215: For @dataclass, add weakref_slot. Default is False. If
  True, and if slots=True, add a slot named "__weakref__", which will
  allow instances to be weakref'd. Contributed by Eric V. Smith

* gh-85984: 为Unix新增函数os.login_tty()。

* gh-92128: 向 "logging.LoggerAdapter" 和 "logging.StreamHandler" 添加
  "__class_getitem__()" 方法，允许它们在运行时被参数化。由Alex Waygood
  提供补丁。

* gh-92049: 禁止pickling常量 "re._constants.SUCCESS" 等。之前，
  pickling不会失败，但结果无法被unpickle。

* gh-92062: 如果 "name" 是一个关键字，除了现有的检查它是标识符外，
  "inspect.Parameter" 现在会引发 "ValueError"。

* gh-87390: 向 "types.GenericAlias" 添加一个 "__unpacked__" 属性。由
  Jelle Zijlstra提供补丁。

* gh-88089: 添加对泛型 "typing.NamedTuple" 的支持。

* gh-91996: 新增http.HTTPMethod枚举，以方便的方式表示所有可用的HTTP请
  求方法

* gh-91984: 修改test_argparse.py中的测试字符串，使其在行尾不包含尾随空
  格。

* gh-91952: 向 "TextIOWrapper.reconfigure()" 添加 "encoding="locale""
  支持。

* gh-91954: 向 "subprocess.getoutput()" 和
  "subprocess.getstatusoutput()" 添加 *encoding* 和 *errors* 参数。

* bpo-47029: 在向管道的写入端最后一次写入缓冲数据*之后*，始终关闭
  "multiprocessing.Queue" 使用的管道的读取端，以避免在垃圾回收和调用
  "multiprocessing.Queue.close()" 时出现 "BrokenPipeError"。补丁由
  Géry Ogam 提供。

* gh-91928: 为 "datetime.timezone.utc" 添加 "datetime.UTC" 别名。

  由 Kabir Kwatra 提供补丁。

* gh-68966: The "mailcap" module is now deprecated and will be removed
  in Python 3.13. See **PEP 594** for the rationale and the
  "mimetypes" module for an alternative. Patch by Victor Stinner.

* gh-91401: 提供一种方法来禁用 "subprocess" 使用 "vfork()"，以防万一需
  要，并记录 "posix_spawn()" 的现有机制。

* gh-64783: 修复 FreeBSD 上的 "signal.NSIG" 值，以接受大于 32 的信号编
  号，如 "signal.SIGRTMIN" 和 "signal.SIGRTMAX"。由 Victor Stinner 提
  供补丁。

* gh-91910: 在 "multiprocessing" 和 "asyncio" 模块的错误消息中，为 f-
  字符串添加缺失的 f 前缀。

* gh-91860: 添加 "typing.dataclass_transform()"，实现 **PEP 681**。由
  Jelle Zijlstra 提供补丁。

* gh-91832: 在 "argparse.Action" 的 repr 输出中添加 "required" 属性。

* gh-91827: 在 "tkinter" 模块中添加方法 "info_patchlevel()"，该方法返
  回 Tcl 库的确切版本，作为一个类似于 "sys.version_info" 的命名元组。

* gh-84461: 添加 "--enable-wasm-pthreads" 以启用 WASM 构建的 pthreads
  支持。"Emscripten/node" 不再默认启用线程。包括额外的文件系统。

* gh-91821: 修复 "test_decimal.py" 中不稳定的 "test_from_tuple" 测试。

* gh-91217: 弃用 xdrlib 模块。

* gh-91217: 弃用 uu 模块。

* gh-91760: 在正则表达式中，对数值组引用和组名将应用更严格的规则。目前
  ，对于未来Python版本中将变为错误的组引用和组名，会发出弃用警告。

* gh-84461: 添加临时的 "sys._emscripten_info" 命名元组，包含有关
  Emscripten平台的构建时和运行时信息。

* gh-90623: "signal.raise_signal()" 和 "os.kill()" 现在会立即检查挂起
  的信号。由Victor Stinner提交的补丁。

* gh-91734: 修复Solaris上的OSS音频支持。

* gh-90633: 在由 "typing.assert_never()" 抛出的异常中包含传递的值。由
  Jelle Zijlstra提交的补丁。

* gh-91700: 现在，包含条件表达式 "(?(group)...)" 的正则表达式的编译，
  如果组号引用未定义的组，将引发适当的 "re.error"。之前会引发内部
  RuntimeError。

* gh-91231: 向 "multiprocessing.BaseManager" 构造函数添加一个可选的关
  键字参数 *shutdown_timeout*。如果terminate()操作超过超时时间，则终止
  进程。由Victor Stinner提交的补丁。

* gh-91621: 修复 "typing.get_type_hints()" 对
  "collections.abc.Callable" 的支持。由Shantanu Jain提交的补丁。

* gh-90568: 在 "regular expression" 中解析Unicode命名字符序列的 "\N"
  转义现在会引发 "re.error" 而不是 "TypeError"。

* gh-91670: 移除 "sysconfig" 中已弃用的 "SO" 配置变量。

* gh-91217: 弃用telnetlib模块。

* gh-91217: 弃用sunau模块。

* gh-91217: 弃用spwd模块。

* gh-91217: 弃用sndhdr模块，以及为 "email.mime.MIMEAudio" 内联所需的功
  能。

* gh-91616: "re" 模块，修复使用原子分组或占有量词时的 "fullmatch()" 不
  匹配问题。

* gh-91217: 弃用'pipes'模块。

* gh-91217: 弃用ossaudiodev模块。

* bpo-47256: "re" 模块，在64位构建中将最大捕获组限制为1,073,741,823，
  这增加了回溯的深度。

* gh-91217: 弃用 nis 模块。

* gh-91595: 修复 "Tools.gdb.libpython.write_repr()" 中字符和整数的比较
  。由 Yu Liu 提交的补丁。

* gh-74166: 添加选项以在 "create_connection()" 无法建立连接时将所有错
  误以 "ExceptionGroup" 的形式抛出。默认行为仍然是仅抛出尝试多个地址时
  发生的最后一个错误。

* gh-91487: 优化 asyncio UDP 速度，传输大文件时速度提升超过100倍。

* gh-91575: 将 "re" 模块中的大小写不敏感匹配更新至最新的 Unicode 版本
  。

* gh-90622: 在 "concurrent.futures.process.ProcessPoolExecutor" 中，当
  使用新的 "max_tasks_per_child" 特性时，禁止使用 "fork" 多进程启动方
  法，因为线程+fork 的混合会导致子进程挂起。在这种情况下，如果没有提供
  "mp_context"，默认使用安全的 "spawn" 启动方法。

* gh-89022: 在 "sqlite3" 中，"SQLITE_MISUSE" 结果代码现在映射到
  "InterfaceError" 而不是 "ProgrammingError"。此外，当绑定参数失败时，
  会抛出更准确的异常。由 Erlend E. Aasland 提交的补丁。

* gh-91526: 停止在 "TextIOWrapper" 中调用
  "os.device_encoding(file.fileno())"。它复杂，从未被文档化，并且在大
  多数情况下不起作用。（由 Inada Naoki 提交的补丁。）

* gh-88116: 将 "inspect" 模块中与帧相关的函数更改为返回一个常规对象（
  与旧的类似元组的接口向后兼容），该对象包括扩展的 **PEP 657** 位置信
  息（结束行号、列和结束列）。受影响的函数有："inspect.getframeinfo()"
  、"inspect.getouterframes()"、"inspect.getinnerframes()"、
  "inspect.stack()" 和 "inspect.trace()"。由 Pablo Galindo 提交的补丁
  。

* gh-69093: 为 "sqlite3.Blob" 添加索引和切片支持。由 Aviv Palivoda 和
  Erlend E. Aasland 提交补丁。

* gh-69093: 为 "sqlite3.Blob" 添加 上下文管理器` 支持。由 Aviv
  Palivoda 和 Erlend E. Aasland 提交补丁。

* gh-91217: 废弃 nntplib。

* gh-91217: 废弃 msilib。

* gh-91404: 通过在支持的平台上使用计算跳转（或“线程代码”）并移除昂贵的
  指针间接寻址，提高 "re" 匹配的性能。

* gh-91217: 废弃 imghdr 模块。

* gh-91217: 废弃 crypt 模块。

* gh-91276: 在 "dis" 输出中为更长的操作码腾出空间。

* bpo-47000: 当指定 "encoding="locale"" 时，即使处于 UTF-8 模式，
  "TextIOWrapper" 也使用区域编码。

* gh-91230: "warnings.catch_warnings()" 现在接受
  "warnings.simplefilter()" 的参数，提供了一种更简洁的方式来本地忽略警
  告或将它们转换为错误。

* gh-91217: 废弃 chunk 模块。

* gh-91498: 在 "socket" 中添加 "TCP_CONNECTION_INFO" 选项（在 macOS 上
  可用）。

* bpo-47260: 修复 "os.closerange()" 在 Linux seccomp 沙箱中可能不执行
  任何操作的问题。

* bpo-47087: 实现 "typing.Required" 和 "typing.NotRequired" (**PEP
  655**)。由 David Foster 和 Jelle Zijlstra 提交补丁。

* bpo-47061: 废弃 cgi 和 cgitb。

* bpo-47061: 废弃 audioop。

* bpo-47000: 添加 "locale.getencoding()" 以获取当前区域编码。它类似于
  "locale.getpreferredencoding(False)"，但忽略 Python UTF-8 模式。

* bpo-42012: 添加 "wsgiref.types"，包含用于静态类型检查的 WSGI 特定类
  型。

* bpo-47227: 对更多 "re" 解析错误抑制表达式链。

* bpo-47211: 移除未文档化且从未工作的函数 "re.template()" 和标志
  "re.TEMPLATE"。这在 3.11.0b2 中被撤销并改为废弃。

* bpo-47135: "decimal.localcontext()" 现在通过关键字参数接受上下文属性
  。

* bpo-43323: 修复 "email" 模块中如果字符集本身包含不可解码/不可编码字
  符时的错误。

* bpo-46841: 快速代码的反汇编。

* bpo-46681: 将 gzip.compress() 的 compresslevel 参数传递给 zlib。

* bpo-45100: 添加 "typing.get_overloads()" 和
  "typing.clear_overloads()"。由 Jelle Zijlstra 提供补丁。

* bpo-44807: "typing.Protocol" 不再静默替换子类上定义的 "__init__()"
  方法。由 Adrian Garcia Badaracco 提供补丁。

* bpo-46787: 修复 "concurrent.futures.ProcessPoolExecutor" 异常内存泄
  漏

* bpo-46720: 为 Windows 添加对路径类对象的支持到
  "multiprocessing.set_executable()"，以与类 Unix 系统保持一致。由
  Géry Ogam 提供补丁。

* bpo-46696: 添加 "SO_INCOMING_CPU" 常量到 "socket"。

* bpo-46053: 修复 NetBSD 上的 OSS 音频支持。

* bpo-45639: 添加 "image/avif" 和 "image/webp" 到 "mimetypes"。

* bpo-46285: 为模块 "http.server" 添加命令行选项 "-p"/"--protocol"，指
  定服务器符合的 HTTP 版本（HTTP/1.1 兼容的服务器现在可以从模块
  "http.server" 的命令行界面运行）。由 Géry Ogam 提供补丁。

* bpo-44791: 接受省略号作为 "typing.Concatenate" 的最后一个参数。

* bpo-46547: 移除泄漏到 "pydoc.Helper" 类命名空间的变量。

* bpo-46415: 修复 ipaddress.ip_{address,interface,network} 在给定无效
  元组作为地址参数时抛出 TypeError 而不是 ValueError 的问题。

* bpo-46075: 带有 "DefaultCookiePolicy" 的 "CookieJar" 现在可以处理来
  自 localhost 的 cookie，这些 cookie 在 Set-Cookie 头中明确指定了
  domain=localhost。

* bpo-45995: 在字符串格式化规范中添加 "z" 选项，该选项在四舍五入到格式
  精度后，将负零浮点值强制转换为正零。由 John Belmonte 贡献。

* bpo-26175: 为 "tempfile.SpooledTemporaryFile" 对象完全实现
  "io.BufferedIOBase" 或 "io.TextIOBase" 接口。这使得它们能与更高层次
  的模块（如压缩模块）正确协作。由 Carey Metcalfe 提供补丁。

* bpo-45138: 修复 "sqlite3" 跟踪回调中的一处回归问题，其中绑定参数未在
  传递的语句字符串中展开。此回归问题由 Python 3.10 中的 bpo-40318 引入
  。补丁由 Erlend E. Aasland 提供。

* bpo-44863: 允许 "TypedDict" 子类在基于类的语法中也包含 "Generic" 作
  为基类。从而允许用户定义一个泛型 "TypedDict"，就像用户定义的泛型一样
  ，但具有 "TypedDict" 语义。

* bpo-44587: 修复 BooleanOptionalAction 不自动添加默认字符串的问题。如
  果需要默认字符串，使用格式化程序添加。

* bpo-43827: "ABCMeta.__new__" 的所有位置或关键字参数现在都是仅位置的
  ，以避免与要传递给 "__init_subclass__()" 的关键字参数冲突。

* bpo-43218: 防止创建路径包含 PATH 分隔符的 venv。这可能会影响激活脚本
  的使用。由 Dustin Rodrigues 提供补丁。

* bpo-38435: 向 "subprocess.Popen" 添加一个 "process_group" 参数，以帮
  助将更多内容从不安全的 "preexec_fn" 参数中移出。

* bpo-42066: 修复 "CookieJar.__iter__()" 中对 cookie 进行排序的问题，
  这是一个额外的行为，且在 RFC 2965 或 Netscape cookie 协议中未提及。
  现在 "CookieJar" 中的 cookie 遵循 "Set-Cookie" 头的顺序。由 Iman
  Kermani 提供补丁。

* bpo-40617: 向 "sqlite3.Connection" 添加 "create_window_function()"
  用于创建聚合窗口函数。由 Erlend E. Aasland 提供补丁。

* bpo-40676: 将 "csv" 模块的 "csv.field_size_limit()"、
  "csv.get_dialect()"、"csv.unregister_dialect()" 和
  "csv.list_dialects()" 转换为使用 Argument Clinic。

* bpo-39716: 当相同的子解析器名称被两次添加到
  "argparse.ArgumentParser" 时，引发一个 "ArgumentError"。这与当相同的
  选项字符串被两次添加到 "ArgumentParser" 时的（默认）行为一致。

* bpo-36073: 在 "sqlite3" 转换器中递归使用游标时，引发
  "ProgrammingError" 而不是段错误。由 Sergey Fedoseev 提供补丁。

* bpo-34975: 向 "StreamWriter" 添加了一个 "start_tls()" 方法，该方法使
  用给定的 "SSLContext" 升级连接为 TLS。

* bpo-22276: "Path" 的方法 "glob()" 和 "rglob()" 如果 *pattern* 以路径
  名组件分隔符（"/" 或 "sep"）结尾，则仅返回目录。由 Eisuke Kawashima
  提供补丁。

* bpo-24905: 向 "sqlite3.Connection" 添加了 "blobopen()"。
  "sqlite3.Blob" 允许对 blob 进行增量 I/O 操作。由 Aviv Palivoda 和
  Erlend E. Aasland 提供补丁。


文档
----

* gh-91888: 向文档添加一个新的 "gh" 角色，以链接到 GitHub 问题。

* gh-91783: 记录关于使用函数 "shutil.unpack_archive()" 的安全问题。

* gh-91547: 移除“未记录模块”页面。

* gh-91298: 在 "importlib.resources.abc" 中，完善了 Traversable 协议的
  文档，应用了从 importlib_resources 5.7.1 的更改。

* bpo-44347: 澄清了 *dirs_exist_ok* 的含义，这是 "shutil.copytree()"
  的一个关键字参数。

* bpo-36329: 移除 'make -C Doc serve'，支持 'make -C Doc htmlview'。

* bpo-47189: 为 Faster CPython 项目添加 Python 3.11 新特性条目。文档由
  Ken Jin 和 Kumar Aditya 提供。

* bpo-38668: 更新 "os.path" 文档的引言，移除在实现了 **PEP 383** 和
  **PEP 529** 后变得无关紧要的警告。

* bpo-47115: 文档现在列出了C结构体的哪些成员是 Limited API/Stable ABI
  的一部分。

* bpo-46962: All docstrings in code snippets are now wrapped into
  "PyDoc_STR" to follow the guideline of PEP 7's Documentation Strings
  paragraph. Patch by Oleg Iarygin.

* bpo-26792: 改进 "runpy.run_module()" 和 "runpy.run_path()" 的文档字
  符串。原始补丁由Andrew Brezovsky提供。


测试
----

* gh-92169: 在测试中统一使用 "warnings_helper.import_deprecated()" 来
  导入已弃用的模块。补丁由Hugo van Kemenade提供。

* gh-84461: 当启用多进程时，libregrtest现在可以通过 "--python" 标志使
  用除 "sys.executable" 之外的Python可执行文件。

* gh-91904: 修复 "PYTHONREGRTEST_UNICODE_GUARD" 的初始化，该问题阻止了
  在非UTF-8语言环境下运行回归测试。

* gh-91752: 在test.test_tools.test_freeze.TestFreeze中添加了
  @requires_zlib。

* gh-91607: 修复 "test_concurrent_futures"，在测试逻辑混淆的情况下测试
  正确的多进程启动方法上下文。

* bpo-40280: 现在在没有pthread支持的WASM目标上跳过线程测试。

* bpo-47109: 将 "ctypes.macholib.dyld"、"ctypes.macholib.dylib" 和
  "ctypes.macholib.framework" 的测试从手动的前 "unittest" 时代带到
  "ctypes.test" 的位置和结构。由Oleg Iarygin提供补丁。

* bpo-29890: 为 "ipaddress.IPv4Interface" 和 "ipaddress.IPv6Interface"
  添加了使用元组参数构造的测试。原始补丁和测试由louisom提供。


构建
----

* gh-89452: 如果系统中同时存在gdbm-compat和ndbm，现在优先选择gdbm-
  compat。这样可以避免在macOS上使用有问题的ndbm.h。

* gh-91731: Python 现在使用 "-std=c11" 编译器选项构建，而不是
  "-std=c99"。由 Victor Stinner 提供补丁。

* bpo-47152: 添加用于生成 "sre_constants.h" 的脚本和 make 目标。

* bpo-47103: Windows "PGInstrument" 构建现在会将一个必需的 DLL 复制到
  输出目录，使得运行 PGO 构建的分析阶段更加容易。


Windows
-------

* bpo-46907: 更新 Windows 安装程序以使用 SQLite 3.38.3。

* bpo-47239: 修复了在活动虚拟环境中使用 适用于Windows的Python启动器 时
  的 --list 和 --list-paths 输出。

* bpo-46907: 更新 Windows 安装程序以使用 SQLite 3.38.2。

* bpo-46785: 通过适当在 "win32_xstat_impl" 中使用 "FindFirstFileW()"
  返回的错误代码，修复了 Windows 上 "os.stat()" 和取消链接文件之间的竞
  态条件。

* bpo-40859: 更新 Windows 构建以使用 xz-5.2.5。


macOS
-----

* bpo-46907: 更新 macOS 安装程序以使用 SQLite 3.38.4。


工具/示例
---------

* gh-91583: 修复了 Argument Clinic 为带有 "defining_class" 参数的函数
  生成的代码中的回归问题。

* gh-91575: 添加脚本 "Tools/scripts/generate_re_casefix.py" 和 make 目
  标 "regen-re"，用于根据当前 Unicode 版本生成用于大小写不敏感匹配的额
  外数据。

* gh-91551: 移除了古老的 Pynche 颜色编辑器。它已经迁移到
  https://gitlab.com/warsaw/pynche。


C API
-----

* gh-88279: Deprecate the C functions: "PySys_SetArgv()",
  "PySys_SetArgvEx()", "PySys_SetPath()". Patch by Victor Stinner.

* gh-92154: 添加了 "PyCode_GetCode()" 函数。此函数执行等同于 Python 代
  码 "getattr(code_object, 'co_code')" 的操作。

* gh-92173: 修复了 "PyEval_EvalCodeEx()" 的 "closure" 参数。

* gh-91320: 修复了关于 Python C API 中“旧式转换”（"g++ -Wold-style-
  cast"）的 C++ 编译器警告。在 C++ 中使用 Python C API 时，使用 C++ 的
  "reinterpret_cast<>" 和 "static_cast<>" 转换。由 Victor Stinner 提供
  补丁。

* gh-80527: 通过 **PEP 623** 将以下函数标记为弃用 :
  "PyUnicode_AS_DATA()", "PyUnicode_AS_UNICODE()",
  "PyUnicode_GET_DATA_SIZE()", "PyUnicode_GET_SIZE()"。由 Victor
  Stinner 提供补丁。

* gh-91768: "Py_REFCNT()", "Py_TYPE()", "Py_SIZE()" 和 "Py_IS_TYPE()"
  函数的参数类型现在为 "PyObject*" 而不是 "const PyObject*"。补丁由
  Victor Stinner 提供。

* gh-91020: 添加 "PyBytes_Type.tp_alloc" 来为 bytes 子类初始化
  "PyBytesObject.ob_shash"。

* bpo-40421: 添加 "PyFrame_GetLasti" C-API 函数以安全地从 C 代码访问帧
  对象的 "f_lasti" 属性。

* bpo-35134: 移除 "Include/code.h" 头文件。C 扩展应仅包含主
  "<Python.h>" 头文件。补丁由 Victor Stinner 提供。

* bpo-47169: "PyOS_CheckStack()" 现在在 Windows 上的稳定 ABI 中导出。

* bpo-47169: "PyThread_get_thread_native_id()" 在不存在的平台（如
  Solaris）上被排除在稳定 ABI 之外。

* bpo-46343: 添加 "PyErr_GetHandledException()" 和
  "PyErr_SetHandledException()" 作为 "PyErr_GetExcInfo()" 和
  "PyErr_SetExcInfo()" 的更简单替代。

  它们被包含在稳定 ABI 中。


Python 3.11.0 alpha 7
=====================

*发布日期: 2022-04-05*


核心与内置函数
--------------

* bpo-47212: 对于没有后续缩进的裸 "except"，抛出 "IndentationError" 而
  不是 "SyntaxError"。对于用作参数的无括号生成器，改进 "SyntaxError"
  的位置。由 Matthieu Dartiailh 提供补丁。

* bpo-47186: 用 "CHECK_EG_MATCH" + 跳转替换 "JUMP_IF_NOT_EG_MATCH"。

* bpo-47176: 由于平台限制，Emscripten 构建不能以通常的方式处理信号。
  Python 现在可以处理信号。要使用，设置
  Module.Py_EmscriptenSignalBuffer 为单个字节的 SharedArrayBuffer 并设
  置 Py_EMSCRIPTEN_SIGNAL_HANDLING 为 1。向 SharedArrayBuffer 写入一个
  数字将导致相应的信号被提升到 Python 线程中。

* bpo-47186: 用 "CHECK_EXC_MATCH" + jump 替换 "JUMP_IF_NOT_EXC_MATCH"
  。

* bpo-47120: 用相对的 "JUMP_BACKWARD_NO_INTERRUPT" 替换绝对跳转操作码
  "JUMP_NO_INTERRUPT"。

* bpo-46841: 比较代码对象时避免不必要的分配。

* bpo-47182: 修复在主解释器第二次初始化后使用命名Unicode字符如
  ""\N{digit nine}"" 时崩溃的问题。

* bpo-47162: WebAssembly 无法处理错误的函数指针转换（参数数量或类型不
  同）。Python 现在可以使用调用蹦床来缓解这个问题。定义
  "PY_CALL_TRAMPOLINE" 来启用调用蹦床。

* bpo-46775: 现在一些Windows系统错误代码(>= 10000)被正确映射到errno，
  并可能引发 "OSError" 的子类。由Donghee Na提供补丁。

* bpo-47129: 改进关于空表达式的f-string语法错误消息。

* bpo-47117: 修复在交互模式下如果分词器缓冲区未初始化时解码字符失败导
  致的崩溃。由Pablo Galindo提供补丁。

* bpo-47127: 通过特殊化，将带有关键字参数的c函数调用速度提高25%。由
  Kumar Aditya提供补丁。

* bpo-47120: 用相对跳转 "JUMP_BACKWARD" 替换 "JUMP_ABSOLUTE"。

* bpo-42197: "PyFrame_FastToLocalsWithError()" 和
  "PyFrame_LocalsToFast()" 在性能分析或跟踪期间不再被调用。C代码可以通
  过调用 "PyFrame_GetLocals()" 来访问 "PyFrameObject" 的 "f_locals" 属
  性。

* bpo-47070: 通过减少 "memcpy" 的调用次数来提高 "array_inplace_repeat"
  的性能。重构 "array", "bytes", "bytearray" 和 "unicodeobject" 的
  "repeat" 和原地 "repeat" 方法以使用共同的 "_PyBytes_Repeat"。

* bpo-47053: 减少专业化的 "BINARY_OP_INPLACE_ADD_UNICODE" 操作码中的去
  优化。

* bpo-47045: 从 _PyInterpreterFrame 结构中移除 "f_state" 字段。向
  _PyInterpreterFrame 结构添加 "owner" 字段，以明确所有权，简化帧和生
  成器的清理和释放。

* bpo-46968: 在 "faulthandler" 中检查 "sys/auxv.h" 头文件的存在，以避
  免在不存在此头文件的系统中出现编译问题。由 Pablo Galindo 提供补丁。

* bpo-46329: 使用 "LOAD_GLOBAL" 的低位来指示是否在全局变量之前推送一个
  "NULL"。有助于稍微简化调用序列。

* bpo-46841: 通过将快速字节码存储为相应的 "PyCodeObject" 的一部分，原
  地快速化字节码。

* bpo-47012: 通过 Kumar Aditya 的补丁，将 "bytes" 和 "bytearray" 的迭
  代速度提高了 30%。

* bpo-47009: Improved the performance of "list.append()" and list
  comprehensions by optimizing for the common case, where no resize is
  needed. Patch by Dennis Sweeney.

* bpo-47005: 通过减少 "memcpy" 的调用次数，提高了 "bytearray_repeat"
  和 "bytearray_irepeat" 的性能。

* bpo-46829: 弃用在 "asyncio.Future.cancel()" 和
  "asyncio.Task.cancel()" 中传递消息的做法。

* bpo-46993: 通过 Kumar Aditya 的补丁，将 "bytearray" 从 "list" 和
  "tuple" 创建的速度提高了 40%。

* bpo-39829: 移除了初始化列表时的 "__len__()" 调用，并将初始化移至
  "list_extend"。由 Jeremiah Pascual 提供补丁。

* bpo-46944: 通过 "METH_FASTCALL" 调用约定，加快了在生成器中抛出异常的
  速度。补丁由 Kumar Aditya 提供。

* bpo-46841: 修改 "STORE_SUBSCR" 以使用内联缓存条目（而非其操作数）作
  为自适应计数器。

* bpo-46841: Use inline caching for "PRECALL" and "CALL", and remove
  the internal machinery for managing the (now unused) non-inline
  caches.

* bpo-46881: 静态分配并初始化 latin1 字符。

* bpo-46838: 改进不正确函数定义的语法错误。由Pablo Galindo提供补丁。

* bpo-43721: 修复 "getter", "setter", 和 "deleter" 的文档字符串，以明
  确它们创建属性的新副本。

* bpo-43224: 为PEP 646做出所需的语法更改。


库
--

* bpo-47208: 允许供应商覆盖 "CTYPES_MAX_ARGCOUNT"。

* bpo-23689: "re" 模块: 修复当匹配因信号或内存分配失败而终止时的内存泄
  漏。由Ma Lin提供补丁。

* bpo-47167: 允许在 "asyncio.Task" 中覆盖未来的合规性检查。

* bpo-47151: 当子进程尝试使用vfork时，如果vfork返回错误，现在会回退到
  fork。这允许在操作系统内核不允许vfork的情况下使用。

* bpo-47152: 将 "re" 模块转换为包。弃用模块 "sre_compile",
  "sre_constants" 和 "sre_parse"。

* bpo-4833: 添加 "ZipFile.mkdir()"

* bpo-27929: 修复 "asyncio.loop.sock_connect()" 仅解析
  "socket.AF_INET" 或 "socket.AF_INET6" 家族的名称。对于其他家族，如
  "socket.AF_BLUETOOTH" 和 "socket.AF_UNIX"，解析可能没有意义。

* bpo-14265: 将完全限定的测试名称添加到unittest输出中

* bpo-47061: 弃用aifc模块。

* bpo-39622: 在asyncio程序中处理Ctrl+C以中断主任务。

* bpo-47101: "hashlib.algorithms_available" 现在仅列出由OpenSSL 3.0上
  激活的加密提供者提供的算法。除非将遗留提供者加载到默认的OSSL上下文中
  ，否则不会列出遗留算法。

* bpo-47099: "urllib.request.URLopener" 中引发的所有 "URLError" 异常消
  息现在在 "ftp error" 和消息的其余部分之间包含冒号。之前，
  "open_ftp()" 缺少冒号。由Oleg Iarygin提供补丁。

* bpo-47099: 异常链的机制从
  "Exception.with_traceback()"/"sys.exc_info()" 更改为 **PEP 3134**。
  由 Oleg Iarygin 提供补丁。

* bpo-47095: "hashlib" 的内部 "_blake2" 模块现在优先使用来自
  https://www.blake2.net/ 的 "libb2" 而不是 Python 自带的 blake2 副本
  。

* bpo-47098: "hashlib" 内部 "_sha3" 模块的 Keccak 代码包已被替换为
  tiny_sha3。该模块在 Python 构建时不带 OpenSSL 时作为回退使用。

* bpo-47088: 实现了 "typing.LiteralString"，这是 **PEP 675** 的一部分
  。由 Jelle Zijlstra 提供补丁。

* bpo-42885: 对以 "\A" 或 "^" 开始的正则表达式优化了 "re.search()"、
  "re.split()"、"re.findall()"、"re.finditer()" 和 "re.sub()"。

* bpo-23691: 保护 "re.finditer()" 迭代器不被重新进入。

* bpo-47067: 通过使用 **PEP 590** "vectorcall" 并用 "PyObject_SetAttr"
  替换 "PyObject_SetAttrString"，优化了对 "GenericAlias" 对象的调用。

* bpo-28080: 在 "zipfile.ZipFile" 构造函数中添加了 *metadata_encoding*
  参数，并在 "zipfile" CLI 中添加了 "--metadata-encoding" 选项，以允许
  使用非标准编解码器读取压缩包中的文件名。

* bpo-47000: 当启用 UTF-8 模式时，使 "io.text_encoding()" 返回 "utf-8"
  。

* bpo-42369: 修复 "zipfile._SharedFile.tell()" 的线程安全性，以避免在
  多线程读取 "ZipFile" 时出现 "zipfile.BadZipFile: Bad CRC-32 for
  file" 异常。

* bpo-38256: 修复了当编译使用 zlib 的 crc32 时的 "binascii.crc32()"，
  使其正确处理长度超过 4GiB 的输入而不是返回错误结果。在此之前的解决方
  法是始终以小于 4GiB 的增量向函数提供数据，或直接调用 zlib 模块函数。

  我们还让 "binascii.crc32()" 在处理较大输入时释放 GIL，就像
  "zlib.crc32()" 和 "hashlib" 所做的那样。

  这也提升了Windows上的性能，因为现在 "binascii.crc32()" 使用了zlib
  crc32实现，速度提升了2-3倍。

  标准库在两个模块中都有crc32 API是一个已知的历史遗留问题。这使我们更
  接近于它们背后的单一实现。

* bpo-47066: 全局内联标志（例如 "(?i)"）现在只能在正则表达式的开头使用
  。从Python 3.6开始，不在表达式开头使用它们已被弃用。

* bpo-39394: 关于不在正则表达式开头的内联标志的警告现在包含标志的位置
  。

* bpo-433030: 在 "正则表达式" 中添加了对原子分组（"(?>...)"）和占有量
  词（"*+", "++", "?+", "{m,n}+"）的支持。

* bpo-47062: 实现 "asyncio.Runner" 上下文管理器。

* bpo-46382: "dataclass()" "slots=True" 现在正确地省略了基类中已经定义
  的槽。由Arie Bovenberg提供补丁。

* bpo-47057: 对 "FutureIter.throw()" 使用FASTCALL约定。

* bpo-47061: 弃用 **PEP 594** 中列出的各种模块：

  aifc, asynchat, asyncore, audioop, cgi, cgitb, chunk, crypt, imghdr,
  msilib, nntplib, nis, ossaudiodev, pipes, smtpd, sndhdr, spwd,
  sunau, telnetlib, uu, xdrlib

* bpo-34790: 移除将协程对象传递给 "asyncio.wait()"。

* bpo-47039: 标准化asyncio future和task对象的 "repr()"。

* bpo-2604: 修复了使用全局变量的doctests在多次运行时失败的bug。

* bpo-45150: 添加 "hashlib.file_digest()" 辅助函数，用于高效哈希文件对
  象。

* bpo-34861: 使cumtime成为cProfile的默认排序键。

* bpo-45997: 修复 "asyncio.Semaphore" 重新获取FIFO顺序的问题。

* bpo-47022: The "asynchat", "asyncore" and  "smtpd" modules have been
  deprecated since at least Python 3.6. Their documentation and
  deprecation warnings and have now been updated to note they will
  removed in Python 3.12 (**PEP 594**).

* bpo-43253: 修复在Proactor事件循环中关闭传输时底层套接字句柄已无效导
  致的崩溃问题。

* bpo-40280: "select.select()" 现在对每个空的fdset传递 "NULL" 给
  "select"。

* bpo-47004: 应用来自importlib_metadata 4.11.3的错误修复，包括修复
  EntryPoint.extras返回匹配对象而非额外字符串的问题。

* bpo-46998: 允许对 "typing.Any" 进行子类化。由Shantanu Jain提供补丁。

* bpo-46995: 弃用第三方任务实现中缺失的 "asyncio.Task.set_name()"，计
  划在Python 3.13中使其成为强制要求。

* bpo-46994: 在 "asyncio.create_task()" 和
  "asyncio.loop.create_task()" 中接受显式的contextvars.Context。

* bpo-46981: "typing.get_args(typing.Tuple[()])" 现在返回 "()" 而不是
  "((),)"。

* bpo-46968: 添加 "os.sysconf_names['SC_MINSIGSTKSZ']"。

* bpo-46985: 升级与ensurepip捆绑的pip wheel（pip 22.0.4）。

* bpo-46968: "faulthandler": 在Linux 5.14及更新版本上，动态确定CPython
  使用 "getauxval(AT_MINSIGSTKSZ)" 分配的信号处理程序堆栈大小。这一变
  化允许Python扩展请求Linux内核在Sapphire Rapids Xeon处理器上使用
  AMX_TILE指令集成功，解除了该ISA在框架中使用的阻碍。

* bpo-46917: "math.nan" 值现在总是可用。由Victor Stinner提供补丁。

* bpo-46955: 将 "asyncio.base_events.Server" 作为 "asyncio.Server" 公
  开。由Stefan Zabka提供补丁。

* bpo-23325: "signal" 模块不再假设 "SIG_IGN" 和 "SIG_DFL" 是小的int单
  例。

* bpo-46932: 更新捆绑的libexpat到2.4.7版本。

* bpo-46933: "pwd" 模块现在是可选的。当 "pwd" 模块不可用时，
  "os.path.expanduser()" 返回路径。

* bpo-40059: **PEP 680**，"tomllib" 模块。增加了对解析TOML的支持。

* bpo-464471: 添加了 "asyncio.timeout()" 和 "asyncio.timeout_at()" 上
  下文管理器。由Tin Tvrtković和Andrew Svetlov提交的补丁。

* bpo-46805: 为asyncio添加了原始数据报套接字函数："sock_sendto()"、
  "sock_recvfrom()" 和 "sock_recvfrom_into()"。

* bpo-46644: 不再要求有效的类型形式必须是可调用的。这允许
  "typing.Annotated" 包装 "typing.ParamSpecArgs" 和
  "dataclasses.InitVar"。由Gregory Beauregard提交的补丁。

* bpo-46581: 使 "GenericAlias" 的 "ParamSpec" 传播与 "Concatenate" (及
  其他) 保持一致。

* bpo-45413: 定义了 *posix_venv* 和 *nt_venv* sysconfig安装方案，用于
  引导新的虚拟环境。添加了 *venv* sysconfig安装方案以获取上述适当的方
  案。这些方案与预先存在的 *posix_prefix* 和 *nt* 安装方案相同。"venv"
  模块现在使用 *venv* 方案来创建新的虚拟环境，而不是仅根据平台硬编码路
  径。鼓励以与虚拟环境中使用的安装方案不兼容的方式定制 *posix_prefix*
  或 *nt* 安装方案的下游Python分发者不要定制 *venv* 方案。当Python本身
  在虚拟环境中运行时，"sysconfig.get_default_scheme()" 和
  "sysconfig.get_preferred_scheme()" 与 "key="prefix"" 返回*venv*。

* bpo-43224: 在typing.py中实现了对PEP 646的支持。

* bpo-43224: 允许解包types.GenericAlias对象，例如 "*tuple[int, str]"。

* bpo-46557: 现在，由logging模块捕获的警告将不带有格式字符串记录，以防
  止通过msg参数分组日志的系统将捕获的警告分组在一起。

* bpo-41370: "typing.get_type_hints()" 现在支持在 PEP 585 泛型别名 中
  将字符串作为前向引用进行评估。

* bpo-46607: Add "DeprecationWarning" to "LegacyInterpolation",
  deprecated in the docstring since Python 3.2. Will be removed in
  Python 3.13. Use "BasicInterpolation" or "ExtendedInterpolation"
  instead.

* bpo-26120: "pydoc" 现在从模块的数据项中排除 __future__ 导入。

* bpo-46480: 添加 "typing.assert_type()"。由 Jelle Zijlstra 提供补丁。

* bpo-46421: 修复了一个 unittest 问题，即如果命令以 "python -m
  unittest" 形式调用且文件名以点（.）开头，会返回 "ValueError"。

* bpo-46245: 在 "shutil.rmtree()" 中添加可选参数 *dir_fd*。

* bpo-22859: "usageExit()" is marked deprecated, to be removed in
  3.13.

* bpo-46170: 当你尝试子类化一个 "typing.NewType" 的实例时，改进了错误
  信息。

* bpo-40296: 修复 "pydoc" 中支持泛型别名的问题。

* bpo-20392: 修复 "MimeTypes.guess_type()" 中大写文件扩展名的不一致问
  题。由 Kumar Aditya 提供补丁。

* bpo-46030: 将 "LOCAL_CREDS"、"LOCAL_CREDS_PERSISTENT" 和
  "SCM_CREDS2" FreeBSD 常量添加到 socket 模块中。

* bpo-44439: 修复 "ZipFile" 中成员文件的 ".write()" 方法，当输入数据是
  支持缓冲协议的对象时，文件长度可能错误的问题。

* bpo-45171: 修复 "logging" 模块中处理 "stacklevel" 参数的问题，使其在
  所有日志记录函数中一致，并且如广告中所说，类似于 "warn()" 中使用的
  "stacklevel" 参数。

* bpo-24959: 修复 "unittest" 中有时会从测试中引发的异常的追溯中丢弃帧
  的错误。

* bpo-44859: 在 "sqlite3" 中引发更准确且符合 **PEP 249** 的异常。

  * 对于 "SQLITE_MISUSE" 错误，抛出 "InterfaceError" 而非
    "ProgrammingError"。

  * 当转换为 BLOB 失败时，不要用 "ValueError" 覆盖 "BufferError"。

  * Raise "ProgrammingError" instead of "Warning" if user tries to
    "execute()" more than one SQL statement.

  * 如果 SQL 查询包含空字符，抛出 "ProgrammingError" 而非 "ValueError"
    。

* bpo-44493: 在 sockaddr_un 的长度中添加缺失的终止 NUL。

  当使用非抽象的 AF_UNIX 数据报套接字与用另一种编程语言编写的进程通信
  时，这个问题可能被观察到。

* bpo-41930: 向 "sqlite3" 添加 "serialize()" 和 "deserialize()" 支持。
  由 Erlend E. Aasland 提供补丁。

* bpo-33178: 添加了 "ctypes.BigEndianUnion" 和
  "ctypes.LittleEndianUnion" 类，这些类最初在库文档中有所记载但尚未实
  现。

* bpo-43352: Add an Barrier object in synchronization primitives of
  *asyncio* Lib in order to be consistant with Barrier from
  *threading* and *multiprocessing* libs*

* bpo-35859: "re" 模块，修复了几个关于捕获组的 bug。在极少数情况下，捕
  获组会得到一个不正确的字符串。由马林提供补丁。


文档
----

* bpo-45099: 记录内部 "asyncio" API。

* bpo-47126: 将 PEP URL 更新为 **PEP 676** 的新规范形式。

* bpo-47040: Clarified the old Python versions compatiblity note of
  "binascii.crc32()" / "zlib.adler32()" / "zlib.crc32()" functions.

* bpo-46033: 在其文档中澄清 "for" 语句的执行。

* bpo-45790: 调整 自定义扩展类型：教程 中关于 "ob_base" 字段和用于访问
  其内容的宏的不准确措辞。

* bpo-42340: 记录在某些情况下 "KeyboardInterrupt" 可能导致代码进入不一
  致状态。如果需要，提供了一个示例解决方法以避免这种情况。

* bpo-41233: 将 "Doc/library/exceptions.rst" 中引用的 errnos 链接到它
  们在 "Doc/library/errno.rst" 中的相应部分，反之亦然。之前这仅对
  EINTR 和 InterruptedError 进行了操作。由 Yan "yyyyyyyan" Orestes 提
  供补丁。


测试
----

* bpo-47205: 在 FreeBSD 上跳过 "sched_getaffinity()" 和
  "sched_setaffinity()" 错误情况的测试。

* bpo-46126: 在内部运行测试时恢复 'descriptions'。

* bpo-47104: 重写 "asyncio.to_thread()" 测试以使用
  "unittest.IsolatedAsyncioTestCase"。

* bpo-40280: 测试套件现在可以在 Emscripten 平台上运行。所有基于 fork、
  socket 和 subprocess 的测试都被跳过。

* bpo-47037: 在 Windows 上跳过 "strftime("%4Y")" 功能测试。它可能会在
  调试构建中引起断言错误。

* bpo-46587: 如果平台的 "strftime" 不支持非可移植的 glibc 扩展，则跳过
  测试。

* bpo-47015: A test case for "os.sendfile()" is converted from
  deprecated "asyncore" (see **PEP 594**) to "asyncio". Patch by Oleg
  Iarygin.


构建
----

* bpo-40280: 添加配置选项 "--enable-wasm-dynamic-linking" 以在
  "wasm32-emscripten" 上启用 "dlopen" 和 MAIN_MODULE / SIDE_MODULE。

* bpo-46023: "makesetup" 现在可以检测并跳过所有重复的模块定义。第一个
  条目胜出。

* bpo-40280: 为 Emscripten 添加 SOABI "wasm32-emscripten"，为 WASI 在
  32bit WASM 上添加 "wasm32-wasi"，以及 "wasm64" 对应物。

* bpo-47032: 确保当构建的一部分失败时，Windows 安装构建能够正确地以非
  零退出码失败。

* bpo-47024: 为 macOS 安装程序和所有 Windows 构建更新 OpenSSL 到
  1.1.1n。

* bpo-46996: "tkinter" 包现在需要 Tcl/Tk 版本 8.5.12 或更高。

* bpo-46973: 添加 "regen-configure" make 目标以使用 Christian 的容器镜
  像 "quay.io/tiran/cpython_autoconf:269" 重新生成配置脚本。

* bpo-46917: Building Python now requires support of IEEE 754 floating
  point numbers. Patch by Victor Stinner.

* bpo-45774: "configure" 现在验证所有 "sqlite3" 扩展模块所需的 SQLite
  C API 是否都已找到。


Windows
-------

* bpo-47194: Update "zlib" to v1.2.12 to resolve CVE-2018-25032.

* bpo-47171: 支持在 Windows ARM64 上安装 "py.exe" 启动器。

* bpo-46566: 升级 适用于Windows的Python启动器 以支持新的
  "-V:company/tag" 参数，实现完整的 **PEP 514** 支持，并检测 ARM64 安
  装。参数中的 "-64" 后缀已被弃用，但仍会选择任何非 32 位的安装。设置
  "PYLAUNCHER_ALLOW_INSTALL" 并指定未安装的版本将尝试从 Microsoft
  Store 安装请求的版本。

* bpo-47086: Windows 安装程序现在包含的文档是松散的 HTML 文件，而不是
  一个单一的编译 ".chm" 文件。

* bpo-46907: 更新 Windows 安装程序，使用 SQLite 3.38.1。

* bpo-44549: Update bzip2 to 1.0.8 in Windows builds to mitigate
  CVE-2016-3189 and CVE-2019-12900

* bpo-46948: Prevent CVE-2022-26488 by ensuring the Add to PATH option
  in the Windows installer uses the correct path when being repaired.


macOS
-----

* bpo-46890: 修复了框架构建中 "sys._base_executable" 设置的回归问题，
  从而修复了此类构建中 "venv" 虚拟环境的回归问题。

* bpo-46907: 更新 macOS 安装程序到 SQLite 3.38.1。


工具/示例
---------

* bpo-40280: 用 Katie Bell 的 python-wasm 项目中的 browser-ui REPL 替
  换 Emscripten 的有限 shell。


C API
-----

* bpo-40421: 添加 "PyFrame_GetBuiltins"、"PyFrame_GetGenerator" 和
  "PyFrame_GetGlobals" C-API 函数，以便从 C 代码安全地访问帧对象属性。

* bpo-46850: 将私有的 "_PyFrameEvalFunction" 类型，以及私有的
  "_PyInterpreterState_GetEvalFrameFunc()" 和
  "_PyInterpreterState_SetEvalFrameFunc()" 函数移至内部 C API。
  "_PyFrameEvalFunction" 回调函数类型现在使用属于内部 C API 的
  "_PyInterpreterFrame" 类型。由 Victor Stinner 提供补丁。

* bpo-46850: 将未公开的私有函数 "_PyEval_EvalFrameDefault()" 移至内部
  C API。该函数现在使用属于内部 C API 的 "_PyInterpreterFrame" 类型。
  由 Victor Stinner 提供补丁。

* bpo-46850: 从 C API 中移除未公开的私有函数 "_PyEval_CallTracing()"。
  改为调用公开的 "sys.call_tracing()" 函数。由 Victor Stinner 提供补丁
  。

* bpo-46850: 从 C API 中移除未公开的私有函数
  "_PyEval_GetCoroutineOriginTrackingDepth()"。改为调用公开的
  "sys.get_coroutine_origin_tracking_depth()" 函数。由 Victor Stinner
  提供补丁。

* bpo-46850: 从 C API 中移除以下未公开的私有函数：

  * "_PyEval_GetAsyncGenFirstiter()"

  * "_PyEval_GetAsyncGenFinalizer()"

  * "_PyEval_SetAsyncGenFirstiter()"

  * "_PyEval_SetAsyncGenFinalizer()"

  改为调用公开的 "sys.get_asyncgen_hooks()" 和
  "sys.set_asyncgen_hooks()" 函数。补丁由 Victor Stinner 提供。

* bpo-46987: 移除私有函数 "_PySys_GetObjectId()" 和
  "_PySys_SetObjectId()"。由 Donghee Na 提供补丁。

* bpo-46906: 添加新的函数来打包和解包 C 双精度（序列化和反序列化）：
  "PyFloat_Pack2()", "PyFloat_Pack4()", "PyFloat_Pack8()",
  "PyFloat_Unpack2()", "PyFloat_Unpack4()" 和 "PyFloat_Unpack8()"。由
  Victor Stinner 提供补丁。


Python 3.11.0 alpha 6
=====================

*发布日期：2022-03-07*


核心与内置函数
--------------

* bpo-46940: 避免覆盖嵌套属性访问调用的 "AttributeError" 元数据信息。
  由 Pablo Galindo 提供补丁。

* bpo-46927: 在非泛型类型下标错误消息中包含类型的名称。

* bpo-46921: 支持 "super()" 的 vectorcall。由 Ken Jin 提供补丁。

* bpo-46841: 修复在特化 "BINARY_OP" 时内联缓存条目的不正确处理。

* bpo-46841: 使用 oparg 来简化 "GET_AWAITABLE" 中有用错误消息的构造。

* bpo-46903: 确保 str 子类可以作为具有虚拟字典的实例的属性名。修复了
  3.11alpha 中的回归问题。

* bpo-46841: 为 "COMPARE_OP" 后跟 "EXTENDED_ARG" 添加更详细的专门化失
  败统计信息。

* bpo-46891: 修复了 3.11alpha 中引入的 bug，其中带有 "__slots__" 的
  "types.ModuleType" 子类未正确初始化，导致解释器崩溃。

* bpo-46841: 对 "LOAD_ATTR"、"LOAD_METHOD" 和 "STORE_ATTR" 使用内联缓
  存。

* bpo-46841: 对 "BINARY_SUBSCR" 使用内联缓存。

* bpo-46841: 对 "COMPARE_OP" 使用内联缓存。

* bpo-46864: 弃用 "PyBytesObject.ob_shash"。它将在 Python 3.13 中被移
  除。

* bpo-46841: 对 "UNPACK_SEQUENCE" 使用内联缓存。

* bpo-46845: 当所有插入的键都是 Unicode 时，通过从哈希表中移除哈希值来
  减小字典大小。例如，在 64 位平台上，
  "sys.getsizeof(dict.fromkeys("abcdefg"))" 从 352 字节变为 272 字节。

* bpo-46841: 对 "LOAD_GLOBAL" 使用内联缓存。

* bpo-46852: 将私有的未文档化的 "float.__set_format__()" 方法重命名为
  "float.__setformat__()"，以修复 Python 3.7 中引入的拼写错误。该方法
  仅由 test_float 使用。由 Victor Stinner 提供补丁。

* bpo-46852: 移除未文档化的私有 "float.__set_format__()" 方法，该方法
  在 Python 3.7 中曾被称为 "float.__setformat__()"。其文档字符串说明：
  "您可能不想使用此函数。它主要存在于 Python 的测试套件中使用。" 由
  Victor Stinner 提供补丁。

* bpo-40116: 修复了当 other 是键共享字典时，dict.update(other) 可能不
  尊重 other 的迭代顺序的回归问题。

* bpo-46712: 在深度冻结模块中共享全局字符串标识符。

* bpo-46430: 修复深度冻结模块中内部字符串的内存泄漏问题。

* bpo-46841: 使用新的 "CACHE" 指令将 "BINARY_OP" 缓存内联存储。

* bpo-45107: 为具有字典的实例专门化 "LOAD_METHOD"。

* bpo-44337: 减少专门化的 "LOAD_ATTR" 和 "STORE_ATTR" 指令的内存使用。

* bpo-46729: 在 "BaseException.__str__()" 中添加子异常的数量。

* bpo-45885: 在收集专门化统计信息时不要取消适配 "COMPARE_OP"。

* bpo-46329: Fix specialization stats gathering for "PRECALL"
  instructions.

* bpo-46794: 将 libexpat 版本提升至 2.4.6。

* bpo-46823: 实现一个专门的组合操作码
  "LOAD_FAST__LOAD_ATTR_INSTANCE_VALUE"。由 Dennis Sweeney 提供补丁。

* bpo-46820: 修复在数字字面量后紧跟着（无空格）"not in" 关键字时的解析
  问题，例如 "1not in x"。现在解析器仅发出警告，而非语法错误。

* bpo-46329: 在调用序列中将 "KW_NAMES" 移动到 "PRECALL" 指令之前。更改
  "CALL" 的 "operand" 以匹配 "PRECALL"，便于专门化。

* bpo-46808: 从 compile.c 中移除 "NEXT_BLOCK" 宏，并使编译器在需要时自
  动生成隐式块。

* bpo-46329: 添加 "PUSH_NULL" 指令。这在评估可调用对象时用作前缀，以便
  堆栈对于方法和其他调用具有相同的形状。"PRECALL_FUNCTION" 和
  "PRECALL_METHOD" 被合并为单一的 "PRECALL" 指令。

  语义上没有变化。

* bpo-46762: 修复在调试版本中，当 '<'、'>' 或 '=' 是 f 字符串中缺失右
  大括号的最后一个字符时的断言失败。

* bpo-46730: 由于获取、设置或删除没有相应函数的属性而导致的
  AttributeError 消息现在会提到该属性实际上是一个属性，并且还指定了它
  所属的类的类型。

* bpo-46724: 确保所有向后跳转都使用 "JUMP_ABSOLUTE" 指令，而不是使用参
  数为 "(2**32)+offset" 的 "JUMP_FORWARD"。

* bpo-46732: 更正 "__bool__()" 方法的文档字符串。补丁由 Jelle Zijlstra
  提供。

* bpo-46072: 为 "BINARY_OP" 添加更详细的特化失败统计信息。

* bpo-46707: 避免在产生涉及大量括号的某些语法错误时可能出现的指数级回
  溯。由 Pablo Galindo 提供补丁。

* bpo-46323: "ctypes" 现在在调用 Python 回调函数时在栈上而非堆上分配内
  存以传递参数。由 Donghee Na 提供补丁。

* bpo-45923: 添加一种跳过快速检查的 "RESUME" 快速形式。

* bpo-46702: 为 "tuple" 和 "list" 解包特化 "UNPACK_SEQUENCE"。

* bpo-46072: 现在使用 "--enable-pystats" 收集操作码对统计信息。定义
  "DYNAMIC_EXECUTION_PROFILE" 或 "DXPAIRS" 不再有任何效果。

* bpo-46675: 允许拆分字典在合并前包含超过 16 个项目。现在限制为 254 个
  。

* bpo-40479: 在 "Modules/_hashopenssl.c" 中添加一个遗漏的 "va_end()"
  调用。

* bpo-46323: 调用 ctypes 回调函数时使用 "PyObject_Vectorcall()"。由
  Donghee Na 提供补丁。

* bpo-46615: 在 "setobject.c" 中内部迭代集合时，对集合中的结果项获取强
  引用。这防止了在各种集合操作的边角情况下集合被修改导致的崩溃。

* bpo-45828: 字节码编译器现在尝试在编译时应用运行时栈操作（只要这样做
  是可行的）。

* bpo-30496: 修复了 "PyLong_FromLong()" 实现中的一个小的可移植性问题，
  并为 "PyLong_FromLongLong()" 添加了单数字整数的快速路径。


库
--

* bpo-25707: 修复了 "xml.etree.ElementTree.iterparse()" 中当迭代器未被
  耗尽时的文件泄露问题。由 Jacob Walls 提供补丁。

* bpo-46877: 在 "unittest" 中导出 "unittest.doModuleCleanups()"。由
  Kumar Aditya 提供补丁。

* bpo-46848: 出于性能考虑，使用来自 "find()" 和 "rfind()" 的优化字符串
  搜索实现替代 "find()" 和 "rfind()"。

* bpo-46736: "SimpleHTTPRequestHandler" 现在使用 HTML5 语法。由
  Donghee Na 提供补丁。

* bpo-44886: 将 asyncio proactor 数据报传输继承自
  "asyncio.DatagramTransport"。

* bpo-46827: 在基于选择器的事件循环中支持
  "asyncio.loop.sock_connect()" 的 UDP 套接字。由 Thomas Grainger 提供
  补丁。

* bpo-46811: 使测试套件支持 Expat >=2.4.5。

* bpo-46252: 如果 "ssl.SSLSocket" 被传递给基于传输的 API，则抛出
  "TypeError"。

* bpo-46784: 修复了在嵌入式 Python 中与用户动态加载或静态链接的
  libexpat 库的符号冲突。

* bpo-46786: xml.etree.ElementTree 中的 HTML 序列化现在将 "embed"、
  "source"、"track" 和 "wbr" 写为空标签，符合 HTML5 的定义。

* bpo-39327: "shutil.rmtree()" 现在可以在客户操作系统中运行时与
  VirtualBox 共享文件夹一起工作。

* bpo-45390: 将 "asyncio.CancelledError" 消息从内部任务传播到外部等待
  者。

* bpo-46756: 修复了
  "urllib.request.HTTPPasswordMgr.find_user_password()" 和
  "urllib.request.HTTPPasswordMgrWithPriorAuth.is_authenticated()" 中
  的一个漏洞，该漏洞允许绕过授权。例如，如果用户被授权访问 URI
  "example.org/foo"，则允许访问 URI "example.org/foobar"。

* bpo-46737: "random.gauss()" 和 "random.normalvariate()" 现在有默认参
  数。

* bpo-46752: 向 asyncio 添加任务组（结构化并发，灵感来自 Trio 的
  nurseries）。这也引入了任务取消的变化，其中被取消的任务在调用
  .uncancel() 之前不能被再次取消。

* bpo-46724: 修复 "dis" 在负跳转偏移上的行为。

* bpo-46333: 当设置 "module" 参数时，"typing.ForwardRef" 的
  "__repr__()" 方法现在会包含 "typing.ForwardRef" 的 "module" 参数。

* bpo-46643: 在 "typing.get_type_hints()" 中，支持评估字符串化的
  "ParamSpecArgs" 和 "ParamSpecKwargs" 注解。由 Gregory Beauregard 提
  供补丁。

* bpo-45863: 当 "tarfile" 模块创建 pax 格式的存档时，它会在 ustar 头中
  放置时间戳的整数表示（如果可能的话），以便于旧的解档工具使用，此外还
  会在 pax 扩展头中放置现有的全精度时间戳。

* bpo-46066: 弃用基于 kwargs 的 "typing.TypedDict" 定义语法。在指定完
  全性时它有着令人困惑的语义，并且很大程度上未被使用。由 Jingchen Ye
  提供补丁。

* bpo-46676: 使 "typing.ParamSpec" 的 args 和 kwargs 等于它们自己。由
  Gregory Beauregard 提供补丁。

* bpo-46323: "ctypes.CFUNCTYPE()" 和 "ctypes.WINFUNCTYPE()" 现在会在其
  "_argtypes_" 成员包含太多参数时创建类型失败。以前，错误仅在调用函数
  时引发。由 Victor Stinner 提供补丁。

* bpo-46672: 修复 "asyncio.gather()" 中初始类型检查失败时的
  "NameError"。

* bpo-46659: 如果未指定区域设置，"calendar.LocaleTextCalendar" 和
  "calendar.LocaleHTMLCalendar" 类现在会使用 "locale.getlocale()"，而
  不是使用 "locale.getdefaultlocale()"。由 Victor Stinner 提供补丁。

* bpo-46659: "locale.getdefaultlocale()" 函数已被弃用，并将在 Python
  3.13 中移除。请使用 "locale.setlocale()"、
  "locale.getpreferredencoding(False)" 和 "locale.getlocale()" 函数代
  替。由 Victor Stinner 提供补丁。

* bpo-46655: 在 "typing.get_type_hints()" 中，支持评估裸字符串化的
  "TypeAlias" 注解。由 Gregory Beauregard 提供补丁。

* bpo-45948: 修复了 "xml.etree.ElementTree" 模块 C 实现中的一个不一致
  之处。现在，实例化 "xml.etree.ElementTree.XMLParser" 时使用
  "target=None" 关键字参数会像 Python 实现一样提供一个默认的
  "xml.etree.ElementTree.TreeBuilder" 目标。

* bpo-46626: 在 "socket" 中公开了 Linux 的 "IP_BIND_ADDRESS_NO_PORT"
  选项。

* bpo-46521: 修复了 "codeop" 模块中的一个 bug，该 bug 错误地将涉及字符
  串引号的无效代码识别为有效代码。

* bpo-46571: 改进了 "typing.no_type_check()"。

  现在它不会修改外部的类和函数。我们还正确地标记了类方法为不被类型检查
  。

* bpo-46400: expat: 将 libexpat 从 2.4.1 更新至 2.4.4

* bpo-46556: 弃用将 "pathlib.Path" 对象用作上下文管理器的未文档化支持
  。

* bpo-46534: 实现了 **PEP 673** "typing.Self"。由 James Hilton-Balfe
  提供补丁。

* bpo-46522: 使多个模块的 "__getattr__" AttributeErrors 更接近典型的
  AttributeError

* bpo-46475: 添加了 "typing.Never" 和 "typing.assert_never()"。由
  Jelle Zijlstra 提供补丁。

* bpo-46333: "typing.ForwardRef" 的 "__eq__()" 和 "__hash__()" 方法现
  在尊重 "typing.ForwardRef" 的 "module" 参数。现在可以区分来自不同模
  块的前向引用。

* bpo-46246: 为 "importlib.metadata.DeprecatedList" 添加了缺失的
  "__slots__"。由 Arie Bovenberg 提供补丁。

* bpo-46232: "ssl" 模块现在能正确处理 DN 中包含位字符串的证书。

* bpo-46195: "typing.get_type_hints()" 不再为默认值为 "None" 的参数添
  加 "Optional"。这与 PEP 484 在
  https://github.com/python/peps/pull/689 中的更改一致。

* bpo-31369: 将 "RegexFlag" 添加到 "re.__all__" 并进行了文档化。添加
  "NOFLAG" 以表示没有设置任何标志。

* bpo-45898: "ctypes" 不再在 "cfield.c" 中定义 "ffi_type_*" 符号。这些
  符号由 libffi 提供已有十余年。

* bpo-44953: 调用 "operator.itemgetter" 对象和 "operator.attrgetter"
  对象现在更快，因为使用了 vectorcall 调用约定。

* bpo-44289: 修复了 "is_tarfile()" 方法在使用 *fileobj* 参数时的一个问
  题：*fileobj* 中的位置被向前推进，使得它无法通过
  "tarfile.TarFile.open()" 读取。

* bpo-44011: 在 asyncio 中重新实现 SSL/TLS 支持，借用 uvloop 库的实现
  。

* bpo-41086: 如果 "interpolation" 参数不是
  "configparser.Interpolation" 类型，"configparser.ConfigParser" 构造
  函数将引发 "TypeError"。

* bpo-29418: 实现 "inspect.ismethodwrapper()" 并修复
  "inspect.isroutine()" 对于给定 methodwrapper 的情况。由 Hakan Çelik
  提供补丁。

* bpo-14156: argparse.FileType 现在支持二进制模式下的 '-' 参数，根据情
  况返回 sys.stdin/sys.stdout 的 .buffer 属性。当参数为 '-' 时，包含
  'x' 和 'a' 的模式被视为等同于 'w'。补丁由 Josh Rosenberg 贡献


文档
----

* bpo-42238: "Doc/tools/rstlint.py" 已移至其自己的仓库，现在在 PyPI 上
  打包为 "sphinx-lint"。


测试
----

* bpo-46913: 如果 Python 是用未定义行为消毒剂 (UBSAN) 构建的，修复
  test_faulthandler.test_sigfpe()：在 faulthandler_sigfpe() 函数上禁用
  UBSAN。由 Victor Stinner 提供补丁。

* bpo-46760: 从 test.test_dis 模块中的期望值中移除字节码偏移。减少修改
  虚拟机或编译器的障碍。

* bpo-46708: 防止 "test_asyncio" 执行后默认 asyncio 事件循环策略修改警
  告。

* bpo-46678: "Lib/test/support/import_helper.py" 中的函数
  "make_legacy_pyc" 不再在 "PYTHONPYCACHEPREFIX" 设置为与存储临时文件
  不同的设备上的目录时失败。

* bpo-46623: 在s390x上跳过test_zlib的test_pair()和test_speech128()测试
  ，因为如果zlib使用s390x硬件加速器，这些测试会失败。由Victor Stinner
  提供补丁。


构建
----

* bpo-46860: 在大小写不敏感的文件系统上构建时，尊重 "--with-suffix" 选
  项。

* bpo-46656: 现在构建Python需要一个C11编译器。不需要可选C11功能。补丁
  由Victor Stinner提供。

* bpo-46656: Building Python now requires support for floating point
  Not-a-Number (NaN): remove the "Py_NO_NAN" macro. Patch by Victor
  Stinner.

* bpo-46640: 现在构建Python需要一个提供 "NAN" 常量的C99 "<math.h>" 头
  文件，或者``__builtin_nan()``内置函数。由Victor Stinner提供补丁。

* bpo-46608: 如果深度冻结，排除已封装的冻结数据以节省300 KB磁盘空间。
  这包括向 "_frozen" 添加一个新的 "is_package" 字段。由Kumar Aditya提
  供补丁。

* bpo-40280: Fix wasm32-emscripten test failures and platform issues.
  - Disable syscalls that are not supported or don't work, e.g.
  wait, getrusage, prlimit, mkfifo, mknod, setres[gu]id, setgroups. -
  Use fd_count to cound open fds. - Add more checks for subprocess and
  fork. - Add workarounds for missing _multiprocessing and failing
  socket.accept(). - Enable bzip2. - Disable large file support. -
  Disable signal.alarm.

* bpo-46430: 在深度冻结的模块中内部化字符串。由Kumar Aditya提供补丁。


Windows
-------

* bpo-46744: ARM64的默认所有用户安装目录现在位于原生的 "Program Files"
  文件夹下，而不是用于ARM（32位）文件的 "Program Files (Arm)"。

* bpo-46567: 为Windows ARM64添加Tcl和Tk支持。这也将IDLE添加到安装中。

* bpo-46638: 确保注册表虚拟化一致禁用。对于3.10及更早版本，它保持启用
  （某些注册表写入受到保护），而对于3.11及更高版本，它被禁用（注册表修
  改影响所有应用程序）。


IDLE
----

* bpo-46630: 使 Windows 上的查询对话框开始时光标在输入框中。

* bpo-45447: 将 IDLE 语法高亮应用到 ".pyi" 文件。由 Alex Waygood 和
  Terry Jan Reedy 提供补丁。


C API
-----

* bpo-46748: Python's public headers no longer import "<stdbool.h>",
  leaving code that embedd/extends Python free to define "bool",
  "true" and "false".

* bpo-46836: 将 "PyFrameObject" 类型定义（"struct _frame"）移动到内部
  C API "pycore_frame.h" 头文件中。由 Victor Stinner 提供补丁。

* bpo-45459: Rename "Include/buffer.h" header file to
  "Include/pybuffer.h" to avoid conflits with projects having an
  existing "buffer.h" header file. Patch by Victor Stinner.

* bpo-45412: 移除 "HAVE_PY_SET_53BIT_PRECISION" 宏（已移至内部 C API）
  。由 Victor Stinner 提供补丁。

* bpo-46613: Added function "PyType_GetModuleByDef()", which allows
  accesss to module state when a method's defining class is not
  available.


Python 3.11.0 第 5 个 alpha 版本
================================

*发布日期：2022-02-03*


核心与内置函数
--------------

* bpo-45773: 从字节码编译器中移除两个无效的 "peephole" 优化。

* bpo-46564: 创建 "super" 对象时不创建帧对象。由 Kumar Aditya 提供补丁
  。

* bpo-45885: 关于 "COMPARE_OP" 字节码，添加了更细粒度的特化失败统计。

* bpo-44977: "int()" 委托给 "__trunc__()" 的做法现在已被弃用。当
  "type(a)" 实现了 "__trunc__()" 但没有实现 "__int__()" 或
  "__index__()" 时，调用 "int(a)" 现在会引发 "DeprecationWarning"。

* bpo-46458: 重新排序编译器为 "try"-"except" 块生成的代码，使得 "else"
  块的代码紧随 "try" 体之后（无需跳转）。这对快乐路径更优。

* bpo-46527: 再次允许将 "iterable" 作为关键字参数传递给 "enumerate()"
  。由 Jelle Zijlstra 提供补丁。

* bpo-46528: 用新的 "COPY" 和 "SWAP" 指令替换多个堆栈操作指令（
  "DUP_TOP"、"DUP_TOP_TWO"、"ROT_TWO"、"ROT_THREE"、"ROT_FOUR" 和
  "ROT_N"）。

* bpo-46329: 使用两个或三个字节码来实现大多数调用。

  没有命名参数的调用作为两个指令的序列实现："PRECALL; CALL"。有命名参
  数的调用作为三个指令的序列实现："PRECALL; KW_NAMES; CALL"。有两种不
  同的 "PRECALL" 指令："PRECALL_FUNTION" 和 "PRECALL_METHOD"。后者与
  "LOAD_METHOD" 配对使用。

  这种将调用分为预调用和调用的分区允许更好的专门化，从而最终获得更好的
  性能。

  语义上没有变化。

* bpo-46503: 修复在解析 f-strings 中一些无效的 N 转义序列时的断言。

* bpo-46431: 改进对无效调用 "BaseExceptionGroup.__new__()" 时的错误消
  息。

* bpo-46476: 修复由 deepfreeze 生成的代码对象中的内存泄漏。由 Kumar
  Aditya 提供补丁。

* bpo-46481: 通过使用 **PEP 590** "vectorcall" 调用约定加速对
  "weakref.ref.__call__()" 的调用。由 Donghee Na 提供补丁。

* bpo-46417: 修复设置类型 "__bases__" 属性时的竞争条件：内部函数
  "add_subclass()" 现在在调用 "PyWeakref_NewRef()" 后获取
  "PyTypeObject.tp_subclasses" 成员，这可以触发垃圾回收，间接修改
  "PyTypeObject.tp_subclasses"。由 Victor Stinner 提供补丁。

* bpo-46417: "python -X showrefcount" 现在在清除并销毁主 Python 解释器
  后显示总引用计数。之前是在之前显示的。由 Victor Stinner 提供补丁。

* bpo-43683: 添加 ASYNC_GEN_WRAP 操作码来包装异步生成器中要产生的值。
  移除了在 "YIELD_VALUE" 指令中特殊处理异步生成器的需要。

* bpo-46407: 优化 "Objects/longobject.c" 中的一些模运算。补丁由
  Jeremiah Vivian 提供。

* bpo-46409: 添加新的 "RETURN_GENERATOR" 字节码以生成器。简化了在虚拟
  机中调用Python函数的过程，因为它们不再需要特别处理生成器函数。

  同时添加 "JUMP_NO_INTERRUPT" 字节码，其行为类似于 "JUMP_ABSOLUTE"，
  但不检查中断。

* bpo-46406: 整数除法 "//" 的实现已优化，以便编译器更好地理解其约束。
  在amd64平台上，当除以小于 "2**30" 的值时，速度可以提高20%。

* bpo-46383: 修复 "_zoneinfo" 的 "module_free" 函数的无效签名，以解决
  wasm32-emscripten平台上的崩溃问题。

* bpo-46361: 确保通过 "int.from_bytes()" 和 "decimal.Decimal" 创建的“
  小”整数被正确缓存。

* bpo-46161: 修复当参数为常量且使用 CALL_FUNCTION_EX 时的类构建错误。

* bpo-46028: 修复在虚拟环境中使用与基础环境提供的不同二进制名称的符号
